{

  Diese Unit enthlt Routinen, die sich rund um den Cursor drehen:

  HideCursor : der Cursor wird unsichtbar gemacht.
  ShowCursor : der zuletzt sichtbare Cursor wird wieder benutzt.
  BlockCursor: ein Blockcursor wird nun benutzt.(meistens bei einem
               berschreibenden Einfgen)
  LineCursor : Der Standardcursor wird gezeigt.
  GetCursor : Der aktuelle Cursor wird ermittelt und intern abgespeichert,
              um ihn mit
  SetCursor : wieder zu benutzen.
  SetX(X:Byte) : Der Cursor wird zur angegebenen x-Koordinate bewegt. Die
                 Zeile bleibt gleich.
  SetY(Y:Byte) : Der Cursor wird zur angegebenen Zeile bewegt, wobei nun
                 die Spalte beibehalten wird.




}
Unit Cursors;

Interface

Uses Dos,Crt;

procedure ShowCursor;
procedure HideCursor;
procedure SetX(X:Byte);
Procedure SetY(Y:Byte);
procedure BlockCursor;
procedure LineCursor;
procedure GetCursor;
procedure SetCursor;


implementation

Var  Regs:Registers;
     CurAnf,CurEnd,                 {Bei einer Vernderung des Cursors wird
                                     hier der aktuelle abgespeichert.}
     TempCurAnf,TempCurEnd:Byte;    {Hier wird der Cursor fr die Prozeduren
                                     GetCursor und SetCursor abgespeichert.}


procedure SaveCursor;
{aktuellen Cursor sichern.}
begin
 Regs.ah:=$0F;
 Intr($10,Regs);
 Regs.ah:=$03;
 Intr($10,Regs);
 CurAnf:=Regs.ch;
 CurEnd:=Regs.cl;
end;

procedure Man(x,y:Byte);
{Hilfsroutine frs Verndern, da sich LineCursor,BlockCursor bzw. kein
 Cursor nur durch die entsprechenden x,y Werte unterscheiden.}
begin
 Regs.ah:=$01;
 Regs.ch:=x;
 Regs.cl:=y;
 Intr($10,Regs);
 SaveCursor;
end;

procedure HideCursor;
{Der Cursor wird unsichtbar gemacht.}
begin
 SaveCursor;
 Regs.ah:=$01;
 Regs.ch:=$20;
 Regs.cl:=$00;
 Intr($10,Regs);
end;

procedure ShowCursor;
{Der Cursor wird wieder sichtbar gemacht.}
begin
 Man(CurAnf,CurEnd);
end;

procedure SetX(X:Byte);
{Der Cursor wird zur angegebenen x-Koordinate bewegt.
 Die Zeile bleibt gleich.}
begin
 GotoXY(X,WhereY);
end;

procedure SetY(Y:Byte);
{Der Cursor wird zur angegebenen Zeile bewegt, wobei nun
 die Spalte beibehalten wird.}
begin
 GotoXY(WhereX,Y);
end;

procedure BlockCursor;
{Lt einen Blockcursor erscheinen.}
begin
 Man($00,$07);
end;

procedure LineCursor;
{Der nromale Zeilencursor}
Var x,y:Byte;
begin
 Man($0D,$0E);
end;

procedure GetCursor;
{Der aktuelle Cursor wird ermittelt und intern abgespeichert.}
begin
 Regs.ah:=$0F;
 Intr($10,Regs);
 Regs.ah:=$03;
 Intr($10,Regs);
 TempCurAnf:=Regs.ch;
 TempCurEnd:=Regs.cl;
end;

procedure SetCursor;
{Der zuletzt mit GetCursor gespeicherte erscheint wieder.}
begin
 Man(TempCurAnf,TempCurEnd);
end;

begin
 GetCursor;                {erstmal Cursor sichern.}
end.