{
  Diese Unit enthlt Funktionen, die fr den speziellen Umgang mit Datei-
  namen geeignet sind:

  1. function MaxDatLen(Text:String;Max:Integer):String;

     Der Dateiname kann bei Vorschaltung des Pfades ziemlich lang werden.
     Hufig reicht jedoch nicht der Platz an der Stelle, an der der Pfad
     und Dateiname ausgegeben werden soll.
     In der Variablen Text soll der Dateinamen inkl. des Pfades
     bergeben werden. Die Angabe Max gibt nun die auszugebenden maximalen
     Stellen an. Zurckgegeben wird ein geeigneter String, der immerhin
     noch geeignete Informationen bzgl. des Pfades und des Dateinamens
     enthlt und dennoch nicht lnger als Max Zeichen lang ist.


  2. function GetDateiName(Pattern,Titel:String):String;

     Nichts ist fr den Anwender lstiger als den Dateinamen einzutippen.
     Wenn sich die Datei sich dann noch in einem anderen Verzeichnis
     befindet, wird es ziemlich mhselig.
     Zunchst werden alle Dateien, die einem Suchmuster entsprechen,
     des aktuellen Pfades sowie alle Unterverzeichnisse angezeigt.
     Diese Funktion ermittelt nun einen Dateinamen (inkl. Pfadangabe) und
     gibt diesen zurck. Der Anwender kann den Namen und/oder die
     Verzeichnisse eingeben oder in einer Liste schon vorhandene
     Namen/Verzeichnisse auswhlen. In Pattern ist das vorgegebene Suchmuster
     anzugeben, z.B. nur Dateien der Endung txt (*.txt). Da sich diese
     Routine in einem neuen Fenster aufbaut, ist die Angabe einer
     berschrift (z.B. Speichern unter) in die Variable Titel zu bergeben.



}
Unit Dirs;

Interface

function MaxDatLen(Text:String;Max:Integer):String;
function GetDateiName(Pattern,Titel:String):String;

Implementation
Uses Toolbox,Consts,Dos,Screens,Cursors,Crt ;

Type Modus = (EN,EV,CN,CV);   {EN: Editiere Dateiname
                               EV: Editiere Verzeichnis
                               CN: Whle Dateinamen aus Liste
                               CV: Whle Verzeichnis aus Liste}
     DName=String[12];

     Marker = record
               x1,x2,y,m:Integer;
              end;
      {Die berschriftem zum Editieren/Whlen eines Namens oder
       Verzeichnisses ndern ihre Farbe, falls gerade editiert oder
       gewhlt wird. x1,x2,y sind gerade die Koordinaten, wo das
       entsprechende Wort steht,m enthlt die Angabe der Position
       des anders farbigen Markers fr die Alt-Tastenkombination.}

     PListe =^Liste;
     Liste = record               {einfache Liste von Dateiname bzw.}
              Name:DName;         {Verzeichnisnamen}
              Next,Prev:PListe;
             end;

     Selector = record
                 l:PListe;
                 x1,x2,y1,y2,y:Integer;
                end;



Var
 Suchweg:String;     {hier ist der aktuelle Dateipfad gespeichert, damit
                      bei einem Pfadwechsel dieser nicht immer durchgefhrt
                      werden mu.}
 MarkArray: array[Modus] of Marker;


function MaxDatLen(Text:String;Max:Integer):String;
{Der Dateiname kann bei Vorschaltung des Pfades ziemlich lang werden.
 Hufig reicht jedoch nicht der Platz an der Stelle, an der der Pfad
 und Dateiname ausgegeben werden soll.
 In der Variablen Text soll der Dateinamen inkl des Pfades
 bergeben werden. Die Angabe Max gibt nun die auszugebenden maximalen
 Stellen an. Zurckgegeben wird ein geeigneter String, der immerhin
 noch geiignete Informationen bzgl. des Pfades und des Dateinamens
 enthlt und dennoch nicht lnger als Max Zeichen lang ist.}
Var i,l:Integer;
    s:String;
begin
 if Pos(':\',Text)<>2 then
  MaxDatLen:=Copy(Text,1,Max)
 else
 begin
  if length(Text)>Max-1 then
  begin
   i:=Pos('\',Text);
   s:=Copy(Text,1,i)+'...\';
   Delete(Text,1,i);
   repeat
    while Text[1]<>'\' do Delete(Text,1,1);
    Delete(Text,1,1);
   until length(Text)+Length(s)<Max;
   Text:=s+Text;
  end;
  MaxDatLen:=Text;
 end;
end;

procedure Init(Var l:PListe);
{Liste initialisieren.}
begin
 l:=Nil;
end;

procedure Einf(Var l:PListe;Name:DName);
{Der Eintrag Name wird alphabetisch in die Liste l eingefgt.}
Var Hilf,s,last:PListe;
begin
 if l=Nil then
 begin
  New(Hilf);
  Hilf^.Name:=Name;
  Hilf^.Prev:=Nil;
  Hilf^.Next:=Nil;
  l:=hilf;
 end
 else
 begin
  s:=l;
  while (l<>nil) and (l^.Name<Name) do
  begin
   Last:=l;
   l:=l^.Next;
  end;
  if l= nil then
  begin
   New(Hilf);
   Hilf^.Name:=Name;
   Hilf^.Next:=Nil;
   Hilf^.Prev:=last;
   Last^.Next:=Hilf;
   l:=Hilf;
  end else
  begin
   New(Hilf);
   Hilf^.Name:=Name;
   Hilf^.Next:=l;
   Hilf^.Prev:=l^.Prev;
   if l^.Prev<>nil then l^.Prev^.Next:=Hilf
                   else s:=Hilf;
   l^.Prev:=Hilf;
  end;
  l:=s;
 end;
end;

procedure Entf(Var l:PListe);
{Liste lschen, Speicher wieder freigeben.}
begin
 if l<> nil then
 begin
  Entf(l^.Next);
  Dispose(l);
  l:=nil;
 end;
end;

procedure generate(Var Names,Verz:PListe;Path,Name:String);
{Im Verzeichnis Path werdem alle Unterverzeichnisse gesucht und
 alphabetisch in der Liste Verz abgelegt. Ferner alle im Verzeichnis
 Path befindlichen Dateinamen, die dem Suchmuster Name entsprechen.}

Var Result:SearchRec;
begin
 Entf(Names);
 Entf(Verz);
 if length(Path)>3 then Path:=Path+'\';
 FindFirst(Path+Name,AnyFile,Result);
 while DosError=0 do
 begin
  if Result.Attr<>Directory then Einf(Names,Result.Name);
  FindNext(Result);
 end;
 FindFirst(Path+'*',Directory,Result);
 while DosError=0 do
 begin
  if (Result.Attr=Directory) and(Result.Name<>'.') then Einf(Verz,Result.Name);
  FindNext(Result);
 end;
end;

procedure SchreibePath(Text:String;p:PBildschirm);
{Beim Auswhlen des Verzeichnisses aus der Liste mchte man nicht
 den berblick verlieren, daher wird dann an gewohnter Stelle der
 aktuelle Pfad angezeigt.
}
Var i:Integer;
begin
 Text:=MaxDatLen(Text,43);
 WriteXY(19,9,Text,P);
 for i:=19+length(Text) to 63 do p^[9,i].Zeichen:=' ';
end;

procedure SchreibeName(Text:String;p:PBildschirm);
{Schreibt an gewohnter Stelle den Dateinamen Text}
Var i:Integer;
begin
 if length(Text)>43 then
 begin
  Delete(Text,44,255);
  Text:=Text+'';
  WriteXY(19,6,Text,P);
 end
 else
 begin
  WriteXY(19,6,Text,P);
  for i:=19+length(Text) to 63 do p^[6,i].Zeichen:=' ';
 end;
end;

procedure OnScreen(Name,Verz:PListe;P:PBildschirm);
{Die Listen Name und Verz werden an den erwarteten Stellen ausgegeben.}
Var i,j:Integer;
begin
 for j:= 12 to 20 do
 begin
  for i:=21 to 32 do p^[j,i].Zeichen:=' ';
  for i:=45 to 52 do p^[j,i].Zeichen:=' ';
 end;
 i:=12;
 while (Name<>nil) and (i<21) do
 begin
  WriteXY(21,i,Name^.Name,p);
  Name:=Name^.Next;
  i:=i+1;
 end;
 i:=12;
 while (Verz<>nil) and (i<21) do
 begin
  WriteXY(45,i,Verz^.Name,p);
  Verz:=Verz^.Next;
  i:=i+1;
 end;
end;

procedure DeMark(m:Marker;p:PBildschirm);
{Die Markierung fr den Marker m werden aufgehoben.}
Var i:Integer;
begin
 for i:=m.x1 to m.x2 do p^[m.y,i].Attr:=$70;
 p^[m.y,m.m].Attr:=$74;
end;

procedure Mark(m:Marker;p:PBildschirm);
{Der Marker m wird markiert.}
Var i:Integer;
begin
 for i:=m.x1 to m.x2 do p^[m.y,i].Attr:=$7E;
 p^[m.y,m.m].Attr:=$74;
end;

function Choose(Var Sel:Selector;SchreibeDat:Boolean;Var Name:String;
                Ni,Ho:Menge;P:PBildschirm):Word;
{Ein Name/Verzeichnis soll durch whlen ermittelt werden.
 Im Selector Sel ist die zu whlende Liste enthalten. Soll der Dateiname
 gewhlt werden, soll schon beim Whlen der Name im entsprechenden Feld
 ausgegeben werden. Dies regelt der Booleantyp SchreibeDat. Der gewhlte
 Dateinamen wird in Name gespeichert, sofern gewhlt wurde.
 Ni,Ho sind Mengen von Tastaturcodes, bei denen das Whlen beendet werden
 soll, und zwar hochwertige (Ho) und niederwertiges (Ni) Byte des
 Tastaturcoides.
}
Var c:Word;
    Ende:Boolean;
    i:Integer;

  procedure DeMark;
  {Markierung aufheben}
  Var i:Integer;
  begin
   for i:=Sel.x1 to Sel.x2 do p^[Sel.y,i].Attr:=$17;
  end;

  procedure Mark;
  {markieren und ggf. rollen}
  Var i,j:Integer;
  begin
   if Sel.y<Sel.y1 then
   begin
    Sel.y:=Sel.y+1;
    for i:=Sel.y2 downto Sel.y1+1 do
     For j:=Sel.x1 to Sel.x2 do
      p^[i,j].Zeichen:=p^[i-1,j].Zeichen;
    for J:=Sel.x1 to Sel.x2 do
     p^[Sel.Y1,j].Zeichen:=' ';
    WriteXY(Sel.x1,Sel.y,Sel.l^.Name,P);
   end else
   begin
    if Sel.y>Sel.y2 then
    begin
     Sel.y:=Sel.y-1;
     for i:=Sel.y1 to Sel.y2-1 do
      For j:=Sel.x1 to Sel.x2 do
       p^[i,j].Zeichen:=p^[i+1,j].Zeichen;
     for J:=Sel.x1 to Sel.x2 do
      p^[Sel.y2,j].Zeichen:=' ';
     WriteXY(Sel.x1,Sel.y,Sel.l^.Name,P);
    end;
   end;
   for i:=Sel.x1 to Sel.x2 do p^[Sel.y,i].Attr:=$1E;
   GotoXY(Sel.x1,Sel.y);
   if SchreibeDat then
   begin
    WriteXY(19,6,Sel.l^.Name,P);
    for i:=19+length(Sel.l^.Name) to 62 do p^[6,i].Zeichen:=' ';
   end;
  end;

begin
 Ende:=False;


 HideCursor;

 Gotoxy(Sel.x1,Sel.y);
 if Sel.l= nil then  {gibt nix zu whlen}
 begin
  repeat
   Getkey(c);
   if ((c<=255)  and (c in Ni) and (c<>13)) or
      ((c>255) and (Hi(c) in Ho)) then
    begin
     Ende:=True;
     Choose:=c;
    end;
  until Ende;
 end else
 begin
  Mark;
  repeat
   Getkey(c);
   if ((c<=255)  and (c in Ni)) or
      ((c>255) and (Hi(c) in Ho)) then
    begin
     Ende:=True;
     Choose:=c;
     Name:=Sel.l^.Name;
    end else
    begin
     Case c of
      kbUp   : begin
                if Sel.l^.Prev<>NIL then
                begin
                 DeMark;
                 Sel.l:=Sel.l^.Prev;
                 Sel.y:=Sel.y-1;
                 Mark;
                end;
               end;
      kbDown : begin
                if Sel.l^.Next<>NIL then
                begin
                 DeMark;
                 Sel.l:=Sel.l^.Next;
                 Sel.y:=Sel.y+1;
                 Mark;
                end;
               end;
     end;
    end;
  until Ende;
  DeMark;
 end;
end;

function Join(Path1,Path2:String):String;
{2 Pfade werden 'addiert' und zu einem zusammengefat.}
Var i:Integer;
begin
 Path1:=Up(Path1);Path2:=Up(Path2);
 if (Path2[1]<>'\') and (Path2[2]<>':') then
 begin
  if  length(Path1)>3 then Path1:=Path1+'\'+Path2
                      else Path1:=Path1+Path2;
 end else
  if Path2[2]=':' then
  begin

   if (length(Path2)<>2) or (Path1[1]<>Path2[1]) then
    if Path2[3]='\' then Path1:=Path2
                    else Path1:=Path2;
  end else
  begin
   if Path2[1]='\' then Path1:=Path1[1]+':'+Path2
                   else Path1:=Path1+Path2;
  end;
  Path1:=FExpand(Path1);
  i:=Pos('\\',Path1);
  while i<>0 do
  begin
   Delete(Path1,i,1);
   i:=Pos('\\',Path1);
  end;
  if (length(Path1)>3) and (Path1[length(Path1)]='\') then
   Delete(Path1,length(Path1),1);
 Join:=Path1;
end;

function Add(Path,Name:String):String;
{Hier wird nun aus dem Pfad und dem Dateinamen, der ja auch Angeben
 zum Pfad enthalten kann, ein Name mit beiden Angaben erzeugt.}
Var tmp,Hilf:String;
    D:DirStr;
    N:NameStr;
    E:ExtStr;
begin
 tmp:=Name;
 if Pos('\',tmp)<>0 then
 begin
  while tmp[length(tmp)]<>'\' do
  begin
   Delete(tmp,length(tmp),1);
  end;
  Delete(Name,1,length(tmp));
  if length(tmp)>3 then Delete(tmp,length(tmp),1);
  Path:=Join(Path,tmp);
 end else
 begin
  if Pos(':',tmp)<>0 then
  begin
   while tmp[length(tmp)]<>':' do Delete(tmp,length(tmp),1);
   Delete(Name,1,2);
   Path:=Join(Path,tmp);
  end;
 end;
 if CheckPath(Path) then if length(Path)>3 then Add:=Fexpand(Path+'\'+Name)
                                           else Add:=Fexpand(Path+Name)
                    else Add:='';
end;

procedure Pfadfehler;
begin
 MsgBox($70,'Fehler','Ungltiges Laufwerk oder Verzeichnis');
 {entweder $4E oder $70 oder $17}
end;



procedure Konvert(Suchweg:String;Var Path,Name:String);
{Diese Prozedure extrahiert aus einem String, der Pfad und Dateiname in
 einem enthlt diese beiden.}
Var Modus :Integer;
begin
 Name:='';
 while (Suchweg[length(Suchweg)]<>'\') and (Suchweg[length(Suchweg)]<>':')  do
 begin
  Name:=Suchweg[Length(Suchweg)]+Name;
  Delete(Suchweg,Length(Suchweg),1);
 end;
 if length(Suchweg)>3 then Delete(Suchweg,Length(Suchweg),1);
 Path:=Suchweg;
end;

function GetDateiName(Pattern,Titel:String):String;
{Nichts ist fr den Anwender lstiger als den Dateinamen einzutippen.
 Wenn sich die Datei sich dann noch in einem anderen Verzeichnis
 befindet, wird es ziemlich mhselig.
 Diese Funktion ermittelt nun einen Dateinamen (inkl. Pfadangabe) und
 gibt diesen zurck. In Pattern ist ein vorgebenes Suchmuster anzugeben,
 z.B. nur Dateien der Endung txt (*.txt). Da sich diese Routine in einem
 neuen Fenster aufbaut, ist die Angabe einer berschrift (z.B. Speichern
 unter) in die Variable Titel zu bergeben.}
Var Namen,Verz:PListe;
    p:PBildschirm;
    Screen:Bildschirm;
    i,j,w1,w2,ede:Integer;
    Dummy,ok,Ende:Boolean;
    ExCd,Strt:Word;
    S,ALterWeg,Name,Dir,Dat:String;
    Marked:Modus;
    Selected:Array[CN..CV]of Selector;

  procedure NowMark(M:Modus);
  {Alten Marker demarkieren, neuen markieren.}
  begin
   DeMark(MarkArray[Marked],P);
   Marked:=M;
   Mark(MarkArray[Marked],P);
  end;

  procedure GeneralCheck(ExitCode:Word);
  {Nach erfolgreicher Aktion mu nun gecheckt werden, ob vielleicht
   etwas anderers markiert werden mu.}
  begin
   Case ExitCode of
    kbAltN : NowMark(EN);              {Dateinamen editieren}
    kbAltZ : NowMark(EV);              {Verzeichnis editieren}
    kbAltD : NowMark(CN);              {Dateinamen whlen}
    kbAltV : nowMark(CV);              {Verzeichnis whlen}
    kbTab  : begin                     {Nachfolger}
              if Marked<>CV then NowMark(Succ(Marked))
                            else NowMark(EN);
             end;
    kbShiftTab : begin                 {Vorgnger}
                  if Marked<>EN then NowMark(Pred(Marked))
                                else NowMark(CV);
                 end;
    27     : Ende:=true;
   end;
  end;

  procedure Namenfehler;
  {Falsche Zeichen im Pfad/Namen}
  begin
   Ok:=False;
   Ende:=False;
   MsgBox($70,'Fehler','Ungltiger Dateiname oder Erweiterung');
  end;

begin
 p:=localScreen;
 Name:=Pattern;
 Freeze(Screen);
 Marked:=EN;
 {generieren des Fensters:}
 MakeBox(15,65,3,22,$70,doppelt,Titel,p);
 WriteXYColor(18,5,$7E,'Dateiname :',p);
 p^[5,23].Attr:=$74;

 for i:=18 to 62 do p^[6,i].Attr:=$17;
 WriteXY(18,8,'Verzeichnis :',p);
 p^[8,21].Attr:=$74;
 for i:=18 to 62 do p^[9,i].Attr:=$17;
 WriteXY(20,11,'Dateinamen',p);p^[11,20].Attr:=$74;
 WriteXY(44,11,'Verzeichnisse',p);p^[11,44].Attr:=$74;
 SchreibePath(Suchweg,p);
 SchreibeName(Name,p);
 for j:= 12 to 20 do
 begin
  for i:=20 to 35 do p^[j,i].Attr:=$17;
  for i:=44 to 59 do p^[j,i].Attr:=$17;
 end;
 gotoXY(19,7);
 {generieren der Variablen:}
 Dummy:=true;
 w1:=1;
 w2:=1;
 Init(Namen);
 Init(Verz);
 Generate(Namen,Verz,Suchweg,Pattern);
 Selected[CN].l:=Namen;
 Selected[CN].y:=12;
 Selected[CN].x1:=21;
 Selected[CN].x2:=32;
 Selected[CN].y1:=12;
 Selected[CN].y2:=20;
 Selected[CV].l:=Verz;
 Selected[CV].y:=12;
 Selected[CV].x1:=45;
 Selected[CV].x2:=52;
 Selected[CV].y1:=12;
 Selected[CV].y2:=20;
 OnScreen(Namen,Verz,P);
 OK:=False;
 Ende:=False;
 AlterWeg:=Suchweg;
 Strt:=1;
 Ede:=0;
 {los geht's mit dem 'Men':}
 repeat
  Case Marked of
   EN : begin                  {Dateinamen editieren}
         s:=Name;
         ExCd:=EditLine(19,6,43,Strt,S,255,Dummy,True,[9,13,27],[15,44,32,47],p);
         Up(S);
         GeneralCheck(ExCd);
         if ExCd<>27 then Name:=s;
         if ExCd=13 then    {Nun mu gecheckt werden, ob Eingabe sinnvoll war
                             bzw. evtl. mu nun ins Wahlmen gegangen werden.}
         begin
          if Name='.' then     {Flle Namen mit Pattern}
          begin
           Name:=Pattern;
           SchreibeName(Name,P);
          end
          else
          begin
           if Name[1]='.' then      {Nur Endung eingegeben}
           begin
            Name:='*'+Name;
            Delete(Name,6,255);
            SchreibeName(Name,p);
           end;
          end;
          if (Pos('\',Name)<>0) or          {Pfadangabe mit im Namen, da mu}
             (Pos(':',Name)<>0) or          {jetzt gecheckt werden, ob}
             (Pos('..',Name)<>0) then       {Pfad existiert.}
          begin
           s:=Add(Suchweg,Name);
           if s<>'' then
           begin
            Konvert(s,Dir,Dat);     {Dir=verzeichnis, Dat=Dateinamen nach}
            if Dat='.' then         {'Addition' von Suchweg u. Namen}
             Dat:=Pattern
            else
             if Dat[1]='.' then
             begin
              Dat:='*'+Dat;
              Delete(Dat,6,255);
              SchreibeName(Name,p);
             end;
            if Not(CheckPath(Dir)) then
            begin
             Pfadfehler;
            end else
            begin
             if ((Pos('*',Dat)<>0) or (Pos('?',Dat)<>0) or (Dat='')) then
             begin
              if Dat='' then
              begin
               Dat:=Pattern;
              end;
              Suchweg:=Dir;
              SchreibePath(Suchweg,P);
              generate(Namen,Verz,Suchweg,Dat);
              Selected[CN].l:=Namen;
              Selected[CN].y:=12;
              Selected[CV].l:=Verz;
              Selected[CV].y:=12;
              OnScreen(Namen,Verz,P);
              NowMark(CN);
             end else
             begin
              Ok:=True;
              Ende:=True;
              Name:=Dat;
             end;
             Suchweg:=Dir;
            end;
           end
           else
            Pfadfehler;
          end
          else    {Nur Namen eingegeben}

           if (Pos('*',Name)<>0) or (Pos('?',Name)<>0) then
           begin
            SchreibePath(Suchweg,P);
            generate(Namen,Verz,Suchweg,Name);
            Selected[CN].l:=Namen;
            Selected[CN].y:=12;
            Selected[CV].l:=Verz;
            Selected[CV].y:=12;
            OnScreen(Namen,Verz,P);
            NowMark(CN);
           end
           else
           begin
            if Name='' then
             NowMark(CN)
            else
            begin
             if Add(Suchweg,Name)='' then
             begin
              Pfadfehler;
             end else
             begin
              Ende:=True;
              OK:=true;
             end;
            end;
           end;
         end
        end;
   EV : begin                    {Pfadnamen editieren}
         s:=Suchweg;
         ExCd:=EditLine(19,9,43,Strt,s,255,Dummy,True,[9,13,27],[15,49,32,47],p);
         LineCursor;
         Up(s);
         GeneralCheck(ExCd);
         if (ExCD<>27) and (ExCD<>13) then
         begin
          Suchweg:=AlterWeg;
          SchreibePath(Suchweg,P);
         end;
         if ExCd=13 then          {Checke, ob Eingabe sinnvoll:}
         begin
          Suchweg:=Join(Suchweg,S);
          if w2>length(Suchweg)+1 then
          begin
           w2:=length(Suchweg)+1;
           GotoXY(w2+18,9);
          end;
          if not(CheckPath(Suchweg)) then
          begin
           Pfadfehler;
           SchreibePath(Suchweg,p);  {'Auto-Korrektur' des Pfades}
           {Suchweg:=s;}             {Pfad wie eingegeben.}
          end else     {Neuer Pfad, also auch neue Namen- und}
          begin        {Unterverzeichnislister}
           Entf(Namen);
           Entf(Verz);
           AlterWeg:=Suchweg;
           if (Pos('*',Name)<>0) or (Pos('?',Name)<>0) then
            s:=Name
           else
            s:=Pattern;
           generate(Namen,Verz,Suchweg,s);
           Selected[CN].l:=Namen;
           Selected[CN].y:=12;
           Selected[CV].l:=Verz;
           Selected[CV].y:=12;
           OnScreen(Namen,Verz,P);
           SchreibePath(Suchweg,p);
           NowMark(CN);
          end;
         end
         else
        end;
   CN : begin    {Namen aus Liste whlen}
         exCd:=Choose(Selected[CN],true,Name,[13,27,9],[15,49,44,47],P);
         GeneralCheck(ExCd);
         if ExCd=13 then
         begin
          Name:=Selected[CN].l^.Name;
          Ok:=True;
          Ende:=True;
         end;
        end;
   CV : begin    {Verzeichnis aus Liste whlen}
         exCd:=Choose(Selected[CV],false,s,[13,27,9],[15,49,44,32],P);
         GeneralCheck(ExCd);
         if ExCd=13 then
         begin
          Suchweg:=Join(Suchweg,Selected[CV].l^.Name);
          AlterWeg:=Suchweg;
          Entf(Namen);
          Entf(Verz);
          if (Pos('*',Name)<>0) or (Pos('?',Name)<>0) then
           s:=Name
          else
           s:=Pattern;
          generate(Namen,Verz,Suchweg,s);
          Selected[CN].l:=Namen;
          Selected[CN].y:=12;
          Selected[CV].l:=Verz;
          Selected[CV].y:=12;
          OnScreen(Namen,Verz,P);
          SchreibePath(Suchweg,p);
         end
        end;
  end;
  if (Ok) and (Marked=EN) then
  begin
   Konvert(Add(Suchweg,Name),Dir,Dat);
   if Pos('.',Dat)<>0 then
   begin
    if Pos('.',Dat)>9 then
     Namenfehler
    else
    begin
     Delete(Dat,1,Pos('.',Dat));
     if Pos('.',Dat)<>0 then Namenfehler
                        else if length(Dat)>3 then Namenfehler;
    end;
   end
   else
    if Length(Dat)>8 then Namenfehler;
  end;
 until Ende;
 if Ok then GetDateiName:=Add(Suchweg,Name)
       else
       begin
        GetDateiName:='';
        Suchweg:=AlterWeg;
       end;
 entf(Namen);
 entf(Verz);
 Defreeze(Screen);
 HideCursor;
end;


begin
 {generieren der 'globalen' Variablen:}
 GetDir(0,Suchweg);
 MarkArray[EN].x1:=18;
 MarkArray[EN].x2:=28;
 MarkArray[EN].y:=5;
 MarkArray[EN].m:=23;
 MarkArray[EV].x1:=18;
 MarkArray[EV].x2:=30;
 MarkArray[EV].y:=8;
 MarkArray[EV].m:=21;
 MarkArray[CN].x1:=20;
 MarkArray[CN].x2:=29;
 MarkArray[CN].y:=11;
 MarkArray[CN].m:=20;
 MarkArray[CV].x1:=44;
 MarkArray[CV].x2:=56;
 MarkArray[CV].y:=11;
 MarkArray[CV].m:=44;
end.

