 {$X+}
 {$V-}
 {$M  60000}


 uses Crt,Menus,Screens,Dirs,Cursors,Consts,ToolBox;


 const
      max_schluessel = 50;    {maximal mgliche Schlsselanzahl}
      datensp_const  = 1000;  {eine groe datensp_const ermglicht eine
                               besonders schnelle Suche (im wesentlichen
                               binre Suche), bentigt dafr etwas mehr
                               Arbeitsspeicher}
      MaxLength=80;           {maximale Lnge eines Strings}


      {Konstanten frs Men:}
      cmNeu = 11;
      cmOeffnen = 12;
      cmSpeichern = 13;
      cmSpUnter = 14;
      cmDosShell = 15;
      cmBeenden = 16;

      cmEditieren = 21;
      cmSuchen    = 22;

      cmEinrichten = 31;
      cmNEdit = 32;
      cmNSort = 33;
      cmHinzufuegen = 34;
      cmLoeschen = 35;

      cmEditor = 41;

 type
     datenzeiger   = ^daten;

     dszeiger      = ^datenspeicher;

     dslzeiger     = ^dsltyp;
                                      {Zeiger auf die weiter unten}
     dzeiger       = ^datei;           {ausfhrlich beschriebenen}
                                            {Datenstrukturen}
     pzeiger       = ^posliste;

     npzeiger      = ^neuposliste;

     szeiger       = ^schliste;


     namentyp      = string[MaxLength];   {nimmt die Eintrge der Datei auf}

     datentyp      = array[1..max_schluessel] of namentyp;   {siehe dsltyp}

     prior_typ     = array[1..max_schluessel] of word;  {zum Speichern der
                                                         Sortier-Prioritten}

     dsltyp        = record
                      dsanz     : longint;  {Anzahl Datenstze (DS) in Datei}
                      szahl     : word;     {Anzahl (Sortier-) Sclssel}
                      sposition : array[1..max_schluessel] of dszeiger;
                                            {Jedem Schlssel ist ein Zeiger
                                             auf einen Datenspeicher zuge-
                                             ordnet, z.B. ein Datenspeicher
                                             fr Name, einer fr Vorname etc}
                      sname     : datentyp  {Name des Schlssels ("Adresse",
                                             "Alter" ...}
                     end;

     schliste      = record                 {Jeder DS hat einen Zeiger auf}
                      inhalt : datenzeiger; {eine Liste. In der Liste ist}
                      nach   : szeiger      {fr jeden Schlssel ein Zeiger}
                     end;                   {auf den zugehrigen Daten-
                                             eintrag}

     posliste      = record                {Jeder Dateneintrag (z.B. Name ->}
                      position : dzeiger;  {Hans) hat eine posliste, in der}
                      nach     : pzeiger   {Zeiger auf alle DS mit entspr.}
                     end;                  {Eintrag (Name -> Hans) sind}

     neuposliste   = record                {Hilfsliste, bentigt beim Ein-}
                      poslist : pzeiger;   {fgen neuer DS in die posliste}
                      nach    : npzeiger
                     end;

     daten     = record                    {Dateneintrag, enthlt :}
                      name     : namentyp; {den Einrag (Hans, Fritz, ..)}

                      anzahl   : word;     {Anzahl DS mit diesem Eintrag}
                      poslist  : pzeiger   {Zeiger auf poslist}
                     end;

     datenspeicher = record
                      daten      : array[1..datensp_const] of datenzeiger;
                      belegt     : word;
                      mehr,rueck : dszeiger
                     end;                  {In einem Datenspeicher sind bis
                     zu datensp_const (hier = 1000) viele daten eingetragen.
                     Mehrere Datensp. knnen zu einer doppelt verketteten
                     Liste zusammengefgt werden. Eine grosse datensp_const
                     bringt eine schnelle Suche, da in einem Datensp. binre
                     Suche mglich ist (damit auch schnelleres Einfgen etc)}

     datei         = record                {Die Datei ist als doppelt ver-}
                      vor,nach : dzeiger;  {kettete Liste realisiert. Jeder}
                      nr       : longint;  {DS enthlt seine Nummer (Pos. in}
                      daten    : szeiger   {der Datei) und einen Zeiger auf}
                     end;                  {eine schliste}

     OptionTyp = record
                  AutoRet,    {beim letzten Schlssel Return => einfgen}
                  AutoFirst,  {beim Blttern immer den ersten Schlssel }
                  AutoClear,  {beim Einfgen immer einen leeren DS editieren}
                  AutoAdv,    {beim Einfgen/ndern um eins weiter}
                  marked,     {ob markiert editiert wird}
                  double      {ob doppelt eingefgt wird}
                  : Boolean;
                 end;

 Var
         f:File of OptionTyp;
         Sub1,Sub2,Sub3,Sub4: PSMenu;
         M : PMenu;
         cm: Word;
         Bild : Bildschirm;
         p : PBildschirm;
         Kopf,Edit,Help: DZeiger;
         Dsl : DslZeiger;
         DateiName,SchreibeName,AltName,Message : String;
         Options : OptionTyp;
         change : Boolean;
         tmp:LongInt;
         Ch:Char;

procedure Init(Var Kopf:DZeiger; Var Dsl:DslZeiger;Anz:Word);
Var i:Word;
begin
 new(kopf);
 kopf^.vor:=nil;
 kopf^.nach:=nil;
 kopf^.daten:=nil;
 kopf^.nr:=0;
 New(Dsl);
 Dsl^.SZahl:=Anz;
 Dsl^.DSAnz:=0;
 For i:=1 to Anz Do
 begin
  new(dsl^.sposition[i]);
  dsl^.sposition[i]^.belegt:=0;
  dsl^.sposition[i]^.rueck:=nil;
  dsl^.sposition[i]^.mehr:=nil;
  Dsl^.SName[i]:='';
 end;
end;

 procedure binaere_suche(pos : dszeiger; var neu : namentyp; anf,ende : word;
                         var stelle : word);

  {in:  pos -> Zeiger auf Datenspeicher, in dem gesucht werden soll
        neu -> zu suchender Eintrag
        anf,ende -> fr den rekursiven Aufruf der bin. Suche, vorbelegt mit
                    1 und der Nummer des letzten Eintrags im Datenspeicher
        stelle -> vorbelegt mit Nummer des letzten Eintrags im Dsp.
   out: stelle -> Ergebnis der binren Suche}

  {Sucht in einem Datenspeicher.
   Genaueres zur Suche: siehe procedure suche}

  begin
   if anf < ende
    then begin
     stelle:=(anf + ende) div 2;
     if (pos^.daten[stelle]^.name >= neu)
      then binaere_suche(pos,neu,anf,stelle,stelle)
      else if stelle > anf
            then binaere_suche(pos,neu,stelle,ende,stelle)
            else stelle:=stelle+1
    end
  end;


 procedure suche(var pos : dszeiger; neu : namentyp;
                 var vorhanden : boolean; var stelle : word);

  {in:  pos -> Zeiger auf den ersten Datenspeicher des Schlssels, in
               dem gesucht werden soll
        neu -> Eintrag, nach dem gesucht werden soll
        vorhanden, stelle -> nicht vorbelegt
   out: pos -> Zeiger auf den Datenspeicher, in dem neu gefunden wurde
               bzw. der den neu 'am nchsten kommenden' (siehe unten)
               Eintrag enthlt
        vothanden, stelle -> siehe detaillierte Erluterung unten.}

  var anf,ende : word;

  {Durchsucht alle Datenspeicher beginnend mit dem ersten zu einem Schlssel
   nach dem gesuchten Eintrag 'neu'.
   Ist der (in diesem Fall einzige) Datenspeicher leer, so wird
      -> vorhanden=false            und als Stelle zum Einfgen
      -> stelle=1
   bergeben.
   Sonst wird zunchst der Datenspeicher ermittelt, in dem 'neu' enthalten
   sein knnte (d.h., in dem 'neu' vorhanden ist, falls ein entsprechender
   Eintrag in einem DS existiert). Dazu wird der Datenspeicher ermittelt,
   dessen erster Eintrag (lexikalisch) grsser als 'neu' ist (die Daten sind
   in den Datenspeichern stets sortiert eingetragen !). Dann wird mit binrer
   Suche der entsprechende Datenspeicher durchsucht und falls 'neu' gefunden
      -> vorhanden=true
      -> stelle=stelle im array des Datenspeichers, die den Zeiger auf den
                daten-record mit Eintrag 'neu' enthlt
   bergeben bzw. falls kein daten-record mit Eintrag 'neu' existiert,
      -> vorhanden=false
      -> stelle=stelle im array des Datenspeichers, die den Zeiger auf den
                ersten daten-record mit einem Eintrag, der (lexikalisch)
                grsser als 'neu' ist, enthlt.}

  begin
   if pos^.belegt = 0            {kein datensatz in datei}
    then begin
     vorhanden:=false;
     stelle:=1
    end
    else begin
     while (neu > pos^.daten[pos^.belegt]^.name)
      {'neu' > letzter (und damit grter) Eintrag in diesem Datenspeicher?}
       and (pos^.mehr <> nil)
      {weiterer Datenspeicher vorhanden}
      do pos:=pos^.mehr;
      {jetzt Datenspeicher, der "neu" enth. knnte, erreicht}
      anf:=1;
      ende:=pos^.belegt;
      stelle:=ende;
      binaere_suche(pos,neu,anf,ende,stelle);
      {innerhalb des Datenspeichers kann mit Aufwand O(ld(n)) (binre Suche),
       d.h. sehr schnell, gesucht werden}
      if pos^.daten[stelle]^.name = neu
       then vorhanden:=true
       else begin
        vorhanden:=false;
        if pos^.daten[stelle]^.name < neu
         then stelle:=stelle+1
       end
    end
  end;


 procedure loeschen(liste : npzeiger);

  {in: liste -> Zeiger auf zu lschende neuposlist}

  {Eine nicht mehr bentigte Liste (Hilfsliste beim Einfgen) wird gelscht}

  begin
   if liste^.nach <> nil
    then loeschen(liste^.nach);
   dispose(liste)
  end;

 procedure einf_stelle_suche(pos : dszeiger; var vorhanden,gefunden : boolean;
                             stelle : word; var kopf,dat : dzeiger; i : word;
                             var neu : datentyp; var merk : pzeiger;
                             var neuposlist : npzeiger);

  {in:  pos -> Zeiger auf den ersten Datenspeicher zu dem Schlssel, der
               durchsucht werden soll.
        vorhanden -> true, wenn bereits ein DS mit Eintrag neu im i-ten
                     Schlssel existiert
                     false, wenn kein solcher DS existiert
        gefunden -> vorbelegt mit false
        stelle -> von Prozedur suche gelieferte stelle bei Suche nach
                  neu im i-ten Schlssel, genaueres siehe dort
        kopf
        dat -> Zeiger auf den neuen Datensatz
        i -> Nummer des zu durchsuchenden Schlssels
        neu -> Eintrag des neuen DS zu diesem Schlssel
        merk -> mit nil vorbelegt
        neuposlist -> Beim ertsen Aufruf nicht vorbeleg, danach wie
                      unter 'out' beschrieben.
   out: gefunden -> true, falls endgltige Stelle zum Einfgen gefunden
        dat -> Zeiger auf neuen DS, enthlt aktuelle Annherung an die
               Einf.-Stelle (vor/nach) bzw. exakte Einf-Stelle falls
               gefunden.
        merk -> bergibt die Position fr den neuen DS in der posliste
                des Eintrags neu
        neuposlist -> enthlt die zum weiteren Suchen der Einf.-Stelle noch
                      relevanten Eintrge (detaillierte Beschreibung folgt
                      in der Funktion)}

  {Die Stelle, an der der neue Datensatz (DS) eingefgt werden mu (im
   Folgenden kurz Einf.Stelle), wird gesucht.  Eingefgt wird nach dem
   ersten Schlssel (lexikographisch) sortiert, bei gleichem ersten
   nach dem zweiten Schlssel etc.}

  var plist,nplist     : pzeiger;
      neuposlist2,npl3 : npzeiger;
      sliste           : szeiger;
      neu2             : string[80];
      j                : word;
      stop             : boolean;

  begin

   if i = 1              {berprfung des ersten Schlssels}
    then begin
     if vorhanden = true {Es ex. bereits ein DS in der Datei mit gleichem}
      then begin         {Eintrag im ersten Schlssel}
       {neuposlist wird angelegt, im Folgenden mssen nur noch die Eintrge,
        die in neuposlist stehen, durchsucht werden, z.B. in einer Fahrzeug-
        Kartei mit Eintrgen Marke, Typ, Bj. etc bei Einfgen eines weiteren
        'VW' nur noch alle DS mit Marke 'VW'}
       new(neuposlist);
       neuposlist^.poslist:=pos^.daten[stelle]^.poslist;
       neuposlist^.nach:=nil;
       dat^.vor:=pos^.daten[stelle]^.poslist^.position^.vor
      end
      else begin         {Es ex. noch kein DS mit diesem Eintrag im ersten
                          Schlssel, d.h.: die Einf.Stelle ist bereits durch
                          den Eintrag im 1. Schlssel eindeutig definiert}
       if pos^.belegt > stelle    {es ist ein grerer Eintrag im selben
                                   Datenspeicher (Dsp) vorhanden}
        then dat^.vor:=pos^.daten[stelle+1]^.poslist^.position^.vor
        {in der Datei wird vor den greren Eintrag eingefgt}
        else                      {Der Eintrag ist grsser als alle Eintrge
                                   in diesem Dsp}
         if pos^.mehr <> nil
          {es ex. ein weiterer, nachfolgender Dsp. In diesem mssen dann
           ausschlielich grssere Eintrge vorhanden sein, vgl. Proc. suche}
          then dat^.vor:=pos^.mehr^.daten[1]^.poslist^.position^.vor
          {der DS wird vor den nchst grsseren Eintrag eingefgt}
          else
           if stelle > 1
            then begin  {DS wird nach dem nchst kleineren eingefgt}
             plist:=pos^.daten[stelle-1]^.poslist;
             while plist^.nach <> nil
             do plist:=plist^.nach;
             dat^.vor:=plist^.position;
            end
           else begin   {DS ist der kleinste in der Datei und wird nach kopf
                         eingefgt}
            if pos^.rueck = nil
             then dat^.vor:=kopf
             else begin
              plist:=pos^.rueck^.daten[datensp_const]^.poslist;
              while plist^.nach <> nil
               do plist:=plist^.nach;
              dat^.vor:=plist^.position
             end
          end
      end
    end
    else

     if i = 2           {berprfung des zweiten Schlssels}
      then begin
       nplist:=neuposlist^.poslist;
       neu2:=nplist^.position^.daten^.nach^.inhalt^.name;
       stop:=false;
       repeat
        {Innerhalb der Liste (neuposlist), die alle DS mit gleichem Eintrag
         im 1. Schlssel enthlt, wird der 1. DS gesucht, der im 2. Schlssel
         einen greren (oder den gleichen) Eintrag wie der neu einzufgende
         DS hat. Abgebrochen wird ausserdem, wenn das Ende der neuposlist
         erreicht wurde.}
        if  (neu2 < neu[2]) and (nplist^.nach <> nil)
         then begin
          nplist:=nplist^.nach;
          neu2:=nplist^.position^.daten^.nach^.inhalt^.name
         end
         else stop:=true;
       until (neu2 >= neu[2]) or (stop);
                         {--3 Mglichkeiten--}
       if neu2 < neu[2]
       {1.) auch der letzte DS in der Liste hat im zweiten Schlssel einen
            kleineren Eintrag.
            => der neue DS wird hinten angehngt und gefunden wird auf true
               gesetzt (die Einf.Stelle ist gefunden}
        then begin
         gefunden:=true;
         dat^.vor:=nplist^.position;
         loeschen(neuposlist)  {lschen der Hilfsliste}
        end
        else if neu2 = neu[2]
        {2.) Es ist bereits ein DS vorhanden, in dem 1. und 2. Eintrag mit
             denen des neuen DS bereinstimmen.
             => neuposlist wird auf weitere DS mit gleichem 1. und 2.
                Eintrag durchsucht (diese mssen direkt aufeinander folgen!)
                und nach dem letzten dieser DS abgeschnitten.
                Die endgltige Einf.Stelle mu weiter gesucht werden, falls
                Schlsselzahl>2; andernfalls ist der neue DS in identischer
                Form bereits in der Datei vorhanden}
              then begin
               dat^.vor:=nplist^.position^.vor;
               neuposlist^.poslist:=nplist;
               neuposlist2:=neuposlist;
               if nplist^.nach <> nil
                then begin
                 nplist:=nplist^.nach;
                 repeat
                  neu2:=nplist^.position^.daten^.nach^.inhalt^.name;
                  if neu2 = neu[2]
                   then begin
                    new(neuposlist2^.nach);
                    neuposlist2:=neuposlist2^.nach;
                    neuposlist2^.poslist:=nplist
                   end;
                  nplist:=nplist^.nach;
                 until (neu2 <> neu[2]) or (nplist = nil);
                end;
                neuposlist2^.nach:=nil
              end
              else begin
               {3.) Es gibt einen DS mit gleichem 1., aber greren 2.
                    Eintrag. Vor diesem wird eingefgt und gefunden wird
                    auf true gesetzt (die Einf.Stelle ist gefunden).}
               dat^.vor:=nplist^.position^.vor;
               gefunden:=true;
               loeschen(neuposlist);
              end
      end

      else begin        {berprfung des i. Schlssels (i>2)}
       {Innerhalb der in den vorhergegangenen Schritten erstellten neuposlist
        wird wie im 2. Schritt weitergesucht. Der einzige Unterschied liegt
        im komplizierteren Zugriff auf den i-ten Eintrag zum Vergleich mit
        neu[i], hierzu mu zunchst die schliste des jeweiligen DS bis zur
        i-ten Position durchlaufen werden.}
       plist:=pos^.daten[stelle]^.poslist;
       nplist:=neuposlist^.poslist;
       stop:=false;
       repeat
        sliste:=nplist^.position^.daten;
        for j:=2 to i
         do sliste:=sliste^.nach;
        neu2:=sliste^.inhalt^.name;
        if (neu2 < neu[i]) and (neuposlist^.nach <> nil)
         then begin
          neuposlist2:=neuposlist;
          neuposlist:=neuposlist^.nach;
          dispose(neuposlist2);
          nplist:=neuposlist^.poslist
         end
         else stop:=true;
       until (neu2 >= neu[i]) or (stop);
       if neu2 < neu[i]
        then begin
         gefunden:=true;
         dat^.vor:=neuposlist^.poslist^.position;
         loeschen(neuposlist)
        end
        else if neu2 = neu[i]
              then begin
               dat^.vor:=nplist^.position^.vor;
               while plist^.position <> nplist^.position
                do plist:=plist^.nach;
               neuposlist2:=neuposlist;
               merk:=plist;
               repeat
                npl3:=neuposlist2;
                neuposlist2:=neuposlist2^.nach;
                if plist^.nach <> nil
                 then plist:=plist^.nach;
                if neuposlist2 <> nil
                 then nplist:=neuposlist2^.poslist;
               until (plist^.position <> nplist^.position)
                  or (neuposlist2 = nil);
               npl3^.nach:=nil;
               if neuposlist2 <> nil
                then loeschen(neuposlist2)
              end
              else begin
               gefunden:=true;
               dat^.vor:=nplist^.position^.vor;
               if neuposlist <> nil
                then loeschen(neuposlist)
              end
      end
  end;

 procedure schl_einf(pos : dszeiger; stelle : word; dattrans : datenzeiger);

  {in: pos -> Zeiger auf den Datenspeicher, in den eingefgt werden soll
       stelle -> Nummer im array des Datenspeichers, in der der Zeiger
                 auf den neuen Eintrag eingefgt werden soll. Es mu
                 gelten: 1 <= stelle <= datensp_const
       dattrans -> Zeiger auf den neu einzufgenden daten-record}

  {Fgt einen neuen daten-record eine Datenspeicher ein und rckt ggf. auf}


  var i,posbel : word;
      posneu   : dszeiger;

  begin
   posbel:=pos^.belegt;
   if posbel = datensp_const
    {Ist der Datenspeicher (Dsp), in den eingefgt werden soll, schon voll,
     so wird entweder:}
    then begin
     if pos^.mehr = nil
      {1.) Wenn der Dsp der letzte zu diesem Schlssel ist, ein weiterer,
           neuer Dsp hinten angehngt und der neue Eintrag in der ersten
           Stelle des neuen Dsp eingefgt}
      then begin
       new(posneu);
       pos^.mehr:=posneu;
       posneu^.rueck:=pos;
       posneu^.belegt:=1;
       posneu^.daten[1]:=pos^.daten[datensp_const];
       posneu^.mehr:=nil
      end
      else schl_einf(pos^.mehr,1,pos^.daten[datensp_const]);
      {oder 2.) in den nachfolgenden Dsp durch erneutes Aufrufen der Prozedur
       schl_einf an erster Stelle neu eingefgt}
     for i:=(datensp_const - 1) downto stelle
      do pos^.daten[i+1]:=pos^.daten[i]
    end
    else for i:=posbel downto stelle
    {Ist der Dsp, in den neu eingefgt werden soll, noch nicht voll belegt, so
     werden von der Einf.Stelle aus alle folgenden Eintrge (genauer: Zeiger
     auf die Eintrge) um eine Position aufgerckt.}
          do pos^.daten[i+1]:=pos^.daten[i];
   pos^.daten[stelle]:=dattrans;
   if posbel < datensp_const
    then pos^.belegt:=posbel+1
  end;


 procedure nr_akt(dat : dzeiger);

  {in: dat -> Zeiger auf den Datensatz (datei), ab dem aktualisiert
              werden soll}

  {beim Einfgen (Lschen) eines Datensatzes werden ab dem eingefgten
   (gelschten) DS die Datensatznummern aktualisiert}

  var i : longint;

  begin
   i:=dat^.nr;
   while dat^.nach <> nil
    do begin
     i:=i+1;
     dat:=dat^.nach;
     dat^.nr:=i
    end
  end;

 procedure ds_loeschen(var dsl : dslzeiger; dat : dzeiger);

  forward;


 function ds_einf(kopf : dzeiger; var dsl : dslzeiger; var neu : datentyp;
                  aendern : boolean) : dzeiger;

  {in:  kopf, dsl
        neu -> enthlt zu jedem Schlssel der Datei einen Eintrag fr
               den neu einzufgenden Datensatz
        aendern -> Soll bei bereits vorhandenem, identischen Datensatz
                   vor dem Einfgen gewarnt werden (vgl. Option.double)
                   so wird aendern=false bergeben, andernfalls true.
                   So kann u.a. auch bei aktivierter Warn-Option die
                   Warnung unterdrckt werden (z.B. beim Umsorteieren einer
                   Datei, in die alle vorher vorhandenen DS, also auch die
                   eventuell doppelt vorhandenen, wieder aufgenommen werden
                   mssen.}

  {Fgt einen neuen Datensatz (DS) in die Datei ein.}

  var pos        : array[1..max_schluessel] of dszeiger;
      stelle     : array[1..max_schluessel] of word;
      sliste     : array[1..max_schluessel] of szeiger;
      merk       : array[1..max_schluessel] of pzeiger;
      vorhanden  : array[1..max_schluessel] of boolean;
      pleinf     : pzeiger;
      neuposlist : npzeiger;
      gefunden   : boolean;
      i          : word;
      dat_neu    : dzeiger;
      dattrans   : datenzeiger;
      wahl       : char;

  begin
   new(dat_neu);
   dsl^.dsanz:=dsl^.dsanz+1;  {ein DS mehr in Datei}
   wahl:='j';                 {Initialisierungen}
   for i:=1 to dsl^.szahl
    do begin
     merk[i]:=nil;
     pos[i]:=dsl^.sposition[i];
     new(sliste[i])
    end;
   dat_neu^.daten:=sliste[1]; {An den neuen DS wird eine sliste angehngt.}
   for i:=1 to (dsl^.szahl-1)
    do sliste[i]^.nach:=sliste[i+1];
   sliste[dsl^.szahl]^.nach:=nil;
   gefunden:=false;
   i:=0;
   repeat  {Einfgen des i-ten Eintrags}
    i:=i+1;
    suche(pos[i],neu[i],vorhanden[i],stelle[i]);
    {berprfung, ob schon ein DS im i-ten Schlssel den Eintrag neu[i] hat.}
    if vorhanden[i] = false  {falls nein, mu neu[i] neu eingefgt werden}
     then begin
      if stelle[i] > datensp_const
       {Falls Suche den letzten Datenspeicher (Dsp) zurckliefert und dieser
        bereits voll ist, so wird ein neuer Dsp an die Liste der Dsp
        angehngt, in dem neu[i] an erster Stelle eingefgt wird.}
       then begin
        stelle[i]:=1;
        new(pos[i]^.mehr);
        pos[i]^.mehr^.rueck:=pos[i];
        pos[i]:=pos[i]^.mehr;
        pos[i]^.belegt:=0;
        pos[i]^.mehr:=nil
       end;
      new(dattrans);            {Ein neuer daten-record wird angelegt und}
      dattrans^.name:=neu[i];   {bekommt den Namen neu[i] zugewiesen,}
      dattrans^.anzahl:=1;      {Anzahl (da 'nicht vorhanden') gleich 1}
      schl_einf(pos[i],stelle[i],dattrans)
      {Der neue daten-record wird von schl_einf in den entsprechenden
       Dsp eingefgt (ggf. mu aufgerckt werden, siehe dort)}
     end;
    sliste[i]^.inhalt:=pos[i]^.daten[stelle[i]];
    {Der neue daten-record wird in die entsprechende sliste eingetragen}
    if gefunden=false
     {Solange noch nicht die endgltige Stelle zum Einfgen gefunden ist, mu
      weiter nach dieser gesucht werden. Gibt es z.B. in einer Fahrzeugkartei
      mit Marke, Typ, Baujahr etc mehrere Eintrge mit Marke='VW' und
      Typ='Golf', so mu im Baujahr weiter nach der Einf. Stelle gesucht
      werden.
      Wird in dieser Kartei jedoch z.B. der erste Rolls Royce eingefgt, so
      mu nur innerhalb des ersten Schlssels 'Marke' nach der Einf. Stelle
      gesucht werden. In diesem Fall wird vorhanden[i]=false zurckgeliefert
      und gefunden auf true gesetzt (endgltige Einf. Stelle gefunden).}
     then einf_stelle_suche(pos[i],vorhanden[i],gefunden,stelle[i],
                            kopf,dat_neu,i,neu,merk[i],neuposlist);
    if vorhanden[i] = false
     then gefunden:=true; {Die endgltige Einf.-Stelle ist u.a. gefunden,
                           wenn es noch keinen DS, der im i-ten Schlssel
                           Eintrag neu[i] hat, gibt. Weitere Mglichkeiten:
                           vgl. procedure einf_stelle_suche}
   until i=dsl^.szahl;
   if (gefunden = false) and (neuposlist <> nil)
    {Wurde die Einf.-Stelle fr den neuen DS auch nach dem Durchsuchen des
     letzten Schlssels noch nicht gefunden, so ist bereits ein identischer
     DS in der Datei vorhanden. Je nach gesetzter Option 'Doppelte DS ohne
     nachfragen einfgen' erfolgt eine Warnmeldung/Abfrage ob eingefgt
     werden soll.
     Diese Abfrage entfllt u.a. beim Umsortieren der Datei etc, vgl.
     den jeweiligen Aufruf.}
    then begin
     loeschen(neuposlist);
     if (not aendern)
      then begin
       Wahl:=AskBox($70,$74,'Warnung',
       'Datensatz ist schon vorhanden.'+#13+'Trotzdem einfgen','JN');
      end
    end;

   dat_neu^.nach:=dat_neu^.vor^.nach;    {Einfgen des}
   dat_neu^.vor^.nach:=dat_neu;          {neuen DS in die}
   if dat_neu^.nach <> nil               {doppelt verkettete}
    then dat_neu^.nach^.vor:=dat_neu;    {Liste 'datei'}

   nr_akt(dat_neu^.vor);                 {Aktualisierung der DS-Nummern}
   for i:=1 to dsl^.szahl
    do begin
     if vorhanden[i] = false
      {Fr vorher in der Datei noch nicht vorhandene Eintrge (wenn z.B.
       der erste Rolls-Royce eingefgt wird) wird eine neue posliste angelegt}
      then begin
       new(pos[i]^.daten[stelle[i]]^.poslist);
       pos[i]^.daten[stelle[i]]^.poslist^.nach:=nil;
       pos[i]^.daten[stelle[i]]^.poslist^.position:=dat_neu
      end
      else begin
       {Fr neue Eintrge, die auch vorher schon in der Datei vorhanden waren
        (wenn z.B. der 127. VW eingefgt werden soll), wird die poslist
        durchlaufen und der neue Eintrag an entsprechender Stelle hinzuge-
        fgt. Innerhalb der poslist sind die DS stets in der selben Reihen-
        folge abgelegt, in der sie auch in der Datei stehen.}
       pos[i]^.daten[stelle[i]]^.anzahl:=pos[i]^.daten[stelle[i]]^.anzahl+1;
       if merk[i] = nil
        then merk[i]:=pos[i]^.daten[stelle[i]]^.poslist;
       while (merk[i]^.position^.nr < dat_neu^.nr) and (merk[i]^.nach <> nil)
        do merk[i]:=merk[i]^.nach;
       if merk[i]^.position^.nr < dat_neu^.nr
        then begin
         new(pleinf);
         merk[i]^.nach:=pleinf;
         pleinf^.nach:=nil;
         pleinf^.position:=dat_neu
        end
        else begin
         new(pleinf);
         pleinf^.nach:=merk[i]^.nach;
         merk[i]^.nach:=pleinf;
         pleinf^.position:=merk[i]^.position;
         merk[i]^.position:=dat_neu
        end
      end
    end;
   if wahl = 'N' then
   {Falls der DS nicht doppelt eingefgt werden soll (s.o.), mu er wieder
    aus der Datei gelscht werden.
    Es erscheint zunchst etwas umstndlich, ihn in diesem Fall zunchst
    einzufgen, da jedoch erst recht spt whrend des Einfge-Vorgangs
    erkannt werden kann, ob der DS schon vorhanden war und bis dahin schon
    einige Vernderungen an der Datei vorgenommen wurden, ist es einfacher,
    den DS zunchst komplett einzufgen und dann auf die vorhandene
    Prozedur ds_loeschen zurckzugreifen.}
   begin
    ds_loeschen(dsl,dat_neu);
    Dat_Neu:=Nil;
   end;
   ds_einf:=dat_neu {Der Zeiger auf den neuen DS wird zurckgegeben.}
  end;


 procedure nachruecken(pos : dszeiger; stelle : word);

  {in: pos -> Zeiger auf den Datenspeicher, in dem aufgerckt werden soll
       stelle -> Nummer der freien Stelle}

  {Das Gegenstck zur Prozedur schl_einf.
   Ein nicht mehr bentigter Eintrag wurde aus einem Datenspeicher
   entfernt und die anderen Eintrge mssen aufgerckt werden. Dies
   ist u.a. ntig, damit weiter mit binrer Suche gesucht werden kann.}

  var i : word;

  begin
   for i:=stelle to (pos^.belegt - 1)
    do pos^.daten[i]:=pos^.daten[i+1];
   if pos^.mehr = nil
    then begin
     pos^.belegt:=pos^.belegt - 1;
     if (pos^.belegt = 0) and (pos^.rueck <> nil)
      then begin
       pos^.rueck^.mehr:=nil;
       dispose(pos)
      end
    end
    else begin
     pos^.daten[datensp_const]:=pos^.mehr^.daten[1];
     nachruecken(pos^.mehr,1)
    end
  end;


 procedure schl_loeschen(Var pos : dszeiger; Var dat : dzeiger; stelle : word);

  {in:  pos -> Zeiger auf den Datenspeicher, in dem gelscht werden soll.
        dat -> Zeiger auf den Datensatz (Typ datei), der gelscht werden soll
        stelle -> Stelle im array des Datenspeichers, in der der Zeiger auf
                  den entsprechenden Eintrag des Datensatzes enthalten ist.}

  {Entfernt aus der posliste zu einem daten-Eintrag den Verweis auf den
   datei-record 'dat'. War 'dat' der einzige Datensatz mit diesem Eintrag,
   so wird der Eintrag komplett aus dem Datenspeicher entfernt.}

  var plist,plistmerk : pzeiger;

  begin
   if pos^.daten[stelle]^.anzahl = 1
    {Anzahl=1 => einziger Datensatz mit diesem Eintrag. Eintrag wird aus dem
     Datenspeicher gelscht, die folgenden Eintrge werden aufgerckt}
    then begin
     dispose(pos^.daten[stelle]^.poslist);
     dispose(pos^.daten[stelle]);
     nachruecken(pos,stelle)
    end
    else begin
    {Anzahl>1, d.h., es ex weiterer Datensatz mit diesem Eintrag.
     Anzahl wird um 1 reduziert.
     Die posliste wird durchlaufen, bis der Zeiger auf den zu lschenden
     Datensatz erreicht ist. Dann wird dieser aus der Liste entfernt.}
     pos^.daten[stelle]^.anzahl:=pos^.daten[stelle]^.anzahl-1;

     plist:=pos^.daten[stelle]^.poslist;
     if plist^.position = dat
      then begin
       pos^.daten[stelle]^.poslist:=plist^.nach;
       dispose(plist)
      end
      else begin
       while plist^.nach^.position <> dat
        do plist:=plist^.nach;
       plistmerk:=plist^.nach;
       plist^.nach:=plistmerk^.nach;
       dispose(plistmerk)
      end
    end
  end;


 procedure ds_loeschen(var dsl : dslzeiger; dat : dzeiger);

  {in:  dsl
        dat -> Zeiger auf den Datensatz (datei), der gelscht werden soll}

  {Lscht einen Datensatz.}

  var i,stelle         : word;
      pos              : dszeiger;
      sliste,displiste : szeiger;
      vorhanden        : boolean;  {procedure suche braucht dies als Var-
                                    parameter, hier ohne Bedeutung}

  begin
   dsl^.dsanz:=dsl^.dsanz-1; {Anzahl der Datenstze in Datei um 1 verringern}
   sliste:=dat^.daten;
   for i:=1 to dsl^.szahl     {Die zugehrige schliste wird durchlaufen und}
    do begin                  {fr jeden Schlssel der zugeh. Eintrag aus}
     pos:=dsl^.sposition[i];  {dem Datenspeicher gelscht.}
     suche(pos,sliste^.inhalt^.name,vorhanden,stelle);
     schl_loeschen(pos,dat,stelle);
     displiste:=sliste;
     sliste:=sliste^.nach;    {Dabei werden auch die Zeiger der schliste}
     dispose(displiste)       {nach und nach gelscht.}
    end;
   dat^.vor^.nach:=dat^.nach; {Sind alle Eintrge des Datensatzes gelscht,}
   if dat^.nach <> nil        {so wird der zugehrige datei-record komplett}
    then dat^.nach^.vor:=dat^.vor;  {aus der datei-Liste entfernt und die}
   nr_akt(dat^.vor);          {Nummern der nachfolgenden Datenstze werden}
   dispose(dat)               {aktualisiert.}
  end;


 procedure schl_hinzuf(var dsl : dslzeiger; kopf : dzeiger;
                       Name,Pattern : String; Pos : Word);

  {in: dsl,kopf
       Name -> enthlt den Namen des neuen Schlssels
       Pattern -> enthlt einen vorgegebenen (Standard-)Eintrag, den ALLE
                  Datenstze im neuen Schlssel enthalten sollen (ggf. auch
                  leerer String)
       Pos -> enthlt die Nummer der Position, an der der neue Schlssel
              eingefgt werden soll. Pos mu zwischen 1 und Anzahl der
              Schlssel+1 liegen (also 0 < Pos < dsl^.szahl+1)}

  {Ein (Sortier-)Schlssel wird hinzugefgt.}

  var zahl,i,j        : word;
      neu             : string[80];
      dat             : datenzeiger;
      dateilauf       : dzeiger;
      sliste,slistneu : szeiger;
      plist           : pzeiger;
      hilf            : dszeiger;

  begin
   Zahl:=Pos;
   if (zahl > 0) and (zahl < dsl^.szahl+2)
    then begin
     dsl^.szahl:=dsl^.szahl+1;      {Schlsselanzahl wird um 1 erhht.}
     for i:=dsl^.szahl downto (zahl+1)   {Eintrge sname (Name der Schlssel)}
      do begin                      {Schlssel) und sposition (Zeiger auf den}
       dsl^.sname[i]:=dsl^.sname[i-1];        {zugehrigen Datenspeicher)}
       dsl^.sposition[i]:=dsl^.sposition[i-1] {der Schlssel mit grsserer}
      end;                                    {werden aufgerckt.}
     dsl^.SName[Zahl]:=Name;           {Dem neuen Schlssel wird sein Name}
     new(dsl^.sposition[zahl]);        {und ein neuer, leerer Datenspeicher}
     dsl^.sposition[zahl]^.mehr:=nil;  {zugewiesen.}
     dsl^.sposition[zahl]^.rueck:=nil;
     if kopf^.nach <> nil
      {Falls die Datei nicht leer ist (mindestens ein Datensatz enthlt),
       bekommen alle Datenstze im pos-ten Schlssel den Eintrag 'Pattern'
       zugewiesen.}
      then begin
       dsl^.sposition[zahl]^.belegt:=1; {Zuerst wird 'Pattern' in den Daten-}
       neu:=Pattern;                    {speicher eingefgt. Dann wird belegt}
       new(dat);                        {auf 1 gesetzt und ein neuer daten-}
       dat^.name:=neu;                  {record mit name='Pattern' und Anzahl}
       dat^.anzahl:=1;                  {1 erstellt.}
       dat^.poslist:=nil;
       dsl^.sposition[zahl]^.daten[1]:=dat;
       dateilauf:=kopf;
       while dateilauf^.nach <> nil     {Als nchstes wird die komplette}
        do begin                        {Datei durchlaufen.}
         dateilauf:=dateilauf^.nach;
         if dat^.poslist = nil          {Eine neue poslist wird an dat ange-}
          then begin                    {hngt und}
           new(dat^.poslist);
           plist:=dat^.poslist;
           plist^.position:=dateilauf
          end
          else begin                    {nach und nach werden alle Datenstze}
           dat^.anzahl:=dat^.anzahl+1;  {in diese poslist eingetragen.}
           new(plist^.nach);            {Dabei wird anzahl jeweils um 1}
           plist:=plist^.nach;          {erhht.}
           plist^.position:=dateilauf
          end;
         new(slistneu);                 {Jedem Datensatz wird in seiner}
         slistneu^.inhalt:=dat;         {schliste an pos-ter Position ein}
         if zahl = 1                    {Zeiger auf den neuen daten-record}
          then begin                    {dat zugewiesen.}
           slistneu^.nach:=dateilauf^.daten;
           dateilauf^.daten:=slistneu
          end
          else begin
           sliste:=dateilauf^.daten;
           for j:=2 to (zahl - 1)
            do sliste:=sliste^.nach;
           slistneu^.nach:=sliste^.nach;
           sliste^.nach:=slistneu;
          end
        end;
        plist^.nach:=nil
      end
      else dsl^.sposition[zahl]^.belegt:=0
      {Falls die Datei keinen Datensatz enthlt, so wird belegt auf 0
       gesetzt.}
    end
  end;


 function ds_aendern(kopf,dat : dzeiger; var dsl : dslzeiger;
                     var neu : datentyp) : dzeiger;

  {in:  kopf,dsl
        dat -> Zeiger auf zu ndernden Datensatz
        neu -> array mit neuen, genderten Eintrgen fr den DS
   out: Zeiger auf den genderten DS}

  {Wenn ein Datensatz gendert werden soll, so wird zunchst die neue
   Version des DS eingefgt und danach die alte gelscht.
   Dadurch kann auf die bestehenden Funktionen ds_einf und ds_loeschen
   zurckgegriffen werden.
   Die Reihenfolge (erst einfgen, dann lschen) ist schneller, da oft
   mehrere Eintrge des DS gleich bleiben und ein solcher, falls er der
   einzige derartige Eintrag zum entsprechenden Schlssel war, nicht
   erst komplett gelscht und dann wieder eingefgt werden mu.}

  var dsanz   : longint;

  begin
   ds_aendern:=ds_einf(kopf,dsl,neu,true);
   {true : schaltet Warnung bei 'doppelter Datensatz' aus}
   ds_loeschen(dsl,dat)
  end;


 procedure datensp_loeschen(Var pos : dszeiger);

  {in: pos -> Zeiger auf ersten Datenspeicher in der Liste der zu
              lschenden Dsp.}

  {Durchluft alle Datenspeicher und gibt die angehngten pzeiger (Zeiger
   auf posliste) und alle dszeiger (Zeiger auf Datenspeicher) wieder frei.}

  var i             : integer;
      sliste,slist2 : pzeiger;
      pos2          : dszeiger;

  begin
   if Pos<>Nil then
   begin
    repeat
     for i:=1 to pos^.belegt
      do begin
       sliste:=pos^.daten[i]^.poslist;
       while sliste <> nil
        do begin
         slist2:=sliste;
         sliste:=sliste^.nach;
         dispose(slist2)
        end;
       dispose(pos^.daten[i])
      end;
     pos2:=pos;
     pos:=pos^.mehr;
     if pos <> nil
      then dispose(pos^.rueck)
    until pos = nil;
    dispose(pos2);
    Pos:=Nil;
   end;
  end;

  procedure datei_sort(var kopf: dzeiger; var dsl: dslzeiger;
                      neue_reihenfolge : prior_typ);

  {in:  kopf,dsl
        neue_reihenfolge -> eine Permutation der Zahlen von 1 bis
                            dsl^.dsanz, genaueres siehe unten
   out: kopf,dsl -> die entsprechenden Zeiger der umsortierten Datei}

  {Ist m die Anzahl der Schlssel in der Datei, so mu die Variable
   neue_reihenfolge eine Permutation der Zahlen 1,2,...,m enthalten.
   Der i-te Schlssel wird dann ersetzt durch den neue_reihenfolge[i]-ten
   Schlssel. Beispiel:
     neue_reihenfolge: [2|1|3]
     Schlssel Nummer       alte Datei      neue Datei
               1            Vorname         Name
               2            Name            Vorname
               3            Alter           Alter
   }

  var dat,dat2,neukopf      : dzeiger;
      neudsl: DslZeiger;
      neu           : datentyp;
      i             : word;
      sliste,slist2 : szeiger;
      dsanz         : longint;

  begin
   dsanz:=0;
   Init(NeuKopf,NeuDsl,Dsl^.SZahl);  {Die neue Datei wird initialisiert.}
   for i:=1 to dsl^.szahl    {Die Schlssel werden in der neuen Reihenfolge}
    do neudsl^.sname[neue_reihenfolge[i]]:=dsl^.sname[i];       {eingefgt.}
   dat:=kopf;
   while dat^.nach <> nil     {Die alte Datei wird - beginnend beim ersten}
    do begin                  {Datensatz - komplett durchlaufen. }
     dat2:=dat;
     dat:=dat^.nach;
     dispose(dat2);          {Bereits bertragene Datenstze werden gelscht.}
     sliste:=dat^.daten;
     for i:=1 to dsl^.szahl  {Die Inhalte des Datensatzes werden in ge-}
      do begin               {Reihenfolge in die Variable neu eingegeben.}
       neu[neue_reihenfolge[i]]:=sliste^.inhalt^.name;
       slist2:=sliste;       {Gleichzeitig wird die dem Datensatz zugehtige}
       sliste:=sliste^.nach; {schliste freigegeben.}
       dispose(slist2)
      end;
     ds_einf(neukopf,neudsl,neu,True)
     {Der Datensatz wird in die neue Datei eingefgt, dabei schaltet 'True'
      die Warnung bei 'doppelter Datensatz' aus}
    end;
    dispose(dat);    {Der letzte Datensatz aus der alten Datei wird gelscht.}
    for i:=1 to dsl^.szahl
     do datensp_loeschen(dsl^.sposition[i]);
    {Ist die Datei komplett bertragen, so werden noch die Datenspeicher und
     und der Zeiger auf den dsltyp freigegeben.}
    dispose(dsl);
    kopf:=neukopf;   {Zuletzt wird die neue (umsortierte) Datei wieder als}
    dsl:=neudsl;     {aktuelle Datei eingesetzt (an kopf und dsl bergeben).}
  end;


 procedure schl_loesch(var dsl : dslzeiger; var kopf : dzeiger;
                       loesch_stelle : word);

  {in: dsl,kopf
       loesch_stelle -> Nummer des Schlssels, der gelscht werden soll. Es
                         mu gelten: 0 < loesch_stelle <= dsl^.szahl}

  {Die Prozedur lscht einen Schlssel und die Eintrge zu diesem
   Schlssel aus allen Datenstzen der Datei.}

  var neudsl           : dslzeiger;
      neukopf,dat,dat2 : dzeiger;
      neu              : datentyp;
      i                : word;
      sliste,slist2    : szeiger;
      neue_reihenfolge : prior_typ;

  begin
   if loesch_stelle = dsl^.szahl
    then begin
    {Falls der letzte Schlssel gelscht werden soll, mu die Datei nicht
     umsortiert werden. Der letzte Datenspeicher wird gelscht. Die Datei
     wird komplett durchlaufen und aus den schlisten aller Datenstze wird
     der letzte Eintrag gelscht.}
     datensp_loeschen(dsl^.sposition[dsl^.szahl]);
     dat:=kopf;
     while dat^.nach <> nil
      do begin
       dat:=dat^.nach;
       sliste:=dat^.daten;
       for i:=2 to (dsl^.szahl-1)
        do sliste:=sliste^.nach;
       dispose(sliste^.nach);
       sliste^.nach:=nil
      end;
     dsl^.szahl:=dsl^.szahl-1
    end
    else begin
    {Ein anderer als der letzte Schlssel soll gelscht werden. Dadurch ndert
     sich die Sortier-Prioritt, die Datei mu neu sortiert werden.}
     Init(neukopf,neudsl,dsl^.SZahl-1);    {Eine neue Datei wird angelegt,}
     neuDsl^.DSanz:=0;                     {(neukopf & neudsl)}
     for i:=1 to (loesch_stelle-1)
      do begin
       neue_reihenfolge[i]:=i;              {Die Schlssel (ausser dem an der}
       neudsl^.sname[i]:=dsl^.sname[i]      {loesch_stelle) werden neudsl zu-}
      end;                                  {gewiesen. Der array neue_reihen-}
     for i:=(loesch_stelle+1) to dsl^.szahl {folge wird mit (l=loesch_stelle,}
      do begin                              {d=dsl^.szahl)}
       neue_reihenfolge[i]:=i-1;            {1,2,..,l-1,d,l+1,..,d-1}
       neudsl^.sname[i-1]:=dsl^.sname[i]    {belegt.}
      end;
     neue_reihenfolge[loesch_stelle]:=dsl^.szahl;
     dat:=kopf;
     while dat^.nach <> nil     {Die alte Datei wird komplett durchlaufen,}
      do begin                  {alle Datenstze ohne ihren Eintrag an der}
       dat2:=dat;               {loesch_stelle in die neue Datei eingefgt}
       dat:=dat^.nach;          {und in der alten Datei gelscht.}
       dispose(dat2);
       sliste:=dat^.daten;
       for i:=1 to dsl^.szahl
        do begin
         neu[neue_reihenfolge[i]]:=sliste^.inhalt^.name;
         slist2:=sliste;
         sliste:=sliste^.nach;
         dispose(slist2)
        end;
       ds_einf(neukopf,neudsl,neu,true)
       {'True' schaltet Warnung bei 'doppelter Datensatz' aus}
      end;
      dispose(dat);
      for i:=1 to dsl^.szahl       {Lschen der alten Datenspeicher}
       do datensp_loeschen(dsl^.sposition[i]);
      dispose(dsl);
      kopf:=neukopf; {Zuletzt wird die neue (umsortierte) Datei wieder als}
      dsl:=neudsl;   {aktuelle Datei eingesetzt (an kopf und dsl bergeben).}
    end
  end;


 procedure datei_loeschen(Var dat : dzeiger);

  {in: dat -> Zeiger auf ersten Datensatz in Datei}

  {Durchluft die ganze Datei und gibt alle dzeiger (Zeiger auf datei)
   und szeiger (Zeiger auf schliste) wieder frei.}

  var dat2          : dzeiger;
      sliste,slist2 : szeiger;

  begin
   while dat <> nil
    do begin
     sliste:=dat^.daten;
     while sliste <> nil
      do begin
       slist2:=sliste;
       sliste:=sliste^.nach;
       dispose(slist2)
      end;
     dat2:=dat;
     dat:=dat^.nach;
     dispose(dat2)
    end
  end;

procedure Erase(Var Kopf:DZeiger;Var Dsl:DslZeiger);
{Lscht eine komplette Datei.}
Var i:Word;
begin
 Datei_loeschen(Kopf);      {Datenstze lschen}
 if Dsl<>Nil then
 begin
  for i:=1 to Dsl^.SZahl do
  begin
   Datensp_Loeschen(Dsl^.SPosition[i]);         {Datenspeicher lschen}
  end;
  dispose(dsl);
  dsl:=Nil;
 end;
end;

procedure Konvert (Var S:Datentyp; Dat:DZeiger);
{Der Datensatz aus Dat wird gelesen und in S zurckgegeben.}
Var i:Integer;
    p:SZeiger;
begin
 i:=1;
 if dat<>nil then
 begin
  p:=Dat^.Daten;
  while p<>nil do      {Noch weiterer Schlssel vorhanden}
  begin
   s[i]:=p^.Inhalt^.Name;
   p:=p^.Nach;
   Inc(i);
  end;
 end;
end;

procedure Speichern(Kopf: DZeiger; Dsl:Dslzeiger;DateiName:String);
{Speichert eine komplette Datei, bestehend aus den Datenstzen in Kopf
 und den Listen aus Dsl, in die Datei mit dem Namen DateiName.
 Zum Prinzip des Speicherns:
 Es sollen ja alle Datensatze gespeichert werden. Der erste Ansatz zum
 Abspeichern wre dann also, so etwas wie die Datei durchlaufen und die
 Eintrge jeden Datensatzes abzuspeichern. Das Laden wre dann das Auslesen
 der Datenstze und das Einfgen mit Hilfe der bekannten Routinen.
 Allerdings hat dieses Verfahren ja doch ein paar Macken:
 1. Diverse Texteintrge (z.B. ('Peter','Schmidt') in einer Namensdatei)
    wrden mehrfach abgespeichert. (=>Platzverschwendung)
 2. Die im Speicher abgelegte Datenstruktur wrde nicht bercksichtigt
    werden. Da die Daten ja alle schn sortiert vorliegen. Beim Laden
    mte alles neu eingefgt werden. (=>Zeitverschwendung)
 Also realisieren wir das so:
 Zu Beginn natrlich die notwendigen Dinge wie,z.B. Anzahl Datenstze,
 Namen der Schlssel usw.
 Wir haben das Abspeichern einfach durch 'Speichern' der Datenspeicher
 realisiert.
 Im Datenspeicher stehen ja alle Informationen:
 1. Einmal der reine Textbezeichner, z.B. Peter
 2. Wie oft dieser in der Datei vorkommt und nicht ganz unwichtig
 3. wo dieser 'Peter' berall vorkommt.
 Beachte: Das Abspeichern ist bzgl. verschiedener Datenspeicher Konstanten
 kompatibel.}


Var f:Text;
    s:String;
    i,j,k:Word;
    p:DSZeiger;
    Dz:Datenzeiger;
    l:PZeiger;
    Anz:LongInt;

begin
 SetStatusLine('  '+MaxDatLen(DateiName,50)+'   wird gespeichert.');
 Assign(f,DateiName);
 Rewrite(f);
 Writeln(f,'Gupe-Daten :');       {Wiedererkennug fr das Laden}
 Writeln(f,dsl^.SZahl);           {Anzahl Schlssel}
 for i:=1 to dsl^.SZahl Do Writeln(f,Dsl^.SName[i]);  {Bezeichnungen der Schlssel}
 Writeln(f,dsl^.DSAnz);           {Anzahl Datenstze}
 for i:=dsl^.Szahl downto 1 Do    {beginne mit Datensatz der geringsten Prioritt}
 begin
  P:=Dsl^.SPosition[i];           {Nun werden alle Datenspeicher abgespeichert.}
  while p<>nil do
  begin
   for j:=1 to p^.belegt do
   begin
    Dz:=p^.Daten[j];
    Writeln(f,Dz^.Name);          {Name des Eintrags}
    Writeln(f,Dz^.Anzahl);        {wie oft kommt er in der Datei vor?}
    l:=Dz^.Poslist;
    while l<>nil do
    begin
     Writeln(f,l^.Position^.Nr);  {alle Datensatznummern dieses Eintrages abspeichern}
     l:=l^.nach;
    end;
   end;
   p:=p^.Mehr;
  end;
  Writeln(f,#1);  {Ende-Zeichen}
 end;
 Close(f);
end;

function SpeichernUnter(kopf:DZeiger; Dsl:DslZeiger; Var DateiName:String):Char;
{Die reine Speicher-Prozedur verlangt einen Dateinamen. Ist dieser noch
 nicht vergeben bzw. soll die Datei unter einem anderen Name abgespeichert
 werden, kommt diese Routine zum Einsatz. Es wird zunchst der Dateiname
 ermittelt und dann wird die Datei aus 'Kopf' und 'Dsl' abgspeichert.
 Theoretisch. In der Praxis kommen noch ein paar Stolpersteine dazwischen.
 Der Anwender knnte die Lust am Speicher verlieren, indem er den Dialog
 zur Eingabe des Dateinamens abbricht. Oder aber der gewhlte Dateiname
 ist bereits vergeben und der Anwender mchte sie nicht berschreiben.
 Aus diesem Grund ist die Routine als Funktion konzipiert. Sie liefert
 ein Zeichen zurck, das ber den Ausgang des Speicherns informiert:
 'J': Alles klar, ist gespeichert, Name in DateiName zurckgegeben.
 'N','A': Abbruch der Operation, DateiName bleibt unverndert.}
Var AltName:String;
    Ch:Char;
begin
 SpeichernUnter:='J';   {wir gehen doch vom besten aus...}
 AltName:=GetDateiName('*.DAT','Datei speichern unter');
 if AltName<>'' then    {korrekter Name wurde gewhlt}
 begin
  if (Pos('.',AltName)=0) then AltName:=AltName+'.DAT';
  if ExistDatei(AltName) then
  begin
   Ch:=AskBox($70,$74,'Warnung','Datei '+AltName+' existiert bereits.'+#13+
                         'berschreiben ?','JNA');
   SpeichernUnter:=Ch;
   if Ch='J' then     {klar zum berschreiben}
   begin
    DateiName:=AltName;
    Speichern(kopf,dsl,DateiName);
   end;
  end else     {Datei existiert nicht, also speichern.}
  begin
   DateiName:=AltName;
   Speichern(kopf,dsl,DateiName);
  end;
 end else
 begin                 {kein Name gewhlt}
  SpeichernUnter:='A';
 end;
end;

function Laden(Var Kopf: DZeiger;Var Dsl:Dslzeiger;Var DateiName:String):Boolean;
{Ldt eine Datei. Zunchst wird der Dateiname ermittelt und in DateiName
 abgespeichert und zurckgegeben. Das Resultat des Ladens wird dann in
 Kopf und Dsl zurckgeliefert. Zum Prinzip des Ladens: siehe Speichern.
 Aber auch beim Laden gibt es Stolpersteine: der Anwender kann ja
 einen Namen angeben, den es gar nicht gibt, oder eine falsche Datei
 ffnen (z.B. Pascal Programm). Daher wird ein Boolean Wert zurckgegeben,
 der angibt, ob das Laden positiv verlaufen ist.}
Const Max = 16382;  {1<= Max <= 16382}
Type PListe =Array[0..Max] of DZeiger; {That's what I call CHIP-Tuning}
{Nanu, was soll das denn jetzt?
 Da beim Speichern ja nur die Nummer des Datensatztes (von z.B. 'Peter')
 abgespeichert ist, mu jetzt aber auch in Kopf an entsprechenden Stellen
 Zeiger auf 'Peter' gebogen werden. Aber wie soll man auf auf das x. Element
 eier Liste zugreifen? Alle durchlaufen, dauert zu lange. Gut, man knnte
 auch ber die Neuanschaffung eines schnelleren Rechners nachdenken. Ist aber
 nicht ntig.
 Es wird ein 'quasi-Array' kreiert:
 In PListe gibt es Max Eintrge, Ist nun die Anzahl der Datenstze in der
 zu ladenden Datei kleiner (oder gleich) Max, so kann direkt mit Hilfe
 von PListe auf das x. Element zugegriffen werden. Andernfalls machen wir
 Division mit Rest. und nur auf jedes (Anzahl der Datenstze)/(Max)-te
 Element kann direkt zugegriffen werden, fr die anderen mssen (nur ein
 paar) Elemente in der Liste weitergelaufen werden.}

Var f:Text;
    s,Message:String;
    i,j,k,m,Steps:Word;
    p,last:DSZeiger;
    Dz:Datenzeiger;
    l:PZeiger;
    Anz,c,Nr:LongInt;
    Liste: ^PListe;
    start,Vor,Nach:DZeiger;
    Pz:Pzeiger;
    Daten:SZeiger;
    Ende:Boolean;

begin
 Laden:=False;   {wir gehen vom schlimmsten aus...}

 repeat
  DateiName:=GetDateiName('*.DAT','Datei ffnen');
  s:='Gupe-Daten :';
  if (DateiName<>'') and (Pos('.',DateiName)=0) then DateiName:=DateiName+'.DAT';
  if (DateiName<>'') and (ExistDatei(DateiName)) then  {jetzt noch checkne:}
  begin                                                {ist auch GuPe-Datei?}
   Assign(f,DateiName);
   Reset(f);
   Readln(f,s);
   if s<>'Gupe-Daten :' then     {Leider keine Gupe-Datei, also alles neu}
   begin
    MsgBox($70,'Fehler','Keine GUPE-Datei');
    Close(f);
   end
  end
 until s='Gupe-Daten :' ;

 if (DateiName<>'') and (ExistDatei(DateiName)) then
 {So jetzt kann geladen werden:}
 begin
  Laden:=true;
  SetStatusLine('  '+MaxDatLen(DateiName,50)+'   wird geladen.');
  datei_loeschen(kopf);     {Alten Kopf brauchen wir nicht mehr}
  if dsl<>nil then          {Alten Datenspeicher auch nicht}
   for k:=1 to dsl^.szahl do datensp_loeschen(dsl^.sposition[k])
  else
   New(Dsl);

  {Erstmal die Basics laden:}
  Readln(f,dsl^.SZahl);
  for i:=1 to dsl^.SZahl Do
  begin
   Readln(f,Dsl^.SName[i]);
   Dsl^.SPosition[i]:=Nil;
  end;
  Readln(f,dsl^.DSAnz);
  Anz:=dsl^.DSAnz;


  New(Liste);
  New(Kopf);
  Start:=Kopf;
  Kopf^.Vor:=Nil;
  Kopf^.Nr:=1;
  Kopf^.Daten:=Nil;
  Steps:=(Anz div Max)+1;  {wie weit mu maximal in der Datensatz-Liste
                            gelaufen werden, bis der korrekte Eintrag
                            gefunden ist.}
  Liste^[0]:=Kopf;  {je nachdem ob Steps >1 ist wird Liste[0] frs}
  Liste^[1]:=Kopf;  {erste Zugreifen bentigt oder Liste[1]}

  for c:=2 to Anz do  {generiere nun die Datensatz-Liste}
  begin
   New(Kopf^.Nach);
   Kopf^.Nach^.Vor:=Kopf;
   Kopf^.Nach^.Nr:=c;
   Kopf^.Nach^.Daten:=Nil;
   Kopf:=Kopf^.Nach;
   if (c mod steps)=0 then
   begin
    Liste^[c div steps]:=Kopf;      {Quasi-Array ist auch mal wieder dran}
   end;
  end;
  Kopf^.Nach:=nil;
  Kopf:=Start;

  for i:=dsl^.SZahl downto 1 do
  begin
   Start:=Kopf;
   while kopf<>nil do
   begin
    New(Daten);               {Neue Schliste}
    Daten^.Nach:=Kopf^.Daten; {hnge alte Schliste einfach dran, deshalb}
    Kopf^.Daten:=Daten;       {auch mit niedrigster Prioritt angefangen}
    Kopf:=Kopf^.Nach;
   end;
   Kopf:=Start;
   Ende:=False;
   j:=0;
   repeat
    Readln(f,s);
    Ende:=(s=#1);
    if Ende then
    begin
     Last^.belegt:=j; {Liste (Datenspeicher) nicht voll? Dann Anzahl angeben}
    end else
    begin
     Inc(j);
     if j>DatenSp_Const then j:=1; {neue Liste}
     if j=1 then
     begin
      New(p);
      if Dsl^.SPosition[i]=Nil then  {noch keine Datenspeicher Liste vorhanden}
      begin
       Dsl^.SPosition[i]:=p;
       p^.mehr:=Nil;
       p^.Rueck:=Nil;
       Last:=p;
      end else             {Hnge neue Liste an}
      begin
       Last^.mehr:=p;
       p^.Rueck:=Last;
       p^.mehr:=nil;
       Last:=p;
      end;
     end;

     if j=Datensp_const then
     begin
      p^.belegt:=Datensp_Const;  {im nchsten Schritt ist es hierfr zu spt}
     end;
     New(Last^.Daten[j]);        {Erzeuge neue Posliste}
     Last^.Daten[j]^.Name:=s;             {Zuerst Basics rein:Bezeichnung und}
     readln(f,Last^.Daten[j]^.Anzahl);    {Anzahl}
     Last^.Daten[j]^.poslist:=Nil;
     for m:=1 to Last^.Daten[j]^.Anzahl do
     begin
      Readln(f,Nr);      {Datensatz Nummern lesen}
      if m>1 then
      begin
       New(Last^.Daten[j]^.PosList^.Nach);     {In Posliste einfgen}
       Last^.Daten[j]^.PosList:=Last^.Daten[j]^.PosList^.Nach;
      end
      else
      begin                           {Erstmal Liste erzeugen}
       New(Last^.Daten[j]^.PosList);
       pz:=Last^.Daten[j]^.PosList;
      end;
      Last^.Daten[j]^.PosList^.Nach:=Nil;
      Start:=Kopf;
      Kopf:=Liste^[Nr div Steps];     {Datensatz suchen}
        while Kopf^.Nr<>Nr do
      begin
       Kopf:=Kopf^.Nach;            {ein paar Datenstze weiterrcken}
      end;
      Kopf^.Daten^.Inhalt:=Last^.Daten[j];      {Verkettung posliste mit Datensatzliste}
      Last^.Daten[j]^.PosList^.Position:=Kopf;  {und umgekehrt}
      Kopf:=Start;
     end;
     Last^.Daten[j]^.Poslist:=pz;
      end;
   until Ende;
  end;
  Start:=Liste^[0];
  New(Kopf);
  Kopf^.Nr:=0;
  Kopf^.Daten:=Nil;
  Kopf^.Vor:=Nil;
  Kopf^.Nach:=Start;
  Start^.Vor:=Kopf;
  Dispose(Liste);
  SetStatusLine('');
  Close(f);
 end;
end;

function EditBox(x1,x2,y1,y2,xn1:Integer; AutoRet:Word;Var Starter, yb,yi:Word;YMax:Word;
                 Max:Integer;Var Namen,Ed:Datentyp;Var Auto:Boolean;Marked:Boolean;
                 Ni,Ho:Menge;P:PBildschirm):Word;
{Startet einen Mini-Editor. Er dient zum Editieren von Arrays der Gre
 eines Datensatzes. Sind mehr Schlssel als Editierplatz vorhanden,
 so wird nach oben bzw. nach unten gerollt.
 x1,x2,y1,y2 sind die Koordinaten des Editierfeldes.
 xn1 enthlt die x-Koordinate, an der der Schlsselname ausgegeben
 werden soll. Das ist ntig, da evtl. gerollt werden mu.
 AutoRet ist ein Word-Wert, der dann zum Eisatz kommt, wenn in der letzten
 Editierzeile Return gedrckt wird. Dann wird das aktuelle Kommando auf
 AutoRet gesetzt, und der aktuelle Datensatz wird z.B. eingefgt.
 Starter gibt an, an welcher Position im Wort der Cursor zu plazieren ist und
 das Editieren beginnt.
 yb,yi tun dasselbe fr den y-Eintrag. yi entspricht dem Tatschlich editierten
 Eintrag in dem Editierarray; yb gibt die y-Koordinate (relativ zur Box) an,
 auf der am Bildschirm der Cursor bzw. der Text erscheinen soll.
 Ed beinhaltet das zu editierende String-Array, dieser wird auch zurck
 gegeben.
 Max ist die maximale Lnge, die fr einen String zur Verfgung steht.
 Der Boolean Auto gibt an, ob im Einfgemodus oder berschreibmodus
 editiert wird.
 Der Boolean Marked gibt an, ob markiert editiert werden soll.
 Ni,Ho sind Mengen und beinhalten, bei welchen Zeichen das Editieren
 beendet sein soll. Damit auch Sonderzeichen mglich sind, ist die
 Unterteilung in Ni(ederwertiges Byte) und Ho(chwertiges Byte) ntig,
 da Pascal ja keine Word-Menge kennt. Das Zeichen, durch das der Editor
 verlassen wird, wird ebenfalls zurckgegeben.
 P ist der Bildschirm, wo alles stattfindet.}
Var Ex:Word;
    i,j,l,h:Integer;
begin
 l:=x2-x1+1;  {Editlnge}
 h:=y2-y1;    {Edithhe}
 repeat
  Ex:=EditLine(x1,yb,l,Starter,Ed[yi],Max,Auto,Marked,Ni+[13],Ho+[$50,$48],p);
  if Ex=13 then         {Zeilenvorschub}
  begin
   if yi<YMax then
   begin
    Starter:=1;      {Einen Eintrag weiter im Array,aber an den Zeilenanfang}
    Ex:=kbDown;
   end else
    Ex:=AutoRet;     {im letzten Eintrag kommt AutoRet zu Einsatz}
  end;
  Case Ex of
   kbUp :   begin    {Cursor nach oben}
             if YI>1 then   {geht tatschlich noch einen hher}
             begin
              Yi:=Yi-1;
              Yb:=Yb-1;
              if Yb<Y1 then    {Rollen}
              begin
               for i:=y2 downto y1+1 do
               begin
                for j:=xN1 to x2+1 do p^[i,j]:=p^[i-1,j]; {verschiebe alles}
               end;
               WriteXY(XN1,y1,Namen[yi],p);  {1. Zeile neu ausgeben}
               WriteXY(x1,y1,Ed[yi],p);
               for i:=x1+length(Ed[yi]) to x2 do p^[y1,i].Zeichen:=' ';
               Yb:=Yb+1;
              end;
             end;
            end;
   kbDown : begin    {Cursor nach unten}
             if YI<YMax then
             begin
              Yi:=yi+1;
              Yb:=Yb+1;
              if Yb>y2 then   {rollen}
              begin
               for i:=y1 to y2-1 do
               begin
                for j:=xN1 to x2+1 do p^[i,j]:=p^[i+1,j];
               end;
               WriteXY(XN1,y2,Namen[yi],p);
               WriteXY(x1,y2,Ed[yi],p);
               for i:=x1+length(Ed[yi]) to x2 do p^[y2,i].Zeichen:=' ';
               Yb:=Yb-1;
              end;
             end;
            end;
  end;
 until ((Ex<=255) and (Ex in Ni)) or ((Ex>255) and (Ex div 256 in Ho));
 EditBox:=Ex;
end;

procedure NamenEdit(Var dsl:DslZeiger;Var Change:Boolean);
{Hier werden nachtrglich die Schlsselname editiert.
 bergeben werden mu dafr nur ein Zeiger auf dsltyp. Ein Datei-Zeiger ist
 hierfr nicht ntig.
 Change wird nur dann auf true gesetzt, wenn wirklich etwas verndert wurde.}
Var Namen,Ed:Datentyp;
    i,j,dy,Code,l,y1,y2:Integer;
    P:PBildschirm;
    Auto :Boolean;
    Ex,Starter,yb,yi:Word;
    tmp,s:String;


begin
 p:=localScreen;
 if dsl^.SZahl >14 then dy:=14
                   else dy:=dsl^.SZahl;
 {Mehr als 14 Zeilen knnen nicht editiert werden}
 y1:=3+ (16- dy) div 2;   {y1- Zeile frs Fenster}
 y2:=dy+y1+3;             {y2- Zeile frs Fenster}
 MakeBox(10,70,y1,y2,$70,doppelt,'Schlsselnamen editieren',p);
 y1:=y1+1;
 i:=dsl^.SZahl;  {Anzahl Schlssel}
 j:=1;
 while i>=10 do  {wieviel Stellen als String?}
 begin
  Inc(j);
  i:=i div 10;
 end;
 Ed:=dsl^.SName;  {Alten Schlsselnamen}
 for i:=1 to dsl^.SZahl do
 begin
  Str(i:j,tmp);                   {alle Ziffern mit derselben Lnge}
  Namen[i]:=tmp+'. Schlssel : ';
 end;

 for i:=1 to dy do     {Editierbox vorbereiten:}
 begin
  WriteXY(12,y1+i,Namen[i],P);
  for l:=29 to 67 do p^[y1+i,l].Attr:=$17;
  WriteXY(30,y1+i,copy(Ed[i],1,37),p);
  if length(Ed[i])>37 then p^[y1+i,67].Zeichen:='';
 end;
 WriteXY(1,25,'  ESC : Abbrechen    Alt-B : Beenden',P);
 for l:=37 to 80 do p^[25,l].Zeichen:=' ';
 Auto:=true;
 Starter:=1;
 Yb:=y1+1;
 Y2:=yb+dy-1;
 Yi:=1;
 Ex:=EditBox(30,66,yb,y2,12,kbAltB,Starter,yb,yi,dsl^.SZahl,255,Namen,Ed,Auto,true,[27],[$30],P);
 if Ex<>27 then     {Nun wird gendert, wirklich?}
 begin
  i:=1;
  while i<= Dsl^.SZahl do
  begin
   if Dsl^.SName[i]<>Ed[i] then  {Jetzt wirklich!}
   begin
    Change:=True;
    i:=Dsl^.SZahl+1;
   end;
   i:=i+1;
  end;
  Dsl^.SName:=Ed;
 end;
 HideCursor;
end;

function Nummerlesen(Titel,Text:String;Unten,Oben:LongInt):LongInt;
{Hilfsfunktion zum Ermitteln einer Zahl, die sollte zwischen Unten und Oben
 liegen. Es soll beim Einrichten der Schlssel herausgefunden werden,
 wieviele es denn sein sollen.
 Das ganze Einlesen der Zahl soll auch noch in einem Fenster geschehen.
 Die berschrift ist folgerichtig in Titel zu finden. Damit der Anwender
 wei, was er soll, erscheint vor dem blinkenden Cursor noch etwas Text,
 richtig in Text bergeben.
 Zurckgegeben wird die ermittelte Zahl. Sie knnte auch (Unten-1) sein,
 aber nur bei einem Abbruch anwenderseits.}
Var Scr:BildSchirm;
    P:PBildschirm;
    s,tmp,Message:String;
    Auto:Boolean;
    st,Ex:Word;
    Code,i,Anz,x,dx,x1,x2:Integer;
begin
 Freeze(Scr);
 p:=LocalScreen;
 {generieren des Fensters:}
 x:=length(Text);
 dx:=x+19;
 x1:=(83-dx) div 2;
 x2:=x1+dx-1;
 MakeBox(x1,x2,10,14,$70,Doppelt,Titel,P);
 WriteXY(x1+2,12,Text,P);

 St:=1;
 S:='';
 x1:=x1+x+5;
 x2:=x1+9;
 Auto:=True;
 repeat
  for i:=x1-1 to x2+1 do p^[12,i].Attr:=$17;
  Ex:=EditLine(x1,12,10,St,s,20,AUto,false,[13,27],[],P);
  Val(S,Anz,Code);
  if ((Anz=0) and (Code=0)) or (S='') then Ex:=27;
  if Ex<>27 then
  begin
   if Code<>0 then
    MsgBox($70,'Fehler','Bitte nur Ziffern eingeben')
   else
    if (Anz<Unten) or (Anz>Oben) then  {Falscher Zahlenbereich}
    begin
     Str(Unten,tmp);
     Message:='Bitte eine Zahl zwischen '+tmp+' und ';
     Str(Oben,tmp);
     Message:=Message+tmp+' eingeben';
     MsgBox($70,'Fehler',Message);
     Code:=1;
    end;
  end;
 until (Code=0) or (Ex=27);
 if Ex<>27 then Nummerlesen:=Anz
           else Nummerlesen:=Unten-1;   {Anwender hat abgebrochen}
 Defreeze(Scr);
 HideCursor;
end;

procedure SchlEinr(Var Kopf:DZeiger;Var dsl:DslZeiger;Var Change:Boolean);
{Bevor irgendetwas editiert werden kann, sollen die Schlssel eingerichtet
 werden. Hier wird die Anzahl der Schlssel ermittelt und danach die
 Namen der Schlssel editiert.
 Kopf,dsl die beiden Zeiger fr eine Datei.
 Change wird auf True gesetzt, wenn wirklich etwas passiert ist.}
Var Anz:Integer;
begin
 Anz:=Nummerlesen('Schlssel einrichten','Anzahl der Schlssel :',1,Max_Schluessel);
 if Anz>=1 then
 begin
  Init(Kopf,Dsl,Anz);    {bereite neue Datei vor}
  NamenEdit(dsl,Change);
  if Change then   {alles I.O.}
  {Bem.: Vor Aufruf der Prozedur EchlEinr ist Change garantiert false.}
  begin
   Enable([cmEditieren,cmLoeschen,cmNEdit]);
   Disable([cmEinrichten]);
   if Dsl^.SZahl <MAx_Schluessel then Enable([cmHinzufuegen])
                                 else Disable([cmHinzufuegen]);
  end else    {Anwender hat mal wieder abgebrochen}
  begin
   Erase(Kopf,Dsl);   {alles wieder lschen}
  end;
 end;
end;

procedure OptionEdit(Var Option:Optiontyp);
{Die Optionen knnen editiert werden. Ein/Ausgabe nur die Optionen 'Option'.
 Falls die Option aktiviert werden soll, mu ein 'ja' eingegeben werden,
 andernfalls 'nein'. Alles andere wird abgelehnt.}
Type Hilfsfeld = array[1..6] of Boolean;
Var Op:^Hilfsfeld;
    Namen,Ed,Tester:Datentyp;
    i,j,x1,x2,y1,y2,xn1:Integer;
    p:PBildschirm;
    Scr:Bildschirm;
    Ex,Starter,yi,yb,ymax:Word;
    Auto,Fehler:Boolean;
    f:File of Optiontyp;
begin
 p:=localScreen;
 Freeze(Scr);
 Op:=@Option;  {Nun knnen wir mit Hilfe eines Index auf Option zugreifen}
 YMax:=6;
 {Vorbereiten frs Editieren}
 for i:=1 to YMax do
  if Op^[i] then Ed[i]:='ja'
            else Ed[i]:='nein';
 Namen[1]:='Durch das letzte RETURN einfgen lassen :           ';
 Namen[2]:='Beim Blttern mit dem ersten Schlssel beginnen :   ';
 Namen[3]:='Nach dem Einfgen einen leeren Datensatz anzeigen : ';
 Namen[4]:='Beim Einfgen/ndern einen Datensatz weiter :       ';
 Namen[5]:='Markiertes Editieren :                              ';
 Namen[6]:='Doppelte Datenstze ohne Nachfragen einfgen :      ';
 x1:=5;
 x2:=75;
 y1:=8;
 y2:=17;
 MakeBox(x1,x2,y1,y2,$70,doppelt,'Optionen editieren',p);
 SetStatusLine('  ESC : Abbrechen    Alt-B : Beenden');
 x1:=x1+2;
 y1:=y1+2;
 y2:=y2-2;
 for i:=1 to YMax do
 begin
  WriteXY(x1,y1+i-1,Namen[i],P);
 end;
 xn1:=x1;
 x1:=x1+length(Namen[1])+2;
 x2:=x2-4;
 for i:=x1-1 to x2+1 do
  for j:=y1 to y2 do
   p^[j,i].Attr:=$17;
 for i:=1 to YMax do
  WriteXY(x1,y1+i-1,Ed[i],P);
 Starter:=1;
 yi:=1;
 yb:=y1;
 Auto:=True;

 repeat
  Ex:=EditBox(x1,x2,y1,y2,xn1,kbAltB,Starter,yb,yi,ymax,20,Namen,Ed,Auto,true,[27],[$30],P);
  if Ex=kbAltB then
  begin
   Fehler:=False;
   Tester:=Ed;
   for i:=yMax downto 1 do
   begin
    while (length(Tester[i])>0) and (Tester[i][1]=' ') do Delete(Tester[i],1,1);
    {na ja, wollen mal nicht so streng sein, Leerzeichen am Anfang}
    while Tester[i][length(Tester[i])]=' ' do Delete(Tester[i],Length(Tester[i]),1);
    {und am Ende werden gelscht.}
    if (Up(Tester[i])<>'JA') and (Up(Tester[i])<>'NEIN') then {nur 'ja' oder 'nein'!}
    begin
     Fehler:=True;
     yi:=i;
     yb:=y1+i-1;
    end;
   end;
   if Fehler then
   begin
    MsgBox($70,'Fehler','Bitte nur ''ja'' oder ''nein'' eingeben');
    Ex:=0;
   end;

  end;
 until (Ex=27) or (Ex=kbALtB);
 Defreeze(Scr);
 if Ex=kbAltB then
 begin
  for i:=1 to ymax do
  begin
   if Pos('JA',Up(Ed[i]))<>0 then Op^[i]:=true      {Durchs obige testen, kann der}
                             else Op^[i]:=false;    {Text nur durch Leerzeichen benachbart sein}
  end;
  {Vernderten Optionen noch abspeichern:}
  assign(f,'GuPe.OPT');
  rewrite(f);
  Write(f,Option);
  close(f);
 end;
 HideCursor;
end;

function Suchen(Var Kopf:DZeiger; Var Dsl:DslZeiger;Option:OptionTyp):DZeiger;
{durch Aufruf dieser Funktion kann in der Datei (aus kopf und dsl bestehend)
 nach Schlsseleintrgen gesucht werden. Nach erfolgter Suche knnen alle
 Suchergebnisse betrachtet werden. Der bergabeparameter Option enthlt die
 Editieroptionen.
 Falls nun ein Sucheintrag so spannend ist, da er weiter editiert werden
 mu, so ist dies kein Problem, ein entsprechender Zeiger darauf wird
 zurckgegeben. Falls nur gesucht wurde, so wird NIL zurckgegeben.}
Type PSearch= ^Search;
     Search = record                 {Liste der Suchergebnisse}
               D:DZeiger;
               Nr:LongInt;
               prev,Next:PSearch;
              end;

Var dy,dx,dxe,xn1,y1,y2,x1,x2,i,j,Max,yAltI,yAltb,xa1,ya2:Integer;
    c,Starter,Ex,Yi,Yb,AR,stelle:Word;
    Auto,vorhanden,Ende:Boolean;
    Namen,Ed,NoName,EdAlt:Datentyp;
    P,Scr1,Scr2:PBildschirm;
    tmp,Edit:DZeiger;
    Nr,found:LongInt;
    s:String;
    Sucher : Array[1..Max_Schluessel] of DatenZeiger;
    Helper : Array[1..Max_Schluessel] of PZeiger;
    s1,s2:PSearch;
    Pos:DsZeiger;


 procedure InitScreen(start:Integer);
 {Liest den aktuellen Dateneintrag und gibt auf dem Bildschirm aus.
  Da evtl. gerollt wurde, gibt Starter die Nummer des obersten
  sichtbaren Schlsseleintrages an.}
 Var i,j:Integer;
 begin
  if (Edit<>NIL) and (Edit^.Daten<>NIL) then Konvert(Ed,Edit)
                                        else Ed:=Noname;
  for i:=0 to dy-1 do
  begin
   WriteXY(xn1,y1+i,Namen[start+i],P);
   p^[y1+i,x1-1].Zeichen:=' ';
   WriteXY(x1,y1+i,Copy(Ed[start+i],1,dxe),P);
   for j:=x1+length(Ed[Start+i]) to x2+1 do p^[y1+i,j].Zeichen:=' ';
   if length(Ed[start+i])>dxe then p^[y1+i,x2+1].Zeichen:='';
  end;
 end;

 procedure StatusLineUpdate(Nr:LongInt);
 {Beim Suchen erscheint eine eigene Stauszeile. Sie wird hiermit
  auf den aktuellsten Stand gebracht.}
 Var i,j:Integer;
     Message,tmp:String;
 begin
  str(found,tmp);
  Message:='  Anzahl gefundene Datenstze : '+tmp+'    aktueller Datensatz : ';
  Str(Nr,tmp);
  Message:=Message+tmp;
  WriteXY(1,25,Message,P);
  for j:=length(Message)+1 to 80 do p^[25,j].Zeichen:=' ';

 end;


begin
 New(Scr1);
 New(Scr2);
 Freeze(Scr1^);  {erstmal Bildschirm sichern}
 if dsl^.SZahl >12 then dy:=12                  {maximale Editierzeilen}
                   else dy:=Dsl^.SZahl;         {festlegen}
 Max:=0;
 for i:=1 to Dsl^.SZahl do
 begin
  NoName[i]:='';
  Namen[i]:=Dsl^.SNAme[i]+' :';
  if length(Namen[i])>Max then Max:=Length(Namen[i]);
  {Hier wird die maximale Lnge des Schlsselbezeichenrs ermittelt.
   Beim Editieren sollte ja alles einheitlich sein.}
 end;
 if Max>30 then   {Mehr als 30 Zeichen pat nicht mehr auf den Bildschirm,
                   es soll ja auch noch Platz zum Editieren sein.}
 begin
  Max:=30;
  for i:=1 to Dsl^.SZahl do
  begin
   if length(Namen[i])>Max then
   begin
    Delete(Namen[i],Max-5,255);
    Namen[i]:=Namen[i]+'... :';
   end;
  end;
 end;
 for i:=1 to Dsl^.SZahl do
  while length(Namen[i])<Max do Namen[i]:=Namen[i]+' ';  {Einheitliche Lnge}
 P:=LocalScreen;
 {Fenster vorbereiten:}
 x1:=5;
 x2:=75;
 y1:=4+ (12- dy) div 2;
 y2:=dy+y1+6;
 MakeBox(x1,x2,y1,y2,$70,doppelt,'Datenstze suchen',P);

 for i:=x1+1 to x2-1 do
 begin
  p^[y2-1,i].Attr:=$17;
  p^[y2-2,i].Attr:=$17;
 end;
 SetStatusLine('  ESC : Abbrechen    Alt-S : Suche beginnen');
 ya2:=y2;
 xa1:=x1;
 WriteXY(x1+3,y2-2,
 'Wenn alle vorhandenen Datenstze eines Schlssels gesucht werden',P);
 WriteXY(x1+3,y2-1,
 'sollen, so geben Sie bei diesem Schlssel nichts ein.',P);
 y1:=y1+1;
 xn1:=x1+3;
 x1:=xn1+Max+3;
 x2:=x2-4;
 dxe:=x2-x1+1;
 for i:=0 to dy-1 do
  for j:=x1-1 to x2+1 do p^[y1+1+i,j].Attr:=$17;
 Yb:=y1+1;
 y1:=y1+1;
 YI:=1;
 Starter:=1;
 y2:=y2-5;

 Auto:=True;
 Edit:=Nil;
 Suchen:=Nil;
 if Option.AutoRet then AR:=kbAltS
                   else AR:=0;
 InitScreen(1);
 repeat

  Ex:=EditBox(x1,x2,y1,y2,xn1,AR,Starter,yb,yi,dsl^.SZahl,MaxLength,Namen,Ed,Auto,Option.marked,
              [27],[$1F],P);
  yaltI:=yi;
  yaltb:=yb;
  EdAlt:=Ed;
  Case Ex of
   kbAltS : begin         {offensichtlich soll nun gesucht werden}
             vorhanden:=False;
             i:=1;
             repeat
              {Hier wird gecheckt, ob der Anwender tatschlich etwas zum
               Suchen eingeben hat.}
              vorhanden:=(Ed[i]<>'');
              Inc(i);
             until (Vorhanden) or (i>dsl^.SZAhl);
             if not(Vorhanden) then
             begin
              MsgBox($70,'Information','Bitte einen zu suchenden Schls- seleintrag angeben.');
             end else
             begin
              {Jetzt mu gesucht werden}
              HideCursor;
              for i:=1 to Dsl^.SZahl do
              begin
               Pos:=dsl^.SPosition[i];    {Suche fr jeden Schlssel die
                                           Suchmaske}
               Suche(Pos,Ed[i],vorhanden,Stelle);
               if vorhanden then
               begin
                Sucher[i]:=Pos^.Daten[Stelle];   {Wurde gefunden}
               end else
                Sucher[i]:=Nil;     {nix gefunden}
              end;
              i:=1;

              vorhanden:=true;
              {Jetzt mssen die bisherigen Suchergebnisse noch miteinander
               verknpft werdem.}
              repeat
               if (Sucher[i]=NIL) and (Ed[i]<>'') then
               {Die Suchmaske wurde nicht gefunden}
               begin
                i:=dsl^.SZahl;   {brauchen gar nicht weiter checken}
                Vorhanden:=False;
               end;
               Inc(i);
              until  i>Dsl^.SZahl;
              if vorhanden then

              begin
               stelle:=1;
               for i:=1 to dsl^.SZahl do
                if (Sucher[i]=NIl) or (Ed[i]='') then Helper[i]:=Nil
                                                 else Helper[i]:=Sucher[i]^.Poslist;
               while (Helper[stelle]=Nil) and(Stelle<=dsl^.SZAhl) do Inc(stelle);
               {Stelle : erste echt zu suchende Schlssel}
              end;
              if (not(Vorhanden)) then
              begin
               if AskBox($70,$74,'Information','Datensatz nicht vorhanden.'+#13+
                                               'Noch eine weitere Suche?','JN') ='N' then Ex:=27;
              end else
              begin
               {Jetzt mu das Suchergebnis noch mit 'UND' verknpft werden}

               s1:=Nil;
               s2:=Nil;

               Ende:=False;
               found:=0;   {Anzahl gefundener Datenstze}
               repeat
                vorhanden:=false;
                Ende:=Helper[Stelle]=NIL;
                if not(Ende) then
                begin
                 Nr:=Helper[stelle]^.Position^.Nr;
                 j:=Stelle+1;
                 vorhanden:=true;  {ob wirklich etwas zusammenpat}
                 while (J<=dsl^.SZahl) and vorhanden do
                 {Hier wird jetzt mit 'UND' verknpft:}
                 begin
                  if Ed[j]<>'' then
                  begin
                   while (Helper[j]<>NIL) and( Helper[j]^.Position^.Nr <Nr) Do
                    Helper[j]:=Helper[j]^.Nach;
                   vorhanden:= (Helper[j]<>NIL) and (Helper[j]^.Position^.Nr=Nr);
                   Ende:=Ende or (Helper[j]=NIL);
                  end;
                  Inc(j);
                 end;
                 if vorhanden then
                 {Ein weiterer Datensatz pat zur Suchmaske und mu
                  nun in die Liste der Suchergebnisse eingefgt
                  werden, bzw. falls die Liste noch leer ist,
                  mu sie erst erzeugt werden.}
                 begin
                  Inc(found);
                  if s2=nil then
                  begin
                   New(s1);
                   s1^.prev:=NIL;
                   s1^.D:=Helper[Stelle]^.Position;
                   s1^.Nr:=found;
                   s1^.Next:=Nil;
                   s2:=s1;
                  end else
                  begin
                   New(s1^.Next);
                   s1^.Next^.Prev:=s1;
                   s1:=s1^.Next;
                   s1^.Next:=Nil;
                   s1^.D:=Helper[Stelle]^.Position;
                   s1^.Nr:=found;
                  end;
                 end;
                 Helper[stelle]:=Helper[Stelle]^.Nach;
                end;
               until Ende;

               s1:=s2;
               if s1=Nil then
               begin
                if AskBox($70,$74,'Information','Datensatz nicht vorhanden.'+#13+
                                                'Noch eine weitere Suche?','JN') ='N' then Ex:=27;
               end else
               begin
                {Es wurde etwas gefunden. Nun mu es noch auf dem Bildschirm
                 gebracht werden:}
                Edit:=s2^.d;
                Freeze(Scr2^);
                InitScreen(yi+y1-yb);
                yi:=yi+y1-yb;
                yb:=y1;
                StatusLineUpdate(1);
                WriteXY(xa1+3,ya2-2,
                'neue Suche    Editieren    Nummer    Beenden                    ',P);
                if Dsl^.SZahl >dy then
                begin
                 WriteXY(56,ya2-2,'/ : Rollen',P);
                 p^[ya2-2,56].Attr:=$1D;
                 p^[ya2-2,58].Attr:=$1D;
                end;
                WriteXY(29,y1-2,' Suchergebnis anzeigen ',P);
                p^[ya2-2,xa1+8].Attr:=$1D;
                p^[ya2-2,xa1+17].Attr:=$1D;
                p^[ya2-2,xa1+30].Attr:=$1D;
                p^[ya2-2,xa1+40].Attr:=$1D;

                WriteXYColor(xa1+3,ya2-1,$1D,'PgUp/PgDn',P);
                WriteXY(xa1+12,ya2-1,' : Blttern    ',P);
                WriteXYColor(xa1+26,ya2-1,$1D,'Strg-Pos1/Strg-Ende',P);
                WriteXY(xa1+45,ya2-1,' : 1./letzten Datensatz',P);
                p^[ya2-1,xa1+7].Attr:=$17;
                p^[ya2-1,xa1+34].Attr:=$17;
                repeat
                 getkey(c);
                 Case c of
                  kbAltB : c:=kbESC;  {Beenden}
                  kbAltN : begin      {Direkte Nummerwahl}
                            if found>1 then
                            begin
                             Nr:=NummerLesen('Direkte Datensatzwahl','Zu welchem gefundenen Datensatz springen :',1,found);
                             if Nr<>0 then
                             begin
                              s2:=s1;
                              for j:=2 to Nr do s2:=s2^.Next;
                              Edit:=s2^.d;
                              InitScreen(yi+y1-yb);
                              StatusLineUpdate(s2^.Nr);
                             end;
                            end;
                           end;
                  kbUp   : begin         {nach oben rollen, sofern mglich}
                            if yi>1 then
                            begin
                             yi:=yi-1;
                             InitScreen(yi+y1-yb);
                            end;
                           end;
                  kbDown : begin         {nach unten rollen, sofern mglich}
                            if yi+dy-1<dsl^.SZahl then
                            begin
                             yi:=yi+1;
                             InitScreen(yi+y1-yb);
                            end;
                           end;
                  kbPgUp : begin         {In der Suchliste eine Position zurck}
                            if s2^.Prev<>Nil then
                            begin
                             s2:=s2^.Prev;
                             Edit:=s2^.d;
                             InitScreen(yi+y1-yb);
                             StatusLineUpdate(s2^.Nr);
                            end;
                           end;
                  kbPgDn : begin         {In der Suchliste eins weiter}
                            if s2^.Next<>nil then
                            begin
                             s2:=s2^.Next;
                             Edit:=s2^.d;
                             InitScreen(yi+y1-yb);
                             StatusLineUpdate(s2^.Nr);
                            end;
                           end;
                  kbStrgHome : begin    {In der Suchliste das erste}
                                s2:=s1;
                                Edit:=s2^.d;
                                InitScreen(yi+y1-yb);
                                StatusLineUpdate(s2^.Nr);
                               end;
                  kbStrgEnd  : begin   {In der Suchliste das letzte Element}
                                while s2^.Next<>nil do s2:=s2^.Next;
                                Edit:=s2^.d;
                                InitScreen(yi+y1-yb);
                                StatusLineUpdate(s2^.Nr)
                               end;
                end;
                until (c=kbEsc) or (c=kbAltS) or (c=kbAltE);
                Case c of
                 kbESC  : Ex:=27;       {Beenden}
                 kbAltS : begin         {Neue Suche}
                           Ex:=0;
                           yi:=yAlti;
                           yb:=yAltb;
                           Ed:=EdAlt;
                          end;
                 kbAltE : begin         {Ergebnis editieren}
                           Ex:=27;
                           Suchen:=s2^.d;
                          end;
                end;
                Defreeze(Scr2^);
                s2:=s1;
                while s1<>nil do
                begin
                 s2:=s1;
                 s1:=s1^.Next;
                 dispose(s2);
                end;
               end;
              end;
             end;
            end;
  end;
 until (Ex=27) or (Ex=kbAltB);
 HideCursor;
 Defreeze(Scr1^);
 Dispose(Scr1);
 Dispose(Scr2);
end;


procedure Editieren(Var Kopf,Edit:DZeiger; Var Dsl:DslZeiger;Var Option:Optiontyp;
                    Var Change:Boolean);
{Diese Prozedure startet den Editor. Neben den blichen Zeigern Kopf und dsl
 gibt es hier noch Edit, das ist der aktuelle Editierdatensatz. Dies hat den
 Vorteil, da nach einem erneutem Aufruf dieser Prozedur an der selben Stelle
 weiter editiert wird. Option sind die Editieroptionen. Change wird dann auf
 true gesetzt, wenn etwas verndert wurde.}
Var dy,dx,dxe,xn1,y1,y2,x1,x2,i,j,Max:Integer;
    c,Starter,Ex,Yi,Yb,AR:Word;
    Auto:Boolean;
    Namen,Ed,NoName:Datentyp;
    P:PBildschirm;
    tmp:DZeiger;
    Nr:LongInt;
    s:String;

 procedure InitScreen(start:Integer);
 {Liest den aktuellen Dateneintrag und gibt auf dem Bildschirm aus.
  Da evtl. gerollt wurde, gibt Starter die Nummer des obersten
  sichtbaren Schlsseleintrages an.}
 Var i,j:Integer;
 begin
  if (Edit^.Daten= Nil) then Ed:=NoName
                        else Konvert(Ed,Edit);

  for i:=0 to dy-1 do
  begin
   WriteXY(xn1,y1+i,Namen[start+i],P);
   p^[y1+i,x1-1].Zeichen:=' ';
   WriteXY(x1,y1+i,Copy(Ed[start+i],1,dxe),P);
   for j:=x1+length(Ed[Start+i]) to x2+1 do p^[y1+i,j].Zeichen:=' ';
   if length(Ed[start+i])>dxe then p^[y1+i,x2+1].Zeichen:='';
  end;
 end;

 procedure StatusLineUpdate;
 {Beim Editieren erscheint eine eigene Stauszeile. Sie wird hiermit
  auf den aktuellsten Stand gebracht.}
 Var i,j:Integer;
     Message,tmp:String;
 begin
  str(dsl^.DSAnz,tmp);
  Message:='  Anzahl Datenstze : '+tmp+'    aktueller Datensatz : ';
  Str(Edit^.Nr,tmp);
  Message:=Message+tmp;
  WriteXY(1,25,Message,P);
  for j:=length(Message)+1 to 80 do p^[25,j].Zeichen:=' ';

 end;


begin
 if dsl^.SZahl >12 then dy:=12           {Mehr als 12 Zeilen knnen}
                   else dy:=Dsl^.SZahl;  {nicht editiert werden}
 Max:=0;
 for i:=1 to Dsl^.SZahl do
 begin
  NoName[i]:='';
  Namen[i]:=Dsl^.SNAme[i]+' :';
  if length(Namen[i])>Max then Max:=Length(Namen[i]);
 end;
 if Max>30 then       {Schlsslebezeichner lnger als 30 Zeichen ist
                       zu viel, es bliebe kein Platz zum Editieren}
 begin
  Max:=30;
  for i:=1 to Dsl^.SZahl do
  begin
   if length(Namen[i])>Max then
   begin
    Delete(Namen[i],Max-5,255);
    Namen[i]:=Namen[i]+'... :';
   end;
  end;
 end;
 for i:=1 to Dsl^.SZahl do
  while length(Namen[i])<Max do Namen[i]:=Namen[i]+' ';
 P:=LocalScreen;
 x1:=5;
 x2:=75;
 y1:=4+ (12- dy) div 2;
 y2:=dy+y1+6;

 MakeBox(x1,x2,y1,y2,$70,doppelt,'Datenstze editieren',P);
 for i:=x1+1 to x2-1 do
 begin
  p^[y2-1,i].Attr:=$17;
  p^[y2-2,i].Attr:=$17;
 end;
 WriteXY(x1+3,y2-2,'Einfgen   Lschen   ndern   Optionen   Suchen   Nummer  Beenden',P);

 p^[y2-2,x1+3].Attr:=$1D;
 p^[y2-2,x1+14].Attr:=$1D;
 p^[y2-2,x1+26].Attr:=$1D;
 p^[y2-2,x1+33].Attr:=$1D;
 p^[y2-2,x1+44].Attr:=$1D;
 p^[y2-2,x1+53].Attr:=$1D;
 p^[y2-2,x1+61].Attr:=$1D;
 WriteXYColor(x1+3,y2-1,$1D,'PgUp/PgDn',P);
 WriteXY(x1+13,y2-1,': Blttern',P);
 WriteXYColor(x1+26,y2-1,$1D,'Strg-Pos1/Strg-Ende',P);
 WriteXY(x1+46,y2-1,': 1./letzten Datensatz',P);
 p^[y2-1,x1+7].Attr:=$17;
 p^[y2-1,x1+35].Attr:=$17;
 y1:=y1+1;
 xn1:=x1+3;
 x1:=xn1+Max+3;
 x2:=x2-4;
 dxe:=x2-x1+1;
 for i:=0 to dy-1 do
  for j:=x1-1 to x2+1 do p^[y1+1+i,j].Attr:=$17;
 Yb:=y1+1;
 y1:=y1+1;
 YI:=1;
 Starter:=1;
 y2:=y2-5;
 Auto:=True;
 if Option.AutoRet then AR:=kbAltE
                   else AR:=0;
 InitScreen(1);
 {Alles wurde vorbereitet, jetzt geht's ans Editieren:}
 repeat
  StatusLineUpdate;
  Ex:=EditBox(x1,x2,y1,y2,xn1,AR,Starter,yb,yi,dsl^.SZahl,MaxLength,Namen,Ed,Auto,Option.marked,
              [27],[$12,$26,$20,$18,$1F,$31,$30,$49,$51,$77,$75],P);
  If (Ex=kbAltD) and ((dsl^.dsanz=0) or (Option.Autoclear)) then Ex:=kbAltE;
  {ndern in leerer Datei oder nach ausfllen eines leeren DS=> einfgen.}
  Case Ex of
   kbAltE : begin    {Einfgen}
             tmp:=ds_einf(Kopf,dsl,Ed,Option.double);
             if tmp<>nil then
             begin
              Change:=True;
              Edit:=tmp;
              if (Options.AutoAdv) and (Edit^.Nach<>NIL) then Edit:=Edit^.Nach;
              if Options.AutoFirst then
              begin
               yi:=1;
               YB:=Y1;
              end;
              if (Options.AutoClear) then
              begin
               Ed:=NoName;
               for i:=0 to dy-1 do
               begin
                WriteXY(xn1,y1+i,Namen[yi+y1-yb+i],P);
                p^[y1+i,x1-1].Zeichen:=' ';
                for j:=x1 to x2+1 do p^[y1+i,j].Zeichen:=' ';
               end;
              end else
               InitScreen(yi+y1-yb);
             end;
            end;
   kbAltL : begin      {Lschen}
             if Edit^.Daten<>nil then
             begin
              tmp:=Edit^.Vor;  {Nach Lschen eines Datensatzes wird der
                                vorherige editiert.}
              Change:=True;
              ds_Loeschen(dsl,Edit);
              if (tmp^.Nr=0) and (tmp^.Nach<>nil) then tmp:=tmp^.Nach;
              Edit:=tmp;
              InitScreen(yi+y1-yb);
             end;
            end;
   kbAltD : begin      {ndern}
             if Edit^.Daten<>nil then
             begin
              Change:=True;
              if (Options.AutoAdv)  then
              begin
               if (Edit^.Nach<>NIL) then
               begin
                tmp:=Edit^.Nach;   {einfach einen Datensatz weiter}
                ds_aendern(Kopf,Edit,dsl,Ed);;
               end else
               begin
                tmp:=ds_aendern(Kopf,Edit,dsl,Ed);
                while tmp^.Nach <>nil do tmp:=tmp^.Nach; {bis ans Ende}
               end;
               Edit:=tmp;
              end else
               Edit:=ds_aendern(Kopf,Edit,dsl,Ed);
              InitScreen(yi+y1-yb);
             end;
            end;
   kbAltO : begin       {Optionen werden neu ausgemacht}
             OptionEdit(Option);
             if Option.AutoRet then AR:=kbAltE   {AutoReturn festlegen}
                               else AR:=0;
            end;
   kbAltS : begin       {Suchen}
             tmp:=Suchen(Kopf,Dsl,Option);
             if tmp<>nil then   {Dann der Fall, wenn das Suchergebnis
                                 editiert werden soll}
             begin
              Edit:=tmp;
              if Options.AutoFirst then
              begin
               yi:=1;
               YB:=Y1;
              end;
              InitScreen(yi+y1-yb);
             end;
            end;
   kbAltN : begin      {Direkte Nummerangabe}
             if dsl^.DSAnz>1 then
             begin
              Nr:=NummerLesen('Direkte Datensatzwahl','Zu welchem Datensatz springen :',1,Dsl^.DSAnz);
              if Nr<>0 then
              begin
               Edit:=Kopf;
               while Edit^.Nr<>Nr Do Edit:=Edit^.Nach; {Durchlaufe Liste bis
                                                        gefunden}
               InitScreen(yi+y1-yb);
              end;
             end;
            end;
   kbPgUp : begin     {Einen Datensatz zurck}
             if Edit^.Nr>1 then  {Nur mglich, wenn nicht schon am Anfang}
             begin
              Edit:=Edit^.Vor;
              if Options.AutoFirst then
              begin
               yi:=1;
               YB:=Y1;
              end;
              InitScreen(yi+y1-yb);
             end;
            end;
   kbPgDn : begin     {Einen Datensatz weiter}
             If (Edit<>nil) and (Edit^.Nach<>NIL) then {Nur mglich, wenn nicht am Ende}
             begin
              Edit:=Edit^.Nach;
              if Options.AutoFirst then
              begin
               yi:=1;
               YB:=Y1;
              end;
              InitScreen(yi+y1-yb);
             end;
            end;
   kbStrgHome : begin   {zum ersten Datensatz}
                 if Dsl^.DSAnz>0 then      {bei einer leeren Datei gibt}
                 begin                     {es nichts zu tun}
                  Edit:=Kopf^.Nach;
                  if Options.AutoFirst then
                  begin
                   yi:=1;
                   YB:=Y1;
                  end;
                  InitScreen(yi+y1-yb);
                 end;
                end;
   kbStrgEnd  : begin   {zum letzten Datensatz}
                 if dsl^.DSAnz>0 then  {Datei nicht leer??}
                 begin
                  while Edit^.Nach<> nil do Edit:=Edit^.Nach;
                  if Options.AutoFirst then
                  begin
                   yi:=1;
                   YB:=Y1;
                  end;
                  InitScreen(yi+y1-yb);
                 end;
                end;
  end;
 until (Ex=27) or (Ex=kbAltB);
 HideCursor;
end;

function CheckSave(Var DateiName:String;Var Change:Boolean;Kopf:DZeiger;
                   Dsl:DslZeiger):Boolean;
{Bei einer Vernderung in einer Datei, soll der Anwender gewarnt werden,
 falls er dabei ist, die Datei durch z.B. ffnen einer anderen Datei zu
 zerstren. Die Notwendigkeit dieser Warnung wird in Change bergeben.
 DateiName gibt den aktuellen Dateinamen an, Da evtl. noch keiner vorhanden
 ist und erst in dieser Funktion ermittelt wird, mu er natrlich auch
 zurckgeben werden. Ferner bentigen wir hier natrlich unsere bekannte
 Datei: Kopf und dsl.
 Diese Funktion gibt true zurck, falls alles klar ist und die eigentliche
 Aktion des Anwenders kann fortgefahren werden. Bei False hat sich der
 Anwender dazu entschieden doch lieber abzubrechen.}
Var Msg,AltName:String;
    Ch : Char;
begin
 if Change=false then   {Es lag keine Vernderung vor, alles O.K.}
  CheckSave:=True
 else
 begin
  if (Dsl<>Nil) and (Dsl^.DSAnz>0) then  {wirklich eine Datei vorhanden}
  begin
   if DateiName='' then Msg:='unbenannte Datei'
                   else Msg:='Datei '+MaxDatLen(DateiName,35);
   Msg:=Msg+' wurde gendert. Speichern?';
   Ch:=AskBox($70,$74,'Warnung',Msg,'JNA');
   {Auswerten der Warnbox:}
   Case Ch of
    'A' : CheckSave:=false;   {Abbruch}
    'N' : CheckSave:=True;    {Vernderung verwerfen}
    'J' : begin               {doch lieber abspeichern}
           CheckSave:=True;
           if DateiName<>'' then  {Dateiname schon vorhanden, alles O.K}
           begin
            Speichern(Kopf,dsl,DateiName);
            Change:=false;
           end
           else
           begin
            AltName:=DateiName;
            Ch:=SpeichernUnter(Kopf,dsl,DateiName);
            if Ch='A' then        {Abbruch}
            begin
             CheckSave:=False;
             DateiName:=AltName;
            end;
            if Ch='J' then         {gespeichert}
            begin
             SetStatusLine('');
             Change:=False;
            end;
           end;
          end;
   end;
  end else   {leere Datei, die brauchen wir nicht abspeichern}
   CheckSave:=True;
 end ;
end;

function ChooseNumber(Var Ed:Datentyp;Titel:String;Max:Word;Chooser:Boolean):Word;
{Beim Lschen und Hinzufgen eines Schlssels, mu ja die Position des
 neuen Schlssels bzw. des zu lschenden Schlssels ermittelt werden.
 Das macht diese Funktion, sie gibt die Nummer des Schlssels zurck.
 Falls aber die Aktion mal wieder abgebrochen wurde, so wird 0 zurckgeliefert.
 Im Array Ed sind die Bezeichner des Schlssel abgespeichert.
 Titel ist eine Zeichenkette fr die Fensterberschrift (die Funktion
 wird ja von 2 verschiedenen Funktionen aufgerfufen. Das ist in Chooser
 gespeichert: True <=> soll hinzugefgt werden, false<=> soll gelscht
 werden. In Max sind die Anzahl der Schlssel enthalten.}
Var i,j,c:Word;
    x1,x2,y1,y2,dy,dx,yb,yi:Integer;
    p:PBildschirm;

 procedure Mark(yPos:Integer);
 {Markieren: die yPos}
 Var i:Integer;
 begin
  for i:=x1 to x2 do p^[yPos,i].Attr:=$07;
 end;

 procedure DeMark(YPos:Integer);
 {Markierung des YPos-Zeilenausschnittes aufheben}
 Var i:Integer;
 begin
  for i:=x1 to x2 do p^[YPos,i].Attr:=$70;
 end;

begin
 {Fenster vorbereiten}
 j:=length(Titel)+10;
 p:=localScreen;
 for i:=1 to Max do if length(Ed[i])>j then j:=length(Ed[i]);
 if j>50 then dx:=50
         else dx:=j;
 if Max>14 then Dy:=14
           else dy:=Max;
 for i:=1 to Max do
 begin
  if length(Ed[i]) > dx then Ed[i]:=copy(Ed[i],1,dx-3)+'...'
                        else while length(Ed[i])<dx do Ed[i]:=Ed[i]+' ';
 end;
 y1:=3+ (16- dy) div 2;
 y2:=dy+y1+3;
 x1:=7+(62-dx) div 2;
 x2:=x1+dx+3;
 if Chooser then
  SetStatusLine('  / : Auswhlen     ENTER : Hier Hinzufgen     ESC : Abbrechen')
 else
  SetStatusLine('  / : Auswhlen     ENTER : Lschen     ESC : Abbrechen');
 MakeBox(x1,x2,y1,y2,$70,doppelt,Titel,p);
 x1:=x1+2;
 y1:=y1+1;
 for i:=1 to dy do
  WriteXY(x1,y1+i,Ed[i],P);
 yb:=y1+1;
 x2:=x2-1;
 x1:=x1-1;
 y1:=yb;
 y2:=yb+dy-1;
 yi:=1;
 Mark(yb);
 repeat
  Getkey(c);
  Case c of
  kbDown  : begin   {Einen Schlssel runter}
             if yi<Max then
             begin
              yi:=yi+1;
              if yb<y2 then
              begin
               DeMark(yb);
               yb:=yb+1;
               Mark(yb);
              end else  {rollen}
              begin
               for j:=y1 to y2-1 do
                for i:=x1+1 to x2-1 do p^[j,i].Zeichen:=p^[j+1,i].Zeichen;
               WriteXY(x1+1,yb,Ed[yi],P);
              end;
             end;
            end;
  kbUp    : begin   {Einen Schlssel hoch}
             if yi>1 then
             begin
              yi:=yi-1;
              if yb>y1 then
              begin
               DeMark(yb);
               yb:=yb-1;
               Mark(yb);
              end else     {rollen}
              begin
               for j:=y2 downto y1+1 do
                for i:=x1+1 to x2-1 do p^[j,i].Zeichen:=p^[j-1,i].Zeichen;
               WriteXY(x1+1,yb,Ed[yi],P);
              end;
             end;
            end;
  kbEnter : begin   {Auswahl treffen}
             ChooseNumber:=yi;
            end;
  kbEsc   : begin   {Abbruch}
             ChooseNumber:=0;
            end;
 end;
 until  (c=kbEsc) or (c=kbEnter);
end;

function SchluesselLoeschen(Var Kopf:DZeiger;Var Dsl:DslZeiger;Var Change:Boolean):Boolean;
{Aus der Datei (Kopf,dsl) soll ein Schlssel gelscht werden. Change wird
 auf true gesetzt, falls wirklich etwas gelscht wurde.
 Die Funktion gibt true zurck <=> ein Schlssel wurde gelscht.}
Var Ed:Datentyp;
    Nr:Word;
begin
 SchluesselLoeschen:=False;
 Ed:=Dsl^.SName;
 Nr:=ChooseNumber(Ed,'Schlssel lschen',dsl^.SZahl,false);
 if Nr>0 then
 begin
  SchluesselLoeschen:=True;
  Change:=True;
  if dsl^.SZahl>1 then    {Lsche Schlssel}
  begin
   SetStatusLine('  Lsche Schlssel : '+Ed[Nr]);
   Schl_Loesch(dsl,Kopf,Nr);
   if dsl^.SZahl <Max_Schluessel then Enable([cmHinzufuegen]);
  end
  else
  begin   {war letzter Schlssel, also lsche Datei}
   Erase(kopf,Dsl);
   Disable([cmSpeichern, cmSpUnter, cmEditieren, cmNEdit, cmHinzufuegen, cmLoeschen]);
   Enable([cmEinrichten]);
   Change:=False;
  end;
 end;
end;

function SchluesselHinzufuegen(Var Kopf:DZeiger;Var Dsl:DslZeiger;Var Change:Boolean):Boolean;
{In der Datei (Kopf,dsl) soll ein Schlssel hinzugefgt werden. Change wird
 auf true gesetzt, falls wirklich ein Schlssel hinzugefgt wurde.
 Die Funktion gibt true zurck <=> ein Schlssel wurde gelscht.}
Var Name,Ed:Datentyp;
    P:PBildschirm;
    Nr,Ex,Starter,yb,yi:Word;
    i,j:Integer;
    Auto:Boolean;
begin
 SchluesselHinzufuegen:=False;
 Ed:=Dsl^.SName;
 Ed[dsl^.SZahl+1]:='';
 P:=LocalScreen;
 Nr:=ChooseNumber(Ed,'Schlssel hinzufgen',dsl^.SZahl+1,true);
 if Nr>0 then
 begin
  Ed[1]:='';       {Schlssel-bezeichner}
  Ed[2]:='-';      {alle Datenstze werden damit gefllt}
  Name[1]:='Diesen Schlssel :            ';
  Name[2]:='mit diesem Eintrag hinzufgen :';
  SetStatusLine('  ESC : Abbrechen     Alt-B : Hinzufgen');
  {Fenster vorbereiten}
  MakeBox(6,72,10,15,$70,doppelt,'Neuen Schlssel einrichten',P);
  for i:=1 to 2 do
  begin
   WriteXY(9,i+11,Name[i],P);
   WriteXY(43,i+11,Ed[i],P);
   for j:=42 to 69 do p^[i+11,j].Attr:=$17;
  end;
  Starter:=1;
  Yi:=1;
  Yb:=12;
  Auto:=True;
  {Bezeichner und globalen Fller editieren}
  Ex:=EditBox(43,68,12,13,9,kbALtB,Starter,yb,yi,2,MaxLength,Name,Ed,Auto,true,[27],[$30],P);
  HideCursor;
  if Ex<>27 then  {Nun wird hinzugefgt}
  begin
   SchluesselHinzufuegen:=True;
   SetStatusLine('  Fge Schlssel hinzu : '+Ed[1]);
   Schl_Hinzuf(Dsl,Kopf,Ed[1],Ed[2],Nr);
   Change:=true;
   if Dsl^.SZahl=Max_Schluessel then Disable([cmHinzufuegen]);
  end;
 end;
end;


function SchluesselUmsortieren(Var Kopf:DZeiger;Var Dsl:DslZeiger;
                               Var Change:Boolean):Boolean;
{Manschmal kommt es vor, da die Prioritten der Schlssel gendert
 werden mssen. Mit Hilfe dieser Prozedur wird die neue Ordnung festgelegt.
 In der Datei (Kopf,dsl) sollen die Schlssel umsortiert werden. Change wird
 auf true gesetzt, falls wirklich umsortiert wurde.
 Die Funktion gibt true zurck <=> Eine Umsortierung fand statt.}
Const Titel='Schlssel umsortieren';
Var i,j,c,Max,Nr,Selected:Word;
    x1,x2,y1,y2,dy,dx,yb,yi:Integer;
    p:PBildschirm;
    Ed:Datentyp;
    s:String;
    Prior:Prior_Typ;
    Sort:Boolean;

 procedure Mark(yPos:Integer);
 {Markiere Zeile YPos}
 Var i:Integer;
 begin
  for i:=x1 to x2 do p^[yPos,i].Attr:=$07;
 end;

 procedure DeMark(YPos:Integer);
 {Hebe Markierung des Schlssels in Zeile YPos wieder auf}
 Var i:Integer;
 begin
  for i:=x1 to x2 do p^[YPos,i].Attr:=$70;
 end;

begin
 Ed:=Dsl^.SName;
 Max:=dsl^.SZahl;
 j:=length(Titel)+10;
 p:=localScreen;
 i:=dsl^.SZahl;
 Nr:=1;
 while i>=10 do
 begin
  Inc(Nr);
  i:=i div 10;
 end;
 Nr:=Nr+2;
 for i:=1 to Max do if length(Ed[i])+Nr>j then j:=length(Ed[i])+Nr;
 if j>50 then dx:=50
         else dx:=j;
 if Max>14 then Dy:=14
           else dy:=Max;
 Nr:=Nr-2;
 for i:=1 to Max do
 begin
  if length(Ed[i]) > dx-Nr then Ed[i]:=copy(Ed[i],1,dx-3-Nr)+'...';
  while length(Ed[i])<dx do Ed[i]:=Ed[i]+' ';
  Prior[i]:=0;
 end;
 y1:=3+ (16- dy) div 2;
 y2:=dy+y1+3;
 x1:=7+(62-dx) div 2;
 x2:=x1+dx+3;
 SetStatusLine
 ('  ESC : Abbrechen    ENTER : Reihenfolge festlegen    Alt-S : Sortieren');
 MakeBox(x1,x2,y1,y2,$70,doppelt,Titel,p);
 x1:=x1+2;
 y1:=y1+1;
 for i:=1 to dy do
  WriteXY(x1,y1+i,Ed[i],P);
 yb:=y1+1;
 x2:=x2-1;
 x1:=x1-1;
 y1:=yb;
 y2:=yb+dy-1;
 yi:=1;
 Mark(yb);
 Selected:=1;
 repeat
  Getkey(c);
  Case c of
  kbDown  : begin          {einen runter}
             if yi<Max then
             begin
              yi:=yi+1;
              if yb<y2 then
              begin
               DeMark(yb);
               yb:=yb+1;
               Mark(yb);
              end else      {rollen}
              begin
               for j:=y1 to y2-1 do
                for i:=x1+1 to x2-1 do p^[j,i].Zeichen:=p^[j+1,i].Zeichen;
               WriteXY(x1+1,yb,Ed[yi],P);
              end;
             end;
            end;
  kbUp    : begin         {einen rauf}
             if yi>1 then
             begin
              yi:=yi-1;
              if yb>y1 then
              begin
               DeMark(yb);
               yb:=yb-1;
               Mark(yb);
              end else
              begin      {rollen}
               for j:=y2 downto y1+1 do
                for i:=x1+1 to x2-1 do p^[j,i].Zeichen:=p^[j-1,i].Zeichen;
               WriteXY(x1+1,yb,Ed[yi],P);
              end;
             end;
            end;
  kbEnter : begin        {nchsten Schlssel selektieren}
             if Prior[yi]=0 then {aber nur, falls nicht schon vorher geschehen}
             begin
              Prior[yi]:=Selected;
              Str(Selected:Nr,S);
              Delete(Ed[yi],dx-Nr,Nr);
              Ed[yi]:=Ed[yi]+s;
              WriteXY(x1+1,yb,Ed[yi],p);
              Selected:=Selected+1;
             end;
            end;
 end;
 until  (c=kbEsc) or (c=kbAltS);
 SchluesselUmsortieren:=False;
 if c=kbAltS then
 begin
  Sort:=False;
  j:=1;
  repeat
   Sort:=(Prior[j]<>0);
   Inc(j);
  until (sort) or (j>Dsl^.SZahl);
  if Sort then    {wenigstens 1 Schlssel soll umsortiert werden}
  begin
   SetStatusLine('  Schlssel werden nun umsortiert.');
   SchluesselUmsortieren:=True;
   Change:=True;
   if Selected<=dsl^.SZahl then   {Die nicht selektierten Schlssel behalten}
   begin                          {ihre Rangfolge}
    for j:=1 to dsl^.SZahl do
    begin
     if Prior[j]=0 then
     begin
      Prior[j]:=Selected;
      Inc(Selected);
     end;
    end;
   end;
   Datei_Sort(Kopf,Dsl,Prior);
  end;
 end;
end;


begin   {Hauptprogramm}
 Kopf:=Nil;
 Dsl:=Nil;
 Edit:=kopf;
 assign(f,'GuPe.OPT');
 {$I-}
 reset(f);
 Change:=(IOResult = 0);
 {$I+}
 if Change then
 begin
  {$I-}
  read(f,Options);        {Optionen laden}
  Change:=(IOResult =0);  {Wohl die Datei zu klein, neu schreiben}
  {$I+}
 end;
 if not(Change) then
 begin
  with Options do    {Standardoptionen benutzen}
  begin
   AutoRet:=True;
   AutoFirst:=True;
   AutoClear:=False;
   AutoAdv:=True;
   marked:=true;
   double:=false;
  end;
  rewrite(f);
  write(f,Options);  {und abspeichern}
 end;
 close(f);
 {Men vorbereiten:}
 Sub1:= NewSubMenu('~neu',kbNoKey,cmNeu,
         NewSubMenu('~ffnen',kbF3,cmOeffnen,
         NewSubMenu('~speichern',kbF2,cmSpeichern,
         NewSubMenu('Speichern ~unter',kbNoKey,cmSpUnter,
         NewLine(
         NewSubMenu('~Dos Shell',kbNoKey,cmDosShell,
         NewSubMenu('~Beenden',kbAltX,cmBeenden, NIL)))))));
 Sub2:= NewSubMenu('~editieren',kbF7,cmEditieren,
         NewSubMenu('~suchen',kbF5,cmSuchen,NIL));
 Sub3:= NewSubMenu('~einrichten',kbNoKey,cmEinrichten,
         NewSubMenu('~Namen editieren',kbNoKey,cmNEdit,
         NewSubMenu('~Schlssel umsortieren',kbNoKey,cmNSort,
         NewSubMenu('~hinzufgen',kbNoKey,cmHinzufuegen,
         NewSubMenu('~lschen',kbNoKey,cmLoeschen,NIL)))));
 Sub4:= NewSubMenu('~Editor',kbNoKey,cmEditor,NIL);
 M:= NewMenu('~Datei',Sub1,
      NewMenu('D~atensatz',Sub2,
      NewMenu('~Schlssel',Sub3,
      NewMenu('~Optionen',Sub4,NIL))));
 InitMain(M);
 Disable([cmSpeichern, cmSpUnter, cmEditieren, cmNEdit, cmHinzufuegen, cmLoeschen]);
 HideCursor;
 p:=LocalScreen;
 Message:='  0 Datenstze vorhanden';
 Change:=False;
 {los geth's im Men:}
 repeat
  SetStatusLine(Message);
  if (Dsl<>Nil) and (dsl^.DSAnz>0) then Enable([cmNSort,cmSuchen])
                                   else Disable([cmNSort,cmSuchen]);
  cm:=HandleMenu(M);
  Freeze(Bild);
  Case cm of
   cmNeu        : begin    {neue Datei}
                   if CheckSave(DateiName,Change,Kopf,Dsl) then
                   {alte abgespeichert?}
                   begin
                    Disable([cmSpeichern, cmSpUnter, cmEditieren, cmNEdit, cmHinzufuegen, cmLoeschen]);
                    Erase(Kopf,Dsl);
                    Enable([cmEinrichten]);
                    DateiName:='';
                    SchreibeName:='';
                    Change:=false;
                    Message:='  0 Datenstze vorhanden';
                   end;
                  end;
   cmOeffnen    : begin    {Datei ffnen}
                   if CheckSave(DateiName,Change,Kopf,Dsl) then
                   {alte abgespeichert?}
                   begin
                    AltName:=DateiName;
                    if Laden(Kopf,dsl,DateiName) then
                    begin
                     {passe alles an die neue Datei an:}
                     Change:=False;   {gerade geladen!}
                     Disable([cmEinrichten]);
                     Enable([cmSpeichern, cmSpUnter, cmEditieren, cmNEdit, cmLoeschen]);
                     if Dsl^.SZahl <MAx_Schluessel then Enable([cmHinzufuegen])
                                                   else Disable([cmHinzufuegen]);
                     Edit:=Kopf;
                     if Edit^.Nach<>nil then Edit:=Edit^.Nach;
                     SchreibeName:=MaxDatLen(DateiName,40);
                     Str(dsl^.DSAnz,Message);
                     Message:='  '+SchreibeName+'    '+Message+' Datens';
                     if dsl^.DSAnz=1 then Message:=Message+'atz vorhanden'
                                     else Message:=Message+'tze vorhanden';

                    end else  {nix geladen}
                    begin
                     if DateiName<>'' then  {neue Datei, aber schon mit Namen}
                     begin
                      Change:=False;
                      Erase(Kopf,Dsl);
                      SchreibeName:=MaxDatLen(DateiName,40);
                      Message:='  '+SchreibeName+'    0  Datenstze vorhanden';
                      Enable([cmEinrichten]);
                      Disable([cmSpeichern, cmSpUnter, cmEditieren, cmNEdit, cmHinzufuegen, cmLoeschen]);
                     end else
                     begin  {Das war wohl nix mit dem Laden}
                      DateiName:=AltName;
                     end;
                    end;
                   end;
                  end;
   cmSpeichern  : begin    {Datei speichern}
                   if DateiName<>'' then
                   begin
                    Speichern(Kopf,dsl,DateiName);
                    Change:=false;
                   end
                   else    {Namen auswhlen}
                   begin
                    Ch:=SpeichernUnter(Kopf,dsl,DateiName);
                    if Ch='J' then
                    begin
                     Change:=False;
                     SchreibeName:=MaxDatLen(DateiName,40);
                     Str(dsl^.DSAnz,Message);
                     Message:='  '+SchreibeName+'    '+Message+' Datens';
                     if dsl^.DSAnz=1 then Message:=Message+'atz vorhanden'
                                     else Message:=Message+'tze vorhanden';
                    end;
                   end;
                  end;
   cmSpUnter    : begin   {Datei speichern unter}
                   Ch:=SpeichernUnter(Kopf,dsl,DateiName);
                   if Ch='J' then
                   begin
                    change:=false;
                    SchreibeName:=MaxDatLen(DateiName,40);
                    Str(dsl^.DSAnz,Message);
                    Message:='  '+SchreibeName+'    '+Message+' Datens';
                    if dsl^.DSAnz=1 then Message:=Message+'atz vorhanden'
                                    else Message:=Message+'tze vorhanden';
                   end;
                  end;
   cmDosShell   : DosShell('Zur Rckkehr zu GuPe EXIT eingeben...'); {DOS}
   cmEditieren  : begin    {Datensatz editieren}
                   Editieren(Kopf,Edit,Dsl,Options,change);
                   if Dsl^.DSAnz>0 then
                    Enable([cmSpeichern, cmSPUnter])  {mehr als einen Datensatz}
                   else
                   begin
                    Disable([cmSpeichern, cmSPUnter]);
                   end;
                   Str(dsl^.DSAnz,Message);
                   if SchreibeName='' then Message:='  '+Message+' Datens'
                                      else Message:='  '+SchreibeName+'    '+Message+' Datens';
                   if dsl^.DSAnz=1 then Message:=Message+'atz vorhanden'
                                   else Message:=Message+'tze vorhanden';
                  end;
   cmEinrichten : begin     {Schlssel einrichten}
                   SchlEinr(Kopf,dsl,Change);
                   Edit:=Kopf;
                  end;
   cmHinzufuegen: begin     {Schlssel hinzufgen}
                   tmp:=0;
                   if Edit<>NIL then tmp:=Edit^.Nr;  {aktuellen Editier-
                                                      datensatz merken}
                   if SchluesselHinzufuegen(Kopf,dsl,Change) then
                   begin
                    Edit:=Kopf;
                    if (Edit<>NIL) and(Edit^.Nach<>NIL) then Edit:=Edit^.Nach;
                    if tmp>0 then
                    begin
                     while Edit^.Nr<>tmp do Edit:=Edit^.Nach;
                     {zurck zum alten Editierdatensatz}
                    end;
                   end;
                  end;
   cmLoeschen   : begin      {Schlssel lschen}
                   begin
                    tmp:=0;
                    if (Edit<>NIL) then tmp:=Edit^.Nr; {Editierdatensatz merken}
                    if SchluesselLoeschen(Kopf,Dsl,Change) then
                    begin
                     Edit:=Kopf;
                     if (Edit<>NIL) and (Edit^.Nach<>NIL) then Edit:=Edit^.Nach;
                     if Edit=Nil then {Letzter Schlssel wurde auch noch gelscht.}
                     begin
                      tmp:=0;
                      Message:='  '+SchreibeName+'      0 Datenstze vorhanden'
                     end;
                     if tmp>0 then
                     begin
                      while Edit^.Nr<>tmp do Edit:=Edit^.Nach;
                      {zurck zum alten Editierdatensatz}
                     end;
                    end;
                   end;
                  end;
   cmNEdit      : begin   {Schlsselbezeichner neu ausmachen}
                   NamenEdit(dsl,change);
                  end;
   cmNSort      : begin   {Schlsselreihenfolge neu festlegen}
                   tmp:=0;
                   if (Edit<>NIL) then tmp:=Edit^.Nr;
                   {aktuellen Editierdatensatz merken}
                   if SchluesselUmsortieren(Kopf,Dsl,Change) then
                   begin
                    Edit:=Kopf;
                    if (Edit<>NIL) and (Edit^.Nach<>NIL) then Edit:=Edit^.Nach;
                    if tmp>0 then
                    begin
                     while Edit^.Nr<>tmp do Edit:=Edit^.Nach;
                     {zurck zum alten Editierdatensatz}
                    end;
                   end;
                  end;
   cmEditor     : begin     {Optionen neu bestimmen}
                   OptionEdit(Options);
                  end;
   cmSuchen     : begin     {Datensatz suchen}
                   Help:=Suchen(Kopf,dsl,Options);
                   if Help<>nil then  {Jetzt soll das gefundene editiert werden}
                   begin
                    Edit:=Help;
                    Editieren(Kopf,Edit,Dsl,Options,change);
                   end;
                  end;
   cmBeenden    : begin     {Datei beenden}
                   if not(CheckSave(DateiName,change,Kopf,Dsl)) then cm:=0;
                   {Datei abgespeichert?}
                  end;
  end;
  Defreeze(Bild);
 until cm = cmBeenden;
 {normalen DOS-Bildschirm:}
 TextColor(LightGray);
 TextBackGround(Black);
 ClrScr;
 LineCursor;
end.