Unit Menus;
{

 Diese Unit enthlt ein komplettes Pull-Down Men System. Sie enthlt die
 dazugehrenden Datenstrukturen, von denen der Anwender (der Unit) aber
 nur 'Menge' und die Zeigertypen PSMenu (Zeiger auf Untermen) sowie
 PMenu (Zeiger auf Men) benutzt, ohne die jeweilige Recordstruktur zu
 kennen. Dafr gibt es ja die mitgelieferten Funktionen:


 1. function NewSubMenu(Name:MenuString; QuickHot,Kom:Word; Next:PSMenu):PSMenu;

    Richtet einen neuen Untermenpunkt ein. Der Titel ist logischerweise
    in der Variablen Name abgespeichert. Enthlt der String eine Tilde
    (~), so wird das folgende Zeichen der Shortkey, der zum Auswhlen
    des Mens gengt. Es wird aber nur das erste Auftreten der Tilde
    bercksichtigt. Quickhot ist ein Hotkey, der den Menpunkt auswhlt,
    selbst wenn gerade wo anders gefensterlt wird. (Meistens werden hierfr
    Funktionstasten benutzt, z.B. F3 entspricht kbF3 (siehe Unit Consts).
    Kom ist ein Zahlenwert, der dem Aufruf dieses Menpunktes entspricht.
    Dieser wird von HandleMenu bei Auswahl zurckgeliefert und kann dann
    im Hauptprogramm ausgewertet werden (s.u.).
    Beachte: Werte bis 255 knnen durch Disable (s.u.) deaktiviert werden,
     so da diese Menpunkte dann nicht gewhlt werden knnen.


 2. function NewLine(Next:PSMenu):PSMenu;

    Generiert eine Trennlinie zwischen den einzelnen Untermenpunkten.

 3. function NewMenu(Name:MenuString;Sub : PSMenu; Next:PMenu):PMenu;

    Richtet einen neuen Hauptmenpunkt ein. Dieser trgt den Titel
    'Name'.
    Beachte: Enthlt der String ein '~', so wird das nchste Zeichen
     der Shortkey. (Er mu in Verbindung mit Alt gedrckt werden.
     Es wird nur das erste Auftreten der Tilde bercksichtigt.
     Ebenso trgt der Anwender die Verantwortung, das die Tastenkombination
     mit Alt berhaupt realisierbar ist (z.B. '~@bla...': Der Klammeraffe(!)
     wird zwar rot gefrbt, allerdings ist die Shortkeyfunktion de facto
     nicht vorhanden.
    'Sub' enthlt das dazugehrende Untermen.
    'Next' ist der nchste Hauptmenpunkt. Bem.: NIL fr Ende.

 4. procedure SetStatusLine(Info:String);

    Der String Info wird am unteren Rand in die Statuszeile ausgegeben.

 5. procedure InitMain(Var M:PMenu);

    Nach dem generieren des Mens mit den Funktionen NewMenu/NewSubMenu
    mu diese Funktion zwingend notwendig aufgerufen werden. damit die
    interne Datenstruktur ordnungsgem initialisiert wird. M ist das
    zuvor erzeugte Mensystem.


 6. procedure Disable(M:Menge);

    Wie oben schon erwhnt, knnen die Kommandos bis 255 deaktiviert werden.
    Zum Aufruf gibt es nur zu beachten, da die Kommandos als Menge
    bergeben werden mssen (es knnen also auf einmal mehrere Kommandos
    deaktiviert werden). Dies hat mit der inneren Struktur zu tun, da die
    abgewhlten Kommandos alle in einer Menge verwaltet werden. Hier ist
    jetzt auch zu erkennen, warum nur die Kommandos bis 255 deaktiviert
    werden knnen, da Borland Pascal Mengen nur bis 256 Elemente verwalten
    kann. In M sind die zu deaktivierenden Kommandos enthalten.

 7. procedure Enable(M:Menge);

    Alle in der Menge M befindlichen Kommandos werden wieder aktiviert.

 8. function HandleMenu(Var Menu:PMenu):Word;

    Dieses ist nun die Hauptfunktion zur Menverwaltung. Der Anwender
    fensterlt solange durch das Men, bis er ein Kommando aktiviert hat.
    Der Zahlenwert, der beim Aufruf von 'NewSubMenu' vergeben wurde,
    wird nun zurckgegeben.


}


Interface
Uses Consts;

Type   MenuString = String[80];
       Menge = Set of Byte;

       PSMenu = ^Submenu;
       Submenu =  record
                   prev,next:PSMenu;
                   Titel:MenuString;
                   Pos:Byte;
                   Y,X1,X2:Integer;   {frs markieren}
                   Hotkey,QuickHot:Word;
                   Kommando:Word;
                  end;

       PMenu=^Hauptmenu;
       Hauptmenu = record
                    prev,next:PMenu;
                    Titel:MenuString;
                    Pos:Byte;
                    Hotkey:Word;
                    Sub:PSMenu;
                    x1,x2,             {Anfangs- u. Endkoordinate auf Screen}
                    SX1,SX2,           {linke obere Ecke des Sub-Fensters}
                    SY1,SY2: Integer;  {rechte untere Ecke "  "  "}
                    Hots,QuickHots : Menge;
                   end;

function NewMenu(Name:MenuString;Sub : PSMenu; Next:PMenu):PMenu;
function NewSubMenu(Name:MenuString; QuickHot,Kom:Word; Next:PSMenu):PSMenu;
function NewLine(Next:PSMenu):PSMenu;
procedure SetStatusLine(Info:String);
procedure InitMain(Var M:PMenu);
procedure Disable(M:Menge);
procedure Enable(M:Menge);
function HandleMenu(Var Menu:PMenu):Integer;



Implementation
Uses Crt,Screens,Toolbox;
Type MenuArt = (Main,Sub);

Const MainHots:Menge=[];
      QuickHots:Menge=[];
      cmNewLine = 60000;

Var disabled:Menge;

const

  AltCodes1: array[$10..$32] of Char =
    'QWERTYUIOP'#0#0#0#0'ASDFGHJKL'#0#0#0#0#0'ZXCVBNM';

  AltCodes2: array[$78..$81] of Char =
    '1234567890';

function GetAltChar(KeyCode: Word): Char;
{Aus einem 2 Zeichentastaturcode wird, sofern berhaupt der Fall,
 das zugehrige ALT Zeichen herausgesucht.}
begin
 GetAltChar := #0;
 if Lo(KeyCode) = 0 then
  case Hi(KeyCode) of
   $10..$32: GetAltChar := AltCodes1[Hi(KeyCode)];
   $78..$81: GetAltChar := AltCodes2[Hi(KeyCode)];
  end;
end;

function GetAltCode(Ch: Char): Word;
{Zum Zeichen Ch wird der 2 Byte Tastaturcode gesucht.
 Quasi das Inverse zu GetAltChar}
var
  I: Word;
begin
 GetAltCode := 0;
 if Ch = #0 then Exit;
 Ch := UpCase(Ch);
 Case Ch of
  'A'..'Z' : begin
              I:=$10;
              while AltCodes1[I]<>Ch do I:=I+1;
              GetAltCode:=I shl 8;
             end;
  '0'..'9' : begin
              I:=$78;
              while AltCodes2[I]<>Ch do I:=I+1;
              GetAltCode:=I shl 8;
             end;
 end;
end;

procedure ManageString(Var Name:MenuString;Var Pos:Byte; Var Hotkey:Word;
                       Art:MenuArt);
{Bekannterweise sorgt eine Tilde im Menpunkt zur Aktivierung eines
 Hotkeys. Diese Funktion berprft nun, ob dies erforderlich ist. Und
 gibt einige Werte zurck:
 Name wird logischerweise um die Tilde bereinigt. Deren Position wird
 aber in Pos festgehalten (Ist erforderlich, damit das Programm wei,
 welches Zeichen andersfarbig markiert werden mu.). Hotkey liefert den
 Tastaturcode zurck. Da frs Hauptmen nur Tastenkombinationen mit
 ALT generiert werden, mu ebenfalls bergeben werden, fr welche
 Menart der Hotkey eingerichtet werden mu.}

Var i,j:Integer;
begin
 Hotkey:=0;
 Pos:=System.Pos('~',Name);
 if Pos<>0 then
 begin
  Delete(Name,Pos,1);
  if Art = Sub then
  begin
   Hotkey:=Ord(UpCase(Name[Pos]));
  end else   {Im Hauptmen nur Hotkeys mit 'ALT'}
  begin
   HotKey:=GetAltCode(Name[Pos]);
  end;
 end;
end;

function KonvertToString(c:Word):String;
{Liefert zum Tastaturcode den entsprechenden String, z.B. 'F3'.
 Dies erscheint dann im Untermenfenster.}
Const ChNum:Array[1..10] of String[2]=('1','2','3','4','5','6','7','8','9','10');
begin
 Case Hi(c) of
  $10..$32,
  $78..$81 : KonvertToString:='Alt-'+GetAltChar(c);
  59..68   : KonvertToString:='F'+ChNum[Hi(c)-58];
  84..93   : KonvertToString:='Shift-F'+ChNum[Hi(c)-83];
  94..103  : KonvertToString:='Strg-F'+ChNum[Hi(c)-93];
  104..113 : KonvertToString:='Alt-F'+ChNum[Hi(c)-103];
 end;
end;


function Max(a,b:Integer):Integer;
{gibt das Maximum von a und b zurck.}
begin
 if a>b then Max:=a
        else Max:=b;
end;

function NewSubMenu(Name:MenuString; QuickHot,Kom:Word;Next:PSMenu):PSMenu;
{Richtet einen neuen Untermenpunkt ein. Der Titel ist logischerweise
 in der Variablen Name abgespeichert. Enthlt der String eine Tilde
 (~), so wird das folgende Zeichen der Shortkey, der zum Auswhlen
 des Mens gengt. Es wird aber nur das erste Auftreten der Tilde
 bercksichtigt. Quickhot ist ein Hotkey, der den Menpunkt auswhlt,
 selbst wenn gerade wo anders gefensterlt wird. (Meisten werden hierfr
 Funktionstasten benutzt, z.B. F3 entspricht kbF3 (siehe Unit Consts).
 Kom ist ein Zahlenwert, der dem Aufruf dieses Menpunktes entspricht.
 Dieser wird von HandleMenu bei Auswahl zurckgeliefert und kann dann
 im Hauptprogramm ausgewertet werden
 Beachte: Werte bis 255 knnen durch Disable deaktiviert werden,
          so da diese Menpunkte dann nicht gewhlt werden knnen.}

Var P:PSMenu;
    i:Integer;
begin
 New(P);
 ManageString(Name,P^.Pos,P^.Hotkey,Sub);
 P^.Titel:=Name;
 P^.QuickHot:=QuickHot;
 P^.Prev:=Nil;
 P^.Next:=Next;
 if Next=Nil then i:=0 else i:=Next^.X1;
 {in P^.X1 wird temporr die maximal bentigte Lnge
  des Rollbalkens ermittelt:}
 if (QuickHot<>kbNoKey) then
 begin
  P^.X1:=Max(i,length(Name)+length(KonvertToString(Quickhot))+2);
  QuickHots:=QuickHots+[Hi(QuickHot)];
 end
 else
  P^.X1:=Max(i,length(Name));
 if Next=Nil then i:=0 else i:=Next^.Y;
 P^.Y:=i+1; {in P^.Y wird temporr die Anzahl der folgenden Untermen-
             punkte gespeichert.}
 P^.Kommando:=Kom;
 NewSubMenu:=P;
end;


function NewLine(Next: PSMenu):PSMenu;
{Generiert eine Trennlinie zwischen den einzelnen Untermenpunkten.}
begin
 NewLine:=NewSubMenu('',kbNoKey,cmNewLine,Next);
end;


function NewMenu(Name:MenuString;Sub : PSMenu;Next:PMenu):PMenu;
{Richtet einen neuen Hauptmenpunkt ein. Dieser trgt den Titel
 'MenuString'.
 Beachte: Enthlt der String ein '~', so wird das nchste Zeichen
  der Shortkey. (Er mu in Verbindung mit Alt gedrckt werden.
  Es wird nur das erste Auftreten der Tilde bercksichtigt.
  Ebenso trgt der Anwender die Verantwortung, das die Tastenkombination
  mit Alt berhaupt realisierbar ist (z.B. '~@bla...': Der Klammeraffe(!)
  wird zwar rot gefrbt, allerdings ist die Shortkeyfunktion de facto
  nicht vorhanden.
 'Sub' enthlt das dazugehrende Untermen.
 'Next' ist der nchste Hauptmenpunkt. Bem.: NIL fr Ende.}
Var M:PMenu;
begin
 New(M);
 ManageString(Name,M^.Pos,M^.Hotkey,Main);
 M^.Titel:=Name;
 M^.Prev:=Nil;
 M^.Next:=Next;
 M^.Sub:=Sub;
 if M^.Hotkey<>0 then MainHots:=MainHots+[Hi(M^.Hotkey)];
 M^.QuickHots:=[];
 NewMenu:=M;
end;

procedure SetStatusLine(Info:String);
{Der String Info wird am unteren Rand in die Statuszeile ausgegeben.}
Var p:PBildschirm;
    i:Integer;
begin
 p:=LocalScreen;
 WriteXY(1,25,Copy(Info,1,80),P);
 for i:=length(Info)+1 to 80 do p^[25,i].Zeichen:=' ';
end;


procedure InitMain(Var M:PMenu);
{Nach dem generieren des Mens mit den Funktionen NewMenu/NewSubMenu
 mu diese Funktion zwingend notwendig aufgerufen werden. damit die
 interne Datenstruktur ordnungsgem initialisiert wird.}

Var i,j,Counter:Integer;
    P:PMenu;
    S:PSMenu;
    Screen:PBildschirm;
    item:Screenplace;
    St:String;

begin
 TextColor(Black);
 TextBackground(LightGray);
 ClrScr;
 item.Zeichen:='';
{ item.Zeichen:=' ';}   {wem's besser gefllt...}
 item.Attr:=$71;
{ item.Attr:=$70;}      {wem's besser gefllt...}
 Screen:=LocalScreen;
 for i:=1 to 80 do
  for j:=2 to 24 do
   Screen^[j,i]:=item;

 if M<>Nil then
 begin
  P:=M;
  i:=1;
  while M<>Nil do
  begin
   M^.X1:=i+1;
   M^.X2:=i+2+Length(M^.Titel);
   i:=M^.X2;
   j:=M^.Sub^.X1+4; {gesamte Breite frs Submen}
   M^.SY1:=1+1+1;
   M^.SY2:=M^.Sub^.Y+M^.SY1;
   if M^.X1+j<=80 then
   begin          {pat linksbndig}
    M^.SX1:=M^.X1+1;
    M^.SX2:=M^.X1+j-2;
   end else
   begin
    M^.SX2:=78;
    M^.SX1:=78-j+1;
   end;
   M^.Pos:=M^.Pos+M^.X1;    {wenn kein Hotkey gesetzt, wird spter
                             ein Space markiert, aber das macht nichts.
                             Da in der Regel Hotkey gesetzt, ist diese Variante
                             schneller als ein Abfragen}
   j:=M^.SY1;
   S:=M^.Sub;
   M^.Hots:=[];
   while s<>nil do
   begin
    if (S^.Hotkey>0) and (S^.Hotkey<256) then M^.Hots:=M^.Hots+[S^.Hotkey];
    S^.Titel:=' '+S^.Titel;
    if S^.QuickHot<>kbNoKey then
    begin
     st:=KonvertToString(S^.QuickHot);
     for counter:=length(s^.Titel) to M^.SX2-M^.SX1-length(st)-1 do
      S^.Titel:=S^.Titel+' ';
     S^.Titel:=S^.Titel+St;
     M^.QuickHots:=M^.QuickHots+[Hi(s^.QuickHot)];
    end;
    if S^.Kommando = cmNewLine then
    begin
     S^.Titel:='';
     for counter:= M^.SX1 to M^.SX2 do S^.Titel:=S^.Titel+'';
    end;
    S^.Y:=j;
    S^.X1:=M^.SX1;
    S^.X2:=M^.SX2;
    j:=j+1;
    S^.Pos:=S^.Pos+S^.X1;
    s:=s^.Next;
   end;
   s:=M^.Sub;
   if s<>nil then
   begin
    While s^.Next<>nil do
    begin
     S^.Next^.Prev:=s;
     s:=s^.Next;
    end;
    S^.Next:=M^.Sub;
    M^.Sub^.prev:=S; {nun ist es ein Ring}
   end;
   While M^.Sub^.Kommando=cmNewLine do
    M^.Sub:=M^.Sub^.Next;    {NewLine direkt zu Beginn ?}
   M:=M^.Next;
  end;
  M:=P;
  If P<> nil then
  begin
   gotoxy(1,1);
   TextColor(Black);
   TextBackGround(Lightgray);
   While P<>nil do
   begin
    GotoXY(P^.X1,1);
    write(' ',P^.Titel,' ');
    Screen^[1,p^.Pos].Attr:=$74;
    P:=P^.Next;

   end;
   P:=M;
   While P^.Next<>nil do
   begin
    P^.Next^.Prev:=P;
    P:=P^.Next;
   end;
   P^.Next:=M;
   M^.Prev:=P;
  end;
 end;
end;

procedure MakeBox(x1,x2,y1,y2,color:Integer;P:PBildschirm);
{Erzeugt eine Box, mit der oberen linken Koordinate (x1,y1) und
 der unteren rechten (x2,y2). Die Farbe der Box ist in Color festgelegt.
 Es wird ebenfalls ein Schatten um die Box gezeichnet.
 Beachte, da um den Rahmen noch ein Leerzeichen gezeichnet wird.}

Var i,j:integer;
    tmp:Screenplace;
begin
 tmp.Attr:=color;
 tmp.Zeichen:='';
 for j:=x1 to x2 do
 begin
  p^[y1,j]:=tmp;
  p^[y2,j]:=tmp;
 end;
 tmp.Zeichen:='';
 for j:=y1+1 to y2-1 do
 begin
  p^[j,x1]:=tmp;
  p^[j,x2]:=tmp;
 end;
 p^[y1,x1].zeichen:='';
 p^[y1,x2].zeichen:='';
 p^[y2,x1].zeichen:='';
 p^[y2,x2].zeichen:='';
 tmp.Zeichen:=' ';
 for j:=x1+1 to x2-1 do
  for i:=y1+1 to y2-1 do
   p^[i,j]:=tmp;
 for j:=x1+1 to x2+1 do
  p^[y2+1,j].Attr:=$08;
 for i:=y1 to y2 do
 begin
  p^[i,x1-1]:=tmp;
  p^[i,x2+1]:=tmp;
 end;
 if x2<78 then
  for j:=y1+1 to y2+1 do
  begin
   p^[j,x2+2].Attr:=$08;
   p^[j,x2+3].Attr:=$08;
  end;
 if x2=78 then
  for j:=y1+1 to y2+1 do
   p^[j,80].Attr:=$08;
end;

function HandleMenu(Var Menu:PMenu):Integer;
{Dieses ist nun die Hauptfunktion zur Menverwaltung. Der Anwender
 fensterlt solange durch das Men, bis er ein Kommando aktiviert hat.
 Der Zahlenwert, der beim Aufruf von 'NewSubMenu' vergeben wurde,
 wird nun zurckgegeben.}

Var Screen:Bildschirm;
    P:PBildschirm;
    c,Erg:Word;
    i,kom:Integer;
    IsPulled,Quick:Boolean;
    tmp:PSMenu;
    Mp:PMenu;


  procedure InitMainMarked(Var M:PMenu);
  {Markiert das aktuell selektierte Hauptmen.}
  Var i:Integer;
  begin
   for i:=M^.x1 to M^.x2 do
    p^[1,i].Attr:=$07;
   if M^.Pos<>0 then p^[1,M^.Pos].Attr:=$04;
  end;

  procedure InitPullDown(Var M:PMenu);
  {Pull-Down Men des in M befindlichen Untermnens wird erzeugt.}
  Var i,j:Integer;
      S:PSMenu;
  begin
   MakeBox(M^.SX1-1,M^.SX2+1,M^.SY1-1,M^.SY2,$70,P);
   S:=M^.Sub;
   for i:=M^.sy1 to m^.sy2 do
   begin
    gotoxy(M^.sx1,S^.Y);Write(S^.Titel);
    p^[S^.y,S^.Pos].Attr:=$74;
    if S^.Kommando=cmNewLine then       {Leere Zeile im Untermen}
    begin
     p^[S^.y,M^.SX1-1].Zeichen:='';
     P^[S^.y,M^.SX1].Attr:=$70;
     p^[S^.y,M^.SX2+1].Zeichen:='';
    end;
    if S^.Kommando in disabled then    {deaktiviert=>andere Farbe}
    begin
     for j:=M^.SX1 to M^.SX2 do p^[S^.Y,j].Attr:=$78;
    end;
    S:=S^.Next;
   end;
   if M^.Sub^.Kommando in disabled then {deaktiviert, also andersfarbig}
   begin
    for i:=M^.Sx1 to M^.Sx2 do p^[M^.Sub^.Y,i].Attr:=$08;
   end
   else
   begin
    for i:=M^.Sx1 to M^.Sx2 do p^[M^.Sub^.Y,i].Attr:=$07;
    p^[M^.Sub^.Y,M^.Sub^.Pos].Attr:=$04;
   end;
  end;

begin
 Freeze(Screen);
 TextColor(Black);
 TextBackGround(LightGray);
 IsPulled:=False;    {berhaupt schon runtergezogen??}
 Quick:=False;
 P:=LocalScreen;
 InitMainMarked(Menu);
 repeat
  GetKey(c);
  if (not(IsPulled)) and (c in [48..57,65..90,97..122]) then
  begin
   if c>90 then c:=c-32;
   c:=GetAltCode(Chr(c)) ;
   if Hi(c) in QuickHots then c:=0;
  end;
  Case c of

   kbRight:  begin                {Men rechts,d.h. Nachfolger}
              Defreeze(Screen);   {Der Nachfolger vom letzten ist ja}
              Menu:=Menu^.Next;   {gerade der erste}
              InitMainMarked(Menu);
              if IsPulled then InitPullDown(Menu);
             end;
   kbLeft:  begin                {Men nach links bzw. beim Verlassen}
              Defreeze(Screen);  {des linken das ganz rechte.}
              Menu:=Menu^.Prev;
              InitMainMarked(Menu);
              if IsPulled then InitPullDown(Menu);
             end;
   kbUp  :  begin
             if IsPulled then    {nur wenn runtergezogen: nach oben}
             begin               {vorher schon ganz oben, dann ganz unten}
              if Menu^.Sub^.Kommando in disabled then
              begin
               for i:=Menu^.Sx1 to Menu^.Sx2 do p^[Menu^.Sub^.Y,i].Attr:=$78;
              end else
              begin
               for i:=Menu^.Sx1 to Menu^.Sx2 do p^[Menu^.Sub^.Y,i].Attr:=$70;
               if Menu^.Sub^.Pos<>0 then p^[Menu^.Sub^.Y,Menu^.Sub^.Pos].Attr:=$74;
              end;
              Menu^.Sub:=Menu^.Sub^.Prev;
              while Menu^.Sub^.Kommando=cmNewLine Do Menu^.Sub:=Menu^.Sub^.Prev;
              if Menu^.Sub^.Kommando in disabled then
              begin
               for i:=Menu^.Sx1 to Menu^.Sx2 do p^[Menu^.Sub^.Y,i].Attr:=$08;
              end else
              begin
               for i:=Menu^.Sx1 to Menu^.Sx2 do p^[Menu^.Sub^.Y,i].Attr:=$07;
               if Menu^.Sub^.Pos<>0 then p^[Menu^.Sub^.Y,Menu^.Sub^.Pos].Attr:=$04;
              end;
             end;
            end;
   kbDown:  begin
             If IsPulled then          {Men nach unten bzw. oberste}
             begin
              if Menu^.Sub^.Kommando in disabled then
              begin
               for i:=Menu^.Sx1 to Menu^.Sx2 do p^[Menu^.Sub^.Y,i].Attr:=$78;
              end else
              begin
               for i:=Menu^.Sx1 to Menu^.Sx2 do p^[Menu^.Sub^.Y,i].Attr:=$70;
               if Menu^.Sub^.Pos<>0 then p^[Menu^.Sub^.Y,Menu^.Sub^.Pos].Attr:=$74;
              end;
              Menu^.Sub:=Menu^.Sub^.Next;
              while Menu^.Sub^.Kommando=cmNewLine Do
               Menu^.Sub:=Menu^.Sub^.Next;
              if Menu^.Sub^.Kommando in disabled then
              begin
               for i:=Menu^.Sx1 to Menu^.Sx2 do p^[Menu^.Sub^.Y,i].Attr:=$08;
              end else
              begin
               for i:=Menu^.Sx1 to Menu^.Sx2 do p^[Menu^.Sub^.Y,i].Attr:=$07;
               if Menu^.Sub^.Pos<>0 then p^[Menu^.Sub^.Y,Menu^.Sub^.Pos].Attr:=$04;
              end;
             end else  {Jetzt runtergezogen}
             begin
              InitPullDown(Menu);
              IsPulled:=True;
             end;
            end;
   else
   begin
    if c>255 then
    begin
     if Hi(c) in QuickHots then    {Menpunkt durch Quickhotkey ausgewhlt}
     begin
      MP:=Menu;
      while not(Hi(c) in Mp^.QuickHots) do MP:=Mp^.Next;
      tmp:=mp^.Sub;
      while not(c=tmp^.QuickHot) do tmp:=tmp^.Next;
      kom:=tmp^.Kommando;
      if not(kom in disabled) then
      begin
       Quick:=true;
       c:=13;
      end;
     end;
     if Hi(c) in MainHots then   {neues Untermen gewhlt}
     begin
      while Menu^.Hotkey<> c do Menu:=Menu^.Next;
      Defreeze(Screen);
      InitMainMarked(Menu);
      InitPullDown(Menu);
      isPulled:=true;
     end;
    end
    else
    begin
     c:=ord(UpCase(Chr(c)));
     if (c=13) then            {Return-Taste}
     if not(IsPulled) then     {erstmal runterziehen}
     begin
      IsPulled:=True;
      InitPullDown(Menu);
      c:=0;
     end else
      if Menu^.Sub^.Kommando in disabled then c:=0;  {Schade: nicht erlaubt}

     if (c in Menu^.Hots) then    {Men ausgewhlt}
     begin
      tmp:=Menu^.Sub;
      while tmp^.Hotkey<>c do tmp:=tmp^.Next;
      if not(tmp^.Kommando in disabled) then
      begin
       c:=13;
       Menu^.Sub:=tmp;
      end;
     end;
    end;
   end;
  end;
 until c=13;
 Defreeze(Screen);
 if Quick then HandleMenu:=kom
          else HandleMenu:=Menu^.Sub^.Kommando;
end;

procedure Disable(M:Menge);
{Alle in der Menge M befindlichen Kommandos werden deaktiviert.}
begin
 Disabled:=disabled+m;
end;

procedure Enable(M:Menge);
{Alle in der Menge M befindlichen Kommandos werden wieder aktiviert.}
begin
 Disabled:=disabled-m;
end;

begin
 disabled:=[];   {alles erlaubt}
end.