{
  Diese Unit enthlt Routinen rund um den Bildschirm. Das Ausgeben von
  Zeichen und deren Farbe geschieht durch direkten Eingriff in den
  Hauptspeicher. Beachte hierzu, da das ganze aber nur bei einer
  Farbgrafikkarte funktioniert. Sollte dennoch mal ein antiker
  Museumsrechner verwendet werden, so wird das festgestellt und
  das Programm bricht sofort ab, um Schden zu vermeiden, da sonst
  an falscher Stelle im Hauptspeicher manipuliert wird.
  Zuerst wird eine eigene Datenstruktur eingefhrt:

  Screenplace = record
                 Zeichen:Char;
                 Attr:Byte;
                end;

  Dieser Record reprsentiert ein Zeichenplatz auf dem Bildschirm.
  Das Zeichen ist als Char in Zeichen abgespeichert. In Attr ist
  die Farbe fr das Zeichen und den Hintergrund gespeichert.

  Bildschirm = array[1..25,1..80] of Screenplace;

  Dieser Datentyp reprsentiert nun den gesamten Bildschirminhalt,
  25 Zeilen  80 Zeichen.

  Nun zu den Routinen, die den Umgang mit dem Bildschirm organisieren:

  1. procedure Freeze(Var Monitor:Bildschirm);

     Diese Prozedur speichert den momentanen, gesamten Bildschirminhalt
     in die Variable Monitor.


  2. Procedure Defreeze(Var Monitor:Bildschirm);

     Der in der Variablen Monitor gespeicherte Bildschirminhalt
     wird auf dem Bildschirm gebracht; z.B. der zuvor durch Freeze
     gespeichert wurde.

  3. function LocalScreen:PBildschirm;

     Liefert einen Zeiger auf den Speicherbereich, in dem die
     Bildschirminformationen gespeichert sind.

  4. procedure MakeBox(x1,x2,y1,y2,color:Integer;Rahmen:RString;
                       Titel:String;P:PBildschirm);

     Generiert eine Box, die auf dem Bildschirm ausgegeben wird.
     x1,x2,y1,y2 Sind die Eck-Koordinaten der Box. Color ist die
     Farbe fr Zeichen in der Box und deren Hintergrundfarbe.
     Rahmen ist meistens die vordefinierten Konstanten 'einfach' und
     'doppelt' und gibt an, welchen Rahmen die Box bekommen soll.
     Titel ist ein String, der die berschrift des Fensters beinhaltet.
     Dann mu noch der Bildschirm bergeben werden, auf dem das
     ganze ausgegeben werden soll.

  5. procedure WriteXY(x,y:Integer;Text:String;P:PBildschirm);

     Schreibt an den x,y-Koordinaten den in 'Text' gespeicherten
     String, das ganze soll auf dem Bildschirm geschehen, der in
     'P' bergeben wurde.

  6. rocedure WriteXYColor(x,y,col:Integer;Text:String;P:PBildschirm);

     Fast wie WriteXY, nur da noch zustzlich eine Farbe fr die
     Stringsausgabe gewhlt wird.

  7. function AskBox(Color,Color2:Integer;Titel,Text,Anw:String):Char;

     Generiert ein Fenster mit der berschrift Titel in der Farbe Color.
     Ausgegeben wird der String Text. Der Anwender soll hier allerdings
     aktiv whlen, was er mchte: 'Ja', 'Nein' oder 'Abbruch'.
     Welche der 3 Antworten vorgegeben sein sollen, ist in Anw gespeichert,
     und zwar jeweils der Anfangsbuchstabe der mglichen Antwort.
     In Color2 ist nun die Farbe fr die zu drckenden Tasten gespeichert.
     Die Funktion gibt die gewhlte Antwort als Zeichen zurck.

  8. procedure MsgBox(Color:Integer;Titel,Text:String);

     Erzeugt ein Hinweisfenster mit der berschrift, die in Titel
     gespeichert ist. Der Hinweis selber ist in Text gespeichert.
     In Color wird die Farbe gewhlt.


}
Unit Screens;
Interface

 Type  Screenplace = record
                      Zeichen:Char;
                      Attr:Byte;
                     end;
       RString=String[6];

       PBildschirm = ^Bildschirm;
       Bildschirm = array[1..25,1..80] of Screenplace;

  Const
   einfach ='Ŀٳ';
   doppelt ='ͻȼ';


  procedure Freeze(Var Monitor:Bildschirm);
  Procedure Defreeze(Var Monitor:Bildschirm);
  function LocalScreen:PBildschirm;
  procedure MakeBox(x1,x2,y1,y2,color:Integer;Rahmen:RString;
                     Titel:String;P:PBildschirm);
  procedure WriteXY(x,y:Integer;Text:String;P:PBildschirm);
  procedure WriteXYColor(x,y,col:Integer;Text:String;P:PBildschirm);
  function AskBox(Color,Color2:Integer;Titel,Text,Anw:String):Char;
  procedure MsgBox(Color:Integer;Titel,Text:String);

Implementation
Uses Dos,Crt,Cursors,Toolbox,consts;


function LocalScreen:PBildschirm;
{Liefert einen Zeiger auf den Speicherbereich, in dem die
 Bildschirminformationen gespeichert sind.}
begin
 LocalScreen:=Ptr(SegB800,0);
end;

procedure Freeze(Var Monitor:Bildschirm);
{Diese Prozedur speichert den momentanen, gesamten Bildschirminhalt
 in die Variable Monitor.}
begin
 Monitor:=PBildschirm(Ptr(SegB800,0))^;
end;

procedure Defreeze(Var Monitor:Bildschirm);
{Der in der Variablen Monitor gespeicherte Bildschirminhalt
 wird auf dem Bildschirm gebracht; z.B. der zuvor durch Freeze
 gespeichert wurde.}
begin
 PBildschirm(Ptr(SegB800,0))^:=Monitor;
end;

procedure MakeBox(x1,x2,y1,y2,color:Integer;Rahmen:RString;Titel:String;P:PBildschirm);
{Generiert eine Box, die auf dem Bildschirm ausgegeben wird.
 x1,x2,y1,y2 Sind die Eck-Koordinaten der Box. Color ist die
 Farbe fr Zeichen in der Box und deren Hintergrundfarbe.
 Rahmen ist meistens die vordefinierten Konstanten 'einfach' und
 'doppelt' und gibt an, welchen Rahmen die Box bekommen soll.
 Titel ist ein String, der die berschrift des Fensters beinhaltet.
 Dann mu noch der Bildschirm bergeben werden, auf dem das
 ganze ausgegeben werden soll.}

Var i,j:integer;
    tmp:Screenplace;
begin
 tmp.Attr:=color;
 tmp.Zeichen:=Rahmen[2];
 for j:=x1 to x2 do  {Rand oben und unten:}
 begin
  p^[y1,j]:=tmp;
  p^[y2,j]:=tmp;
 end;
 if Titel<>'' then   {Titel zentriert auf oberen Rand:}
 begin
  Titel:=' '+Titel+' ';
  i:=(x2+x1-length(Titel)-1) div 2;
  for j:=1 to length(titel) do p^[y1,i+j].Zeichen:=Titel[j];
 end;
 tmp.Zeichen:=Rahmen[6];
 for j:=y1+1 to y2-1 do   {linker und rechter Rand:}
 begin
  p^[j,x1]:=tmp;
  p^[j,x2]:=tmp;
 end;
 p^[y1,x1].zeichen:=Rahmen[1];      {Ecken}
 p^[y1,x2].zeichen:=Rahmen[3];
 p^[y2,x1].zeichen:=Rahmen[4];
 p^[y2,x2].zeichen:=Rahmen[5];
 tmp.Zeichen:=' ';
 for j:=x1+1 to x2-1 do       {leeres Fenster}
  for i:=y1+1 to y2-1 do
   p^[i,j]:=tmp;
 for i:=y1 to y2 do
 begin
  p^[i,x1-1]:=tmp;
  p^[i,x2+1]:=tmp;
 end;
 for j:=x1+1 to x2+1 do    {Schatten genereieren:}
  p^[y2+1,j].Attr:=$08;
 if x2<78 then
  for j:=y1+1 to y2+1 do
  begin
   p^[j,x2+2].Attr:=$08;
   p^[j,x2+3].Attr:=$08;
  end;
 if x2=78 then
  for j:=y1+1 to y2+1 do
   p^[j,80].Attr:=$08;
end;

procedure WriteXY(x,y:Integer;Text:String;P:PBildschirm);
{Schreibt an den x,y-Koordinaten den in 'Text' gespeicherten
 String, das ganze soll auf dem Bildschirm geschehen, der in
 'P' bergeben wurde.}
Var i:Integer;
begin
 for i:=1 to length(Text) do p^[y,x+i-1].Zeichen:=Text[i];
end;

procedure WriteXYColor(x,y,col:Integer;Text:String;P:PBildschirm);
{Fast wie WriteXY, nur da noch zustzlich eine Farbe fr die
 Stringsausgabe gewhlt wird.}
Var i:integer;
begin
 for i:=1 to length(Text) do
 begin
  p^[y,x+i-1].Zeichen:=Text[i];
  p^[y,x+i-1].Attr:=Col;
 end;
end;

procedure MsgBox(Color:Integer;Titel,Text:String);
{Erzeugt ein Hinweisfenster mit der berschrift, die in Titel
 gespeichert ist. Der Hinweis selber ist in Text gespeichert.
 In Color wird die Farbe gewhlt.}

Var P:PBildschirm;
    Screen:Bildschirm;
    x,y,i:Integer;
    s:String;
Begin
 P:=LocalScreen;
 GetCursor;HideCursor;
 Freeze(Screen);
 MakeBox(21,61,9,17,Color,doppelt,Titel,P);
 y:=11;
 x:=24;
 i:=1;
 while Text<>'' do    {Wrter sollen nicht am Ende der Zeile abgeschnitten}
 begin                {werden, sondern dann das ganze Wort in die neue Zeile}
  if Pos(' ',Text)=0 then s:=Text
                     else s:=Copy(Text,1,Pos(' ',Text)-1);
  if Pos(#13,S)<>0 then s:=Copy(s,1,Pos(#13,S)-1);  {Neue Zeile}
  if length(s)+x>58 then
  begin
   x:=24;y:=y+1;
  end;
  if length(s)>35 then
  begin
   s:=Copy(s,1,35);
   Insert(' ',Text,35);
   y:=y-1;
  end;
  if s<>'' then
  begin
   WriteXY(x,y,S,P);
   x:=x+length(s);
   Delete(Text,1,length(s));
  end;
  if Text[1]=' ' then
  begin
   x:=x+1;
   if x>58 then
   begin
    x:=24;
    y:=y+1;
    while Text[2]=' ' do Delete(Text,2,1);
   end;
  end else
   if Text[1]=#13 then
   begin
    Y:=y+1;
    x:=24;
   end;
  Delete(Text,1,1);
 end;
 WriteXY(29,15,'Bitte eine Taste drcken',P);
 if Readkey=#0 then readkey;
 Defreeze(Screen);
 SetCursor;
end;

function AskBox(Color,Color2:Integer;Titel,Text,Anw:String):Char;
{Generiert ein Fenster mit der berschrift Titel in der Farbe Color.
 Ausgegeben wird der String Text. Der Anwender soll hier allerdings
 aktiv whlen, was er mchte: 'Ja', 'Nein' oder 'Abbruch'.
 Welche der 3 Antworten vorgegeben sein sollen, ist in Anw gespeichert,
 und zwar jeweils der Anfangsbuchstabe der mglichen Antwort.
 In Color2 ist nun die Farbe fr die zu drckenden Tasten gespeichert.
 Die Funktion gibt die gewhlte Antwort als Zeichen zurck.}
Var P:PBildschirm;
    Screen:Bildschirm;
    x,y,i:Integer;
    s:String;
    Ch:Char;
    c:Word;
Begin
 P:=LocalScreen;
 Up(Anw);
 GetCursor;HideCursor;
 Freeze(Screen);
 MakeBox(21,61,9,17,Color,doppelt,Titel,P);
 y:=11;
 x:=24;
 i:=1;
 while Text<>'' do  {Nun Text in das Fenster, wie bei MsgBox}
 begin
  if Pos(' ',Text)=0 then s:=Text
                     else s:=Copy(Text,1,Pos(' ',Text)-1);
  if Pos(#13,S)<>0 then s:=Copy(s,1,Pos(#13,S)-1);
  if length(s)+x>58 then
  begin
   x:=24;y:=y+1;
  end;
  if length(s)>35 then
  begin
   s:=Copy(s,1,35);
   Insert(' ',Text,35);
   y:=y-1;
  end;
  if s<>'' then
  begin
   WriteXY(x,y,S,P);
   x:=x+length(s);
   Delete(Text,1,length(s));
  end;
  if Text[1]=' ' then
  begin
   x:=x+1;
   if x>58 then
   begin
    x:=24;
    y:=y+1;
    while Text[2]=' ' do Delete(Text,2,1);
   end;
  end else
   if Text[1]=#13 then
   begin
    Y:=y+1;
    x:=24;
   end;
  Delete(Text,1,1);
 end;
 i:=29;
 if Pos('J',Anw)<>0 then       {'Ja' als Antwort vorgesehen}
 begin
  WriteXY(i,15,'Ja    ',P);
  p^[15,i].Attr:=Color2;
  i:=i+6;
 end;
 if Pos('N',Anw)<>0 then      {'Nein' als Antwort vorgesehen}
 begin
  WriteXY(i,15,'Nein    ',P);
  p^[15,i].Attr:=Color2;
  i:=i+8;
 end;
 if Pos('A',Anw)<>0 then     {'Abbruch' als Antwort vorgesehen}
 begin
  WriteXY(i,15,'Abbruch',P);
  p^[15,i].Attr:=Color2;
 end;
 Anw:=Anw+#27;      {ESC-Taste immer erlaubt, entspricht Abbruch}
 repeat
  Ch:=UpCase(Getkey(c));
  Case c of
  kbAltA : Ch:='A';
  kbAltN : Ch:='N';
  kbAltJ : Ch:='J';
  end;
 until Pos(Ch,Anw)<>0;
 if Ch=#27 then Ch:='A';
 AskBox:=Ch;    {gewhlte Antwort zurck}
 Defreeze(Screen);
 SetCursor;
end;

procedure Check;
{Liegt hier ein normaler Rechner (Farbgrafik) oder eine Antiquitt vor.}
Var Regs:Registers;
begin
 Intr($11,Regs);
 If (Regs.ax and $30)=$30 then
 begin
  Writeln('Das Programm bentigt einen Farbmonitor');
  {Bem.: Wer heute keinen Farbmonitor hat ist es selber schuld.}
  Halt;
 end;
end;


begin
 Check;
end.

