{
  Diese Unit enthlt eine Reihe von Werkzeugen, die berall benutzt
  werden knnen:

  1. function GetKey(Var c:Word):Char;

     Wartet auf einen Tastendruck und liefert sowohl ein Zeichen (der
     Funktion) als auch ein Word-Parameter c zurck. Warum so kompliziert?
     Damit auch das Eingeben einer Sondertaste (z.B. Funktionstaste)
     verarbeitet werden kann. Dann wird als Zeichen einfach #0 zurckgeben,
     und in c ist als HiByte der wahre Tastendruck enthalten, wobei das
     LoByte 0 ist. Bei einer normalen Taste ist es gerade umgekehrt.

 2. function EditLine(x1,y1,l:Integer;Var Starter:Word;Var Edit:String;
                      MaxLen:Integer;Var Auto:Boolean;Marked:Boolean;
                      Ni,Ho:Menge;P:PBildschirm):Word;

    Da beim Einlesen eines Strings durch die Standardroutine read(ln)
    der Editierkomfort doch arg eingeschrnkt ist, gibt es von nun an
    einen komfortablen Zeileneditor.
    x1,y1 sind die Koordinaten vom Zeilenanfang.
    l ist die Lnge, die zum Editieren zur Verfgung steht.
    Starter gibt an, an welcher Position der Cursor zu plazieren ist und
    das Editieren beginnt.
    Ed beinhaltet den zu editierenden String, dieser wird auch zurck
    gegeben.
    Maxlen ist die maximale Lnge, die fr den String zur Verfgung
    steht.
    Der Boolean Auto gibt an, ob im Einfgemodus oder berschreibmodus
    editiert wird.
    Der Boolean Marked gibt an, ob markiert editiert werden soll.
    Ni,Ho sind Mengen und beinhalten, bei welchen Zeichen das Editieren
    beendet sein soll. Damit auch Sonderzeichen mglich sind, ist die
    Unterteilung in Ni(ederwertiges Byte) und Ho(chwertiges Byte) ntig,
    da Pascal ja keine Word-Menge kennt. Das Zeichen, durch das der Editor
    verlassen wird, wird ebenfalls zurckgegeben.
    P ist der Bildschirm, wo alles stattfindet.

 3. function Up(Text:String):String;

    Wandelt einen String in Grobuchstaben um und gibt diesen zurck.

 4. procedure DosShell(Text:String);

    Startet ein DOS-Shell, dabei wird der String Text als Hinweis
    ausgegeben.

 5. function repeate(Num:Byte ; Ch:Char):AnyString;

    Gibt einen String zurck, der aus Num-mal das Zeichen Ch
    enthlt.

 6. function space(Num:Byte):AnyString;

    Gibt einen String der Lnge Num zurck, der nur aus Leerzeichen
    besteht.

 7. function Left(Str:AnyString;Num:Byte):AnyString;

    Gibt einen String zurck, der die ersten Num Zeichen
    aus dem String Str enthlt.

 8. function Right(Str:AnyString;Num:Byte):AnyString;

    Gibt die letzten Num-Zeichen des Strings Str zurck.

 9. function ExistDatei(DateiName:PathStr):Boolean;

    berprft, ob eine Datei existiert. Der Name der zu prfenden
    Datei ist in DateiName gespeichert.

 10.function CheckPath(Path:String):Boolean;

    berprft, ob der in Path gespeicherte Pfad tatschlich existiert.

 11.function NurName(DateiName:PathStr):NameStr;

    In DateiName ist ein kompletter Dateiname (inkl. Pfadangabe) gespeichert.
    Zurckgegeben wird dann nur der Dateiname (ohne Endung).

 12.function NurPfad(DateiName:PathStr):DirStr;

    Aus DateiName wird der Pfad herausgefiltert und zurckgegeben.

 13.function NurExt(DateiName:PathStr):ExtStr;

    Diese Funktion gibt die Endung eines Dateinamens zurck.

 14.procedure RealGetDir(Drv:Byte;Var Path:PathStr);

    Liefert den aktuellen Pfad des Laufwerkes Drv zurck. Dieser
    endet aber in jedem Fall mit einem '\'.


}
{$V-}
Unit Toolbox;

interface
Uses Screens,Crt,Dos;
type  Menge = Set of Byte;
      AnyString=String[255];

Const Print = [' '..'~',''..''];

 function GetKey(Var c:Word):Char;
 function EditLine(x1,y1,l:Integer;Var Starter:Word;Var Edit:String;
                   MaxLen:Integer;Var Auto:Boolean;Marked:Boolean;
                   Ni,Ho:Menge;P:PBildschirm):Word;
 function Up(Text:String):String;
 procedure DosShell(Text:String);
 function repeate(Num:Byte ; Ch:Char):AnyString;
 function space(Num:Byte):AnyString;
 function Left(Str:AnyString;Num:Byte):AnyString;
 function Right(Str:AnyString;Num:Byte):AnyString;
 function ExistDatei(DateiName:PathStr):Boolean;
 function CheckPath(Path:String):Boolean;
 function NurName(DateiName:PathStr):NameStr;
 function NurPfad(DateiName:PathStr):DirStr;
 function NurExt(DateiName:PathStr):ExtStr;
 procedure RealGetDir(Drv:Byte;Var Path:PathStr);



Implementation
Uses Cursors,Consts,Memory;

function GetKey(Var c:Word):Char;
{Wartet auf einen Tastendruck und liefert sowohl ein Zeichen (der
 Funktion) als auch ein Word-Parameter c zurck. Warum so kompliziert?
 Damit auch das Eingeben einer Sondertaste (z.B. Funktionstaste)
 verarbeitet werden kann. Dann wird als Zeichen einfach #0 zurckgeben,
 und in c ist als HiByte der wahre Tastendruck enthalten, wobei das
 LoByte 0 ist. Bei einer normalen Taste ist es gerade umgekehrt.}
Var Ch:Char;
begin
  Ch:=Readkey;
  if Ch=#0 then
  begin
   Ch:=Readkey;
   c:=ord(Ch)*256;
   Ch:=#0;
  end
  else
   c:=ord(Ch);
  Getkey:=Ch;
end;

function EditLine(x1,y1,l:Integer;Var Starter:Word;Var Edit:String;
                  MaxLen: Integer;Var Auto:Boolean;Marked:Boolean;
                  Ni,Ho:Menge;P:PBildschirm):Word;
{Da beim Einlesen eines Strings durch die Standardroutine read(ln)
 der Editierkomfort doch arg eingeschrnkt ist, gibt es von nun an
 einen komfortablen Zeileneditor.
 x1,y1 sind die Koordinaten vom Zeilenanfang.
 l ist die Lnge, die zum Editieren zur Verfgung steht.
 Starter gibt an, an welcher Position der Cursor zu plazieren ist und
 das Editieren beginnt.
 Ed beinhaltet den zu editierenden String, dieser wird auch zurck
 gegeben.
 MaxLen ist die maximale Lnge, die fr den String zur Verfgung
 steht.
 Der Boolean Auto gibt an, ob im Einfgemodus oder berschreibmodus
 editiert wird.
 Der Boolean Marked gibt an, ob markiert editiert werden soll.
 Ni,Ho sind Mengen und beinhalten, bei welchen Zeichen das Editieren
 beendet sein soll. Damit auch Sonderzeichen mglich sind, ist die
 Unterteilung in Ni(ederwertiges Byte) und Ho(chwertiges Byte) ntig,
 da Pascal ja keine Word-Menge kennt. Das Zeichen, durch das der Editor
 verlassen wird, wird ebenfalls zurckgegeben.
 P ist der Bildschirm, wo alles stattfindet.
}
Var c:Word;
    Ch:Char;
    Ende,WasMarked:Boolean;
    x,Max,MaxL,i,s,e:Integer;

    procedure Schreibe;
    {Schreibt den bisher editierten String an die dafr vorgesehene
     Stelle.}
    Var i:integer;
    begin
     {Beachte: Es steht vielleicht nicht die ganze Lnge des Strings
      zum Editieren zur Verfgung. Dennoch soll der String bis zur maximalen
      Lnge editiert werden knnen. Daher mu der String evtl. gerollt
      werden. Der bersichtlichkeit ist dies durch entsprechende Pfeile
      dargestellt}
     if s>1 then p^[y1,x1-1].Zeichen:=''
            else p^[y1,x1-1].Zeichen:=' ';
     WriteXY(x1,y1,Copy(Edit,s,e-s+1),P);
     for i:=x1+e-s+1 to MaxL Do p^[y1,i].Zeichen:=' ';
     if e<length(Edit) then p^[y1,MaxL+1].Zeichen:=''
                       else p^[y1,MaxL+1].Zeichen:=' ';
    end;

    procedure DeMark;
    {Markierung aufheben}
    begin
     Marked:=False;
     WriteXYColor(x1,y1,$17,Copy(Edit,s,e),P);
    end;

begin
 MaxL:=x1+l-1;
 WasMarked:=Marked;
 if Marked then  {markiertes Editieren, also markieren}
 begin
  i:=$02;
  s:=1;
  e:=length(Edit);
  if e>l then
  begin
   e:=l;
  end;
  WriteXYColor(x1,y1,i,Copy(Edit,s,e-s+1),P);
  if e<length(Edit) then p^[y1,MaxL+1].Zeichen:='';
  p^[y1,x1-1].Zeichen:=' ';
  x:=x1;
 end else
 begin       {normales Editieren: bringe u.a. Cursor an Starter-Position}
  i:=$17;
  x:=x1+lo(Starter)-1;
  s:=Hi(Starter);
  if s>length(Edit) then s:=length(Edit);
  if s<1 then s:=1;
  e:=s+l-1;
  if e>length(Edit) then e:=length(Edit);
  if length(Edit) <= l then
  begin
   s:=1;
   e:=length(Edit);
  end;
  Schreibe;
 end;
 Max:=x1+length(Copy(Edit,s,e-s+1));
 if x>Max then x:=Max;
 GotoXY(x,y1);
 Ende:=False;
 if Auto then LineCursor
         else BlockCursor;
 repeat
  Ch:=Getkey(c);
  if Marked then
  begin
   if Ch in Print then
   begin
    {Nun mu ein neues Wort generiert werden}
    DeMark;
    Edit:='';
    s:=1;
    e:=0;
    for i:=x1 to Max do p^[y1,i].Zeichen:=' ';
    Max:=x1;
   end else
   begin
    if (c=kbDel) or (c=kbBack) then c:=Ord(^Y);   {Lsche ganzen String}
    if ((c<=255) and (c in Ni+[20,25,8])) or
       ((c>255) and (Hi(c) in Ho+[$52,$4B,$4D,$47,$4F,$53])) then
     {Markierung aufheben, z.B. durch Cursorbewegungen}
    begin
     DeMark;
    end;
   end;
  end;
  if ((c<=255) and (c in Ni)) or      {Ende des Editierens wurde veranlat.}
     ((c>255) and (Hi(c) in Ho)) then
   Ende:=True
  else
  begin
   Case c of
    kbIns : begin                   {ndere berschreibe-/Einfgemodus}
             Auto:=not(Auto);
             if Auto then LineCursor
                     else BlockCursor;
            end;
    kbLeft : begin                 {Cursor nach links}
              x:=x-1;
              if x<x1 then   {nach links gerollt}
              begin
               x:=x1;
               s:=s-1;
               if s<1 then s:=1
                      else
                      begin
                       if e-s+1>l then e:=e-1
                                  else Max:=Max+1;
                       Schreibe;
                      end;
              end
              else
              begin
               gotoxy(x,y1);
              end;
             end;
    kbRight: begin          {Cursor nach rechts}
              x:=x+1;
              if x>Max then  {nach rechts gerollt}
              begin
               x:=Max;
               e:=e+1;
               if e>length(Edit) then e:=length(edit)
                                 else
                                  begin
                                   s:=s+1;
                                   Schreibe;
                                  end;
              end
              else
              begin
               gotoxy(x,y1);
              end;
             end;
    kbHome : begin      {An den Anfang}
              x:=x1;
              s:=1;
              e:=l;
              if e>length(Edit) then e:=length(Edit);
              Max:=x1+length(Copy(Edit,s,e));

              Schreibe;
              Gotoxy(x,y1);
             end;
    kbEnd  : begin       {Ans Ende}
              if e=length(Edit) then
              begin
               x:=Max;
               e:=length(Edit);
              end else
              begin
               x:=Max;
               e:=length(Edit);
               s:=e-l+1;
               if s<1 then s:=1;
              end;
              Schreibe;
              GotoXY(x,y1);
             end;
    kbDel  : begin     {Lsche Zeichen unter Cursor}
              if (length(Edit)>=1) and (x-x1+s<=length(Edit)) then
              begin
               if (e=length(Edit)) and (x-x1+s<=e) then Max:=Max-1;
               if e>=Length(Edit) then e:=e-1;
               Delete(Edit,x-x1+s,1);
               Schreibe;
              end;
             end;
    kbBack : begin     {Lsche Zeichen links vom Cursor}
              if x>x1 then
              begin
               Delete(Edit,x-x1+s-1,1);
               if e>length(Edit) then e:=length(Edit);
               if s>1 then
                s:=s-1
               else
               begin
                x:=x-1;
                if e=length(Edit) then Max:=Max-1;
               end;
               gotoxy(x,y1);
               Schreibe;
              end;
             end;
    20     : begin              {Lsche alles rechts vom Cursor}
    {^T}      Max:=x;
              Delete(Edit,x-x1+s,255);
              e:=length(Edit);
              Schreibe;
             end;
    25     : begin              {Lsche gesamte Zeile}
    {^Y}      Edit:='';
              Max:=x1;
              x:=x1;
              s:=1;
              e:=0;
              for i:=x1-1 to MaxL+1 do p^[y1,i].Zeichen:=' ';
              GotoXY(x,y1);
             end;
    else begin
          if Ch in Print then   {wirkliches Zeichen eingegeben}
          begin
           if Auto then   {einfgen}
           begin
            if length(Edit)<MaxLen then
            begin
             Insert(Ch,Edit,x-x1+s);
             e:=e+1;
             if length(Edit)<=l then
             begin
              Max:=Max+1;
              x:=x+1;
             end
             else
             begin
              if x<=MaxL then
              begin
               if e<=length(Edit) then
               begin
                e:=e-1;
               end else
                Max:=Max+1;
               x:=x+1;
              end
              else
               s:=s+1;
             end;
             gotoXY(x,y1);
             Schreibe;
            end;
           end
           else    {berschreiben}
           begin
            if (x-x1+s<=length(Edit)) then
             Edit[x-x1+s]:=Ch
            else
             if length(Edit)<MaxLen then
             begin
              Edit:=Edit+Ch;
              e:=e+1;
             end;
            if length(Edit)<=l then
            begin
             Max:=Max+1;
             x:=x+1;
            end else
            begin
             if (length(Edit)<MaxLen) or (x-x1+s<=length(Edit)) then
             begin
              if x<=MaxL then
              begin
               x:=x+1;
              end
              else
              begin
               s:=s+1;
               e:=e+1;
              end;
             end;
            end;
            gotoXY(x,y1);
            Schreibe;
           end;
          end;
         end;
   end;
  end;
 until Ende;
 EditLine:=c;
 Starter:=x-x1+1+256*s;
end;

function ExistDatei(DateiName:PathStr):Boolean;
{berprft, ob eine Datei existiert. Der Name der zu prfenden
 Datei wird in DateiName bergeben.}
Var f:File;
    Dummy:Boolean;
begin
 assign(f,DateiName);
 {$I-}
 reset(f);
 Dummy:=(IOResult = 0);
 {$I+}
 if Dummy then close(f);
 ExistDatei:=Dummy;
end;

function CheckPath(Path:String):Boolean;
{berprft, ob der in Path gespeicherte Pfad tatschlich existiert.}
Var Dummy:SearchRec;
begin
 if length(Path)>3 then Path:=Path+'\';
 Path:=Path+'*.*';
 {Nun ist Path z.B. von der Form c:\Pfad\*.*.}
 FindFirst(Path,AnyFile,Dummy);
 CheckPath:=DosError<>3;
end;

function Up(Text:String):String;
{Wandelt einen String in Grobuchstaben um und gibt diesen zurck.}
Var tmp:String;
    i:Integer;
begin
 tmp:='';
 for i:=1 to length(Text) do tmp:=tmp+upcase(Text[i]);
 Up:=tmp;
end;

procedure DosShell(Text:String);
{Startet ein DOS-Shell, dabei wird der String Text als Hinweis
 ausgegeben.}
Var Screen:Bildschirm;
begin
 if Text='' then Text:='Mit EXIT zurck zum Programm...';
 Freeze(Screen);
 TextColor(7);
 TextBackground(0);
 ClrScr;
 LineCursor;
 SwapVectors;
 Write(Text);
 {$IFNDEF DPMI}
  SetMemTop(HeapPtr);
 {$ENDIF}
 Exec(GetEnv('COMSPEC'),'');
 {$IFNDEF DPMI}
   SetMemTop(HeapEnd);
  {$ENDIF}
 SwapVectors;
 Defreeze(Screen);
 HideCursor;
end;


function repeate(Num:Byte ; Ch:Char):AnyString;
{Gibt einen String zurck, der aus Num-mal das Zeichen Ch enthlt.}
Var z:Byte;
    Help:String[255];
begin
 Help:=Ch;
 while Length(Help)<Num do
 begin
  Help:=Help+Help+Help;
 End;
 repeate:=copy(Help,1,Num);
end;

function space(Num:Byte):AnyString;
{Gibt einen String der Lnge Num zurck, der nur aus Leerzeichen besteht.}
begin
 space:=repeate(Num,' ');
end;

function Left(Str:AnyString;Num:Byte):AnyString;
{Gibt einen String zurck, der die ersten Num Zeichen aus dem String Str
 enthlt.}
begin
 Left:=Copy(Str,1,Num);
end;

function Right(Str:AnyString;Num:Byte):AnyString;
{Gibt die letzten Num-Zeichen des Strings Str zurck.}
Var Tmp:Byte;
begin
 Tmp:=Length(Str);
 Right:=Copy(Str,tmp-Num+1,tmp);
end;

function NurName(DateiName:PathStr):NameStr;
{In DateiName ist ein kompletter Dateiname (inkl. Pfadangabe) gespeichert.
 Zurckgegeben wird dann nur der Dateiname (ohne Endung).}
Var
  Name:NameStr;
  Dir:DirStr;
  Ext:ExtStr;
begin
 FSplit(DateiName,Dir,Name,Ext);
 NurName:=Name;
end;

function NurPfad(DateiName:PathStr):DirStr;
{Aus DateiName wird der Pfad herausgefiltert und zurckgegeben.}
Var
  Name:NameStr;
  Dir:DirStr;
  Ext:ExtStr;
begin
 FSplit(DateiName,Dir,Name,Ext);
 NurPfad:=Dir;
end;

function NurExt(DateiName:PathStr):ExtStr;
{Diese Funktion gibt die Endung eines Dateinamens zurck.}
Var
  Name:NameStr;
  Dir:DirStr;
  Ext:ExtStr;
begin
 FSplit(DateiName,Dir,Name,Ext);
 NurExt:=Ext;
end;

procedure RealGetDir(Drv:Byte;Var Path:PathStr);
{Liefert den aktuellen Pfad des Laufwerkes Drv zurck. Dieser
 endet aber in jedem Fall mit einem '\'.}
begin
 GetDir(Drv,Path);
 if Length(Path)>3 then Path:=Path+'\';
end;

end.